DELIMITER //

USE `mrs`;

DROP PROCEDURE IF EXISTS mig2POEM_metst_c_l_h_d;

create PROCEDURE mig2POEM_metst_c_l_h_d (num_records INT)
BEGIN
  DECLARE counter INT;
  DECLARE v_id INT;
  DECLARE v_profile_id INT;
  DECLARE v_poem_prof_id INT;
  DECLARE done INT DEFAULT 0;

  DECLARE tuple CURSOR FOR
    select a.id, a.profile_id, c.id as poem_prof_id
        from metricstore_curr_load_h_det a, profile b, poem_sync_profile c
        where a.profile_id=b.id AND b.name=c.name and a.poem_sync_profile_id IS NULL;


  DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;

  set autocommit = 0;

  OPEN tuple;
  set counter = 0;

  REPEAT
    set done = 0;
    FETCH tuple INTO v_id, v_profile_id, v_poem_prof_id;

    IF NOT done THEN
      UPDATE metricstore_curr_load_h_det set poem_sync_profile_id = v_poem_prof_id where id=v_id;
      set counter = counter + 1;
      IF counter = num_records THEN
        commit;
        set counter = 0;
      END IF;
      set done = 0;
    END IF;
  UNTIL done END REPEAT;

  CLOSE tuple;

  commit;


END //

DELIMITER ;