DELIMITER //

USE `mrs`;

DROP PROCEDURE IF EXISTS mig2POEM_sc_metric_service;

create PROCEDURE mig2POEM_sc_metric_service (num_records INT)
BEGIN
  DECLARE counter INT;
  DECLARE v_id INT;
  DECLARE v_metric_id INT;
  DECLARE v_poem_metric_id INT;
  DECLARE done INT DEFAULT 0;

  DECLARE tuple CURSOR FOR
    select a.id, a.metric_id, c.id as poem_metric_id
        from statuschange_metric_service a, metric b, poem_sync_metric c
        where a.metric_id=b.id AND b.name=c.name and a.poem_sync_metric_id IS NULL;


  DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;

  set autocommit = 0;

  OPEN tuple;
  set counter = 0;

  REPEAT
    set done = 0;
    FETCH tuple INTO v_id, v_metric_id, v_poem_metric_id;

    IF NOT done THEN
      UPDATE statuschange_metric_service set poem_sync_metric_id = v_poem_metric_id where id=v_id;
      set counter = counter + 1;
      IF counter = num_records THEN
        commit;
        set counter = 0;
      END IF;
      set done = 0;
    END IF;
  UNTIL done END REPEAT;

  CLOSE tuple;

  commit;


END //

DELIMITER ;