create or replace
PROCEDURE MIG2POEM_METRICDATA_DATE (num_records IN NUMBER, begin_date IN VARCHAR, end_date IN VARCHAR) AS 
  counter NUMBER;
BEGIN
  counter := 0;
  
  BEGIN
    FOR tuple IN
      (select md.id, md.metric_id, p.id as poem_id 
        from metricdata md, metric m, poem_sync_metric p
        where md.metric_id=m.id and m.name=p.name and md.poem_sync_metric_id IS NULL
          and md.insert_time >= w3ctime_to_uts(begin_date) and md.insert_time < w3ctime_to_uts(end_date))
      LOOP
        BEGIN
          logstatus('mig2POEM_metricdata_date', 'DEBUG', 'Before update poem_sync_metric_id');
          UPDATE metricdata set poem_sync_metric_id = tuple.poem_id where id=tuple.id;
          logstatus('mig2POEM_metricdata_date', 'DEBUG', 'After update poem_sync_metric_id');
          counter := counter + 1;
          IF counter=num_records THEN
            commit;
            logstatus('mig2POEM_metricdata_date', 'DEBUG', 'After commit of ' || counter || ' records.');
            counter := 0;
          END IF;
        END;
      END LOOP;
      commit;
      logstatus('mig2POEM_metricdata_date', 'DEBUG', 'After commit of ' || counter || ' records.');
  END;
END MIG2POEM_METRICDATA_DATE;
/