create or replace
PROCEDURE delete_obsolete_metrics (num_records IN NUMBER) AS 
  counter NUMBER;
BEGIN
  counter := 0;
  BEGIN
    FOR tuple IN
      (select id from metricdata where metric_id in (
         select id from metric where name in (
           'org.sam.WN-CAver',
           'hr.srce.SRM1-CertLifetime',
           'org.gstat.CE',
           'org.gstat.SE',
           'org.gstat.Site',
           'org.nagios.LocalLogger-PortCheck',
           'org.nmap.CREAM-CE',
           'org.nmap.Central-LFC',
           'org.nmap.Classic-SE',
           'org.nmap.GRAM',
           'org.nmap.LB',
           'org.nmap.Local-LFC',
           'org.nmap.MyProxy',
           'org.nmap.SRM',
           'org.nmap.SRM1',
           'org.nmap.Site-BDII',
           'org.nmap.Top-BDII',
           'org.nmap.WMProxy',
           'org.nmap.WMS')))
      LOOP
        BEGIN
          logstatus('delete_obsolete_metrics', 'DEBUG', 'Before deleting of row');
          delete from metricdata where id = tuple.id;
          counter := counter + 1;
          IF counter=num_records THEN
            commit;
            logstatus('delete_obsolete_metrics', 'DEBUG', 'After commit of ' || counter || ' records.');
            counter := 0;
          END IF;
        END;
      END LOOP;
      commit;
      logstatus('delete_obsolete_metrics', 'DEBUG', 'After commit of ' || counter || ' records.');
  END;
END delete_obsolete_metrics;
/
