CREATE OR REPLACE PROCEDURE MIG2POEM_METRICDATA_SPOOL_REJ(num_records IN NUMBER) AS 
  counter NUMBER;
BEGIN
  counter := 0;
  BEGIN    
    FOR tuple IN
      (select md.id, md.metric_id, p.id as poem_id 
        from metricdata_spool_rejected md, metric m, poem_sync_metric p
        where md.metric_id=m.id and m.name=p.name and md.poem_sync_metric_id IS NULL)
      LOOP
        BEGIN
          --logger('mig2POEM_metricdata_spool_rej', 'DEBUG', 'Before update poem_sync_metric_id');
          UPDATE metricdata_spool_rejected set poem_sync_metric_id = tuple.poem_id where id=tuple.id;
          --logger('mig2POEM_metricdata_spool_rej', 'DEBUG', 'After update poem_sync_metric_id');
          counter := counter + 1;
          IF counter=num_records THEN
            commit;
            --logger('mig2POEM_metricdata_spool_rej', 'DEBUG', 'After commit of ' || counter || ' records.');
            counter := 0;
          END IF;
        END;
      END LOOP;
      commit;
      --logger('mig2POEM_metricdata_spool_rej', 'DEBUG', 'After commit of ' || counter || ' records.');
  END;
END MIG2POEM_METRICDATA_SPOOL_REJ;
/