DELIMITER //

USE `metricstore`;

DROP TRIGGER IF EXISTS load_metricdata_fer;

create trigger load_metricdata_fer

after insert on  metricdata_latest for each row

BEGIN

  DECLARE old_metricstatus_id INTEGER; 
  DECLARE old_timestamp INTEGER; 
  DECLARE num_row INTEGER;
  DECLARE curr_servicestatus_id INTEGER;

  insert into metricdata(metricstatus_id, metricdetail_id, metric_id, service_id, vo_id, summarydata, check_time, insert_time)
    	VALUES (NEW.metricstatus_id, NEW.metricdetail_id, NEW.metric_id, NEW.service_id, NEW.vo_id, NEW.summarydata, NEW.check_time, NEW.insert_time);


  call calculateStatusChange(NEW.service_id, NEW.metric_id, NEW.metricstatus_id, NEW.id, NEW.check_time, NEW.vo_id);

  /*Code below will disappear soon - No need to look at it. it loads data to: statuschange_service, which will be dropped soon*/ 


  SET num_row = 0;

  select count(*) INTO num_row
  from statuschange_service 
  where service_id = NEW.service_id;

  IF num_row > 0 THEN

    SELECT metricstatus_id, timestamp INTO old_metricstatus_id, old_timestamp
    FROM statuschange_service 
    WHERE service_id = NEW.service_id AND timestamp =
      (SELECT max(timestamp) FROM statuschange_service
      WHERE service_id = NEW.service_id and timestamp <= NEW.check_time);

    IF (NEW.metricstatus_id < old_metricstatus_id) THEN
        SELECT max(metricstatus_id) INTO curr_servicestatus_id
            FROM metricdata_latest
            WHERE service_id = NEW.service_id;
    END IF;


    IF (NEW.metricstatus_id > old_metricstatus_id) THEN
      IF old_timestamp != NEW.check_time THEN
        INSERT INTO statuschange_service(service_id, metricstatus_id, detail, timestamp)
        VALUES(NEW.service_id, new.metricstatus_id, concat('Status changed by metricdata(1): ', '', NEW.id, ''), NEW.check_time);
      ELSE
         UPDATE statuschange_service SET metricstatus_id = new.metricstatus_id, detail = concat('Status changed by metricdata(2): ', '', NEW.id, '') WHERE service_id = NEW.service_id and timestamp = NEW.check_time;
      END IF;
    ELSEIF ((NEW.metricstatus_id < old_metricstatus_id) AND (curr_servicestatus_id < old_metricstatus_id)) THEN

      IF old_timestamp != NEW.check_time THEN
        INSERT INTO statuschange_service(service_id, metricstatus_id, detail, timestamp)
        VALUES(NEW.service_id, curr_servicestatus_id, concat('Status changed by metricdata(3): ', '', NEW.id, ''), NEW.check_time);
      ELSE
         UPDATE statuschange_service SET metricstatus_id = curr_servicestatus_id, detail = concat('Status changed by metricdata(4): ', '', NEW.id, '') WHERE service_id = NEW.service_id and timestamp = NEW.check_time;
      END IF;

    END IF;

  ELSE 
    INSERT INTO statuschange_service(service_id, metricstatus_id, detail, timestamp)
    VALUES(NEW.service_id, NEW.metricstatus_id, concat('Status changed by metricdata  : ', '', NEW.id, ''), NEW.check_time); 
  END IF;

END //

DELIMITER ;
