
/* BEGIN: Temporary hack to make msg-consume2oracle working */

CREATE OR REPLACE TRIGGER V_MOUT_INSERT_TRG instead of insert on V_METRICOUTPUT

BEGIN
  dataloader.loadmetricdata(:NEW.serviceflavour, :NEW.metricname, :NEW.metricstatus,
       :NEW.summarydata, :NEW.detailsdata, :NEW.voname, :NEW.hostname, :NEW.timestamp, :NEW.serviceURI);

END;
/

/* END: Temporary hack to make msg-consume2oracle working */

create or replace trigger load_metricdata
  before insert on metricdata_latest for each row

DECLARE

BEGIN
  
  delete from metricdata_latest_tmp;
  
  insert into metricdata_latest_tmp select * from metricdata_latest WHERE service_id = :NEW.service_id;
  
/*
SELECT *
    BULK COLLECT INTO state_pkg.l_metric_data_latest_table
    FROM metricdata_latest;
    
execute immediate 'SELECT *
    FROM TABLE( CAST( state_pkg.l_metric_data_latest_table AS metric_data_latest_table_type2));';
*/          

END;
/

create or replace trigger load_metricdata_fer
  after insert on metricdata_latest for each row

DECLARE
  --pragma autonomous_transaction;
  old_metricstatus_id INTEGER; 
  old_timestamp INTEGER; 
  num_row INTEGER;
  curr_servicestatus_id INTEGER;
  --CURSOR flavourCurs IS select count(1) from metricdata_latest_tmp;
  --v_curs InTEGER;
  
BEGIN
  /*open flavourcurs;
    FETCH flavourcurs INTO v_curs;  
    dbms_output.put_line(v_curs);
  close flavourcurs;
  */

  insert into metricdata(id, metricstatus_id, metricdetail_id, metric_id, service_id, vo_id, summarydata, check_time, insert_time)
    	VALUES (MetricDataSeq.nextval, :NEW.metricstatus_id, :NEW.metricdetail_id, :NEW.metric_id, :NEW.service_id, :NEW.vo_id, :NEW.summarydata, :NEW.check_time, :NEW.insert_time);


  DataLoader.calculateStatusChange(:NEW.service_id, :NEW.metric_id, :NEW.metricstatus_id, :NEW.id, :NEW.check_time, :NEW.vo_id);
  

  /*Code below will disappear soon - No need to look at it. it loads data to: statuschange_service, which will be dropped soon*/ 
 
  num_row := 0;

  select count(*) INTO num_row
  from statuschange_service 
  where service_id = :NEW.service_id;

  IF num_row > 0 THEN

    SELECT metricstatus_id, timestamp INTO old_metricstatus_id, old_timestamp
    FROM statuschange_service 
    WHERE service_id = :NEW.service_id AND timestamp =
      (SELECT max(timestamp) FROM statuschange_service
      WHERE service_id = :NEW.service_id and timestamp <= :NEW.check_time);

    IF (:NEW.metricstatus_id < old_metricstatus_id) THEN
        SELECT max(metricstatus_id) INTO curr_servicestatus_id
            FROM metricdata_latest_tmp
            WHERE service_id = :NEW.service_id;

    END IF;

    IF (:NEW.metricstatus_id > old_metricstatus_id) THEN
      IF old_timestamp != :NEW.check_time THEN
        INSERT INTO statuschange_service(id, service_id, metricstatus_id, detail, timestamp)
        VALUES(StatusChange_ServiceSeq.nextval, :NEW.service_id, :NEW.metricstatus_id, 'Status changed by metricdata(1): ' || :NEW.id, :NEW.check_time);
      ELSE
         UPDATE statuschange_service SET metricstatus_id = :NEW.metricstatus_id, detail = 'Status changed by metricdata(2): ' || :NEW.id WHERE service_id = :NEW.service_id and timestamp = :NEW.check_time;
      END IF;
    ELSIF ((:NEW.metricstatus_id < old_metricstatus_id) AND (curr_servicestatus_id < old_metricstatus_id)) THEN

      IF old_timestamp != :NEW.check_time THEN
        INSERT INTO statuschange_service(id, service_id, metricstatus_id, detail, timestamp)
        VALUES(StatusChange_ServiceSeq.nextval, :NEW.service_id, curr_servicestatus_id, 'Status changed by metricdata(3): ' || :NEW.id, :NEW.check_time);
      ELSE
         UPDATE statuschange_service SET metricstatus_id = curr_servicestatus_id, detail = 'Status changed by metricdata(4): ' || :NEW.id WHERE service_id = :NEW.service_id and timestamp = :NEW.check_time;
      END IF;

    END IF;

  ELSE 
    INSERT INTO statuschange_service(id, service_id, metricstatus_id, detail, timestamp)
    VALUES(StatusChange_ServiceSeq.nextval, :NEW.service_id, :NEW.metricstatus_id, 'Status changed by metricdata  : ' || :NEW.id, :NEW.check_time); 
  END IF;
  
  
END;
/
