CREATE TABLE Logger (
  id INT NOT NULL,
  inserttime timestamp default sysdate NOT NULL,
  proc_name VARCHAR2(256),
  severity VARCHAR2(50),
  message VARCHAR2(1024)
);

CREATE SEQUENCE logger_seq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE TABLE gatheredat
(
  id INT NOT NULL,
  name VARCHAR2(256),
  PRIMARY KEY (id)
);


CREATE SEQUENCE gatheredat_seq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;


CREATE TABLE fqan (
  id INT NOT NULL,
  name VARCHAR(256) NOT NULL,
  PRIMARY KEY (id),
  CONSTRAINT uk_fqan UNIQUE (name)
);


CREATE SEQUENCE fqan_seq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;


CREATE TABLE metricstatus (
  id INT NOT NULL ,
  weight INT NOT NULL,
  description VARCHAR(45) NULL ,
  description_nagios VARCHAR(45) NULL ,
  comments VARCHAR(45) NULL ,
  PRIMARY KEY (id),
  CONSTRAINT uk_metricstatus UNIQUE (description),
  CONSTRAINT uk_metricstatus_weight UNIQUE (weight)
);


CREATE TABLE metricdetails (
  id INT NOT NULL,
  detail CLOB NOT NULL,
  timestamp int NOT NULL,
  PRIMARY KEY (id))
  --The next 5 lines should be enabled only in production DB
  --TABLESPACE LCG_SAM_MS_DATA01
  --lob (detail) store as metricdetails_lob (
  --  TABLESPACE LCG_SAM_MS_DATA01 DISABLE STORAGE IN ROW CHUNK 8192 PCTVERSION 5
  --  NOCACHE LOGGING
  --)
  PARTITION BY RANGE (id) (
    partition metricdetails_1 VALUES LESS THAN (18000000),
    partition metricdetails_2 VALUES LESS THAN (36000000),
    partition metricdetails_3 VALUES LESS THAN (54000000),
    partition metricdetails_4 VALUES LESS THAN (72000000),
    partition metricdetails_5 VALUES LESS THAN (90000000),
    partition metricdetails_6 VALUES LESS THAN (108000000),
    partition metricdetails_7 VALUES LESS THAN (126000000),
    partition metricdetails_8 VALUES LESS THAN (144000000),
    partition metricdetails_9 VALUES LESS THAN (162000000),
    partition metricdetails_10 VALUES LESS THAN (180000000),
    partition metricdetails_11 VALUES LESS THAN (198000000),
    partition metricdetails_12 VALUES LESS THAN (216000000),
    partition metricdetails_13 VALUES LESS THAN (234000000),
    partition metricdetails_14 VALUES LESS THAN (252000000),
    partition metricdetails_15 VALUES LESS THAN (270000000),
    partition metricdetails_16 VALUES LESS THAN (288000000),
    partition metricdetails_17 VALUES LESS THAN (306000000),
    partition metricdetails_18 VALUES LESS THAN (324000000),
    partition metricdetails_19 VALUES LESS THAN (342000000),
    partition metricdetails_20 VALUES LESS THAN (360000000),
    partition metricdetails_21 VALUES LESS THAN (378000000),
    partition metricdetails_22 VALUES LESS THAN (396000000),
    partition metricdetails_23 VALUES LESS THAN (414000000),
    partition metricdetails_24 VALUES LESS THAN (432000000),
    partition metricdetails_25 VALUES LESS THAN (450000000),
    partition metricdetails_26 VALUES LESS THAN (468000000),
    partition metricdetails_27 VALUES LESS THAN (486000000),
    partition metricdetails_28 VALUES LESS THAN (504000000),
    partition metricdetails_29 VALUES LESS THAN (522000000),
    partition metricdetails_30 VALUES LESS THAN (540000000),
    partition metricdetails_31 VALUES LESS THAN (558000000),
    partition metricdetails_32 VALUES LESS THAN (576000000),
    partition metricdetails_33 VALUES LESS THAN (594000000),
    partition metricdetails_34 VALUES LESS THAN (612000000),
    partition metricdetails_35 VALUES LESS THAN (630000000),
    partition metricdetails_36 VALUES LESS THAN (648000000),
    partition metricdetails_37 VALUES LESS THAN (666000000),
    partition metricdetails_38 VALUES LESS THAN (684000000),
    partition metricdetails_39 VALUES LESS THAN (702000000),
    partition metricdetails_40 VALUES LESS THAN (720000000),
    partition metricdetails_41 VALUES LESS THAN (738000000),
    partition metricdetails_42 VALUES LESS THAN (756000000),
    partition metricdetails_43 VALUES LESS THAN (774000000),
    partition metricdetails_44 VALUES LESS THAN (792000000),
    partition metricdetails_45 VALUES LESS THAN (810000000),
    partition metricdetails_46 VALUES LESS THAN (828000000),
    partition metricdetails_47 VALUES LESS THAN (846000000),
    partition metricdetails_48 VALUES LESS THAN (864000000),
    partition metricdetails_49 VALUES LESS THAN (882000000),
    partition metricdetails_50 VALUES LESS THAN (900000000),
    partition metricdetails_51 VALUES LESS THAN (918000000),
    partition metricdetails_52 VALUES LESS THAN (936000000),
    partition metricdetails_53 VALUES LESS THAN (954000000),
    partition metricdetails_54 VALUES LESS THAN (972000000),
    partition metricdetails_55 VALUES LESS THAN (990000000),
    partition metricdetails_56 VALUES LESS THAN (1008000000),
    partition metricdetails_57 VALUES LESS THAN (1026000000),
    partition metricdetails_58 VALUES LESS THAN (1044000000),
    partition metricdetails_59 VALUES LESS THAN (1062000000),
    partition metricdetails_60 VALUES LESS THAN (1080000000),
    partition metricdetails_61 VALUES LESS THAN (1098000000),
    partition metricdetails_62 VALUES LESS THAN (1116000000),
    partition metricdetails_63 VALUES LESS THAN (1134000000),
    partition metricdetails_64 VALUES LESS THAN (1152000000),
    partition metricdetails_65 VALUES LESS THAN (1170000000),
    partition metricdetails_66 VALUES LESS THAN (1188000000),
    partition metricdetails_67 VALUES LESS THAN (1206000000),
    partition metricdetails_68 VALUES LESS THAN (1224000000),
    partition metricdetails_69 VALUES LESS THAN (1242000000),
    partition metricdetails_70 VALUES LESS THAN (1260000000),
    partition metricdetails_71 VALUES LESS THAN (1278000000),
    partition metricdetails_72 VALUES LESS THAN (1296000000),
    partition metricdetails_73 VALUES LESS THAN (1314000000),
    partition metricdetails_74 VALUES LESS THAN (1332000000),
    partition metricdetails_75 VALUES LESS THAN (1350000000),
    partition metricdetails_76 VALUES LESS THAN (1368000000),
    partition metricdetails_77 VALUES LESS THAN (1386000000),
    partition metricdetails_78 VALUES LESS THAN (1404000000),
    partition metricdetails_79 VALUES LESS THAN (1422000000),
    partition metricdetails_80 VALUES LESS THAN (1440000000),
    partition metricdetails_81 VALUES LESS THAN (1458000000),
    partition metricdetails_82 VALUES LESS THAN (1476000000),
    partition metricdetails_83 VALUES LESS THAN (1494000000),
    partition metricdetails_84 VALUES LESS THAN (1512000000),
    partition metricdetails_85 VALUES LESS THAN (1530000000),
    partition metricdetails_86 VALUES LESS THAN (1548000000),
    partition metricdetails_87 VALUES LESS THAN (1566000000),
    partition metricdetails_88 VALUES LESS THAN (1584000000),
    partition metricdetails_89 VALUES LESS THAN (1602000000),
    partition metricdetails_90 VALUES LESS THAN (1620000000),
    partition metricdetails_91 VALUES LESS THAN (1638000000),
    partition metricdetails_92 VALUES LESS THAN (1656000000),
    partition metricdetails_93 VALUES LESS THAN (1674000000),
    partition metricdetails_94 VALUES LESS THAN (1692000000),
    partition metricdetails_95 VALUES LESS THAN (1710000000),
    partition metricdetails_96 VALUES LESS THAN (1728000000),
    partition metricdetails_97 VALUES LESS THAN (1746000000),
    partition metricdetails_98 VALUES LESS THAN (1764000000),
    partition metricdetails_99 VALUES LESS THAN (1782000000),
    partition metricdetails_100 VALUES LESS THAN (1800000000)
);

CREATE TABLE metricdata (
  id INT NOT NULL  ,
  metricstatus_id INT NOT NULL ,
  metricdetail_id INT NULL ,
  metric_id INT,
  poem_sync_metric_id INT,
  service_id INT,
  vo_id INT,
  fqan_id INT,
  gatheredat_id INT,
  summarydata VARCHAR(256) NULL ,
  check_time INT NOT NULL ,
  insert_time INT NOT NULL ,
  PRIMARY KEY (id) ,
  CONSTRAINT fk_metricdata_metricstatus
    FOREIGN KEY (metricstatus_id )
    REFERENCES metricstatus (id ),
  CONSTRAINT fk_metricdata_metricdetails
    FOREIGN KEY (metricdetail_id )
    REFERENCES metricdetails (id ),
  CONSTRAINT fk_metricdata_sam_metrics
    FOREIGN KEY (metric_id )
    REFERENCES metric (id ),
  CONSTRAINT fk_metricdata_poem_metrics
    FOREIGN KEY (poem_sync_metric_id)
    REFERENCES poem_sync_metric (id),
  CONSTRAINT fk_metricdata_sam_nodes
    FOREIGN KEY (service_id )
    REFERENCES service (id ),
  CONSTRAINT fk_metricdata_fqan_id
    FOREIGN KEY (fqan_id)
    REFERENCES fqan (id),
  CONSTRAINT fk_metricdata_sam_vos
    FOREIGN KEY (vo_id )
    REFERENCES vo (id ),
  CONSTRAINT fk_metricdata_gatheredat_id
    FOREIGN KEY (gatheredat_id)
    REFERENCES gatheredat (id),
  CONSTRAINT uk_metricdata UNIQUE (metricstatus_id, metric_id, service_id, vo_id, check_time))
  PARTITION BY RANGE (check_time) (
    PARTITION METRICDATA_08_2010 VALUES LESS THAN (1283299200),
    PARTITION METRICDATA_09_2010 VALUES LESS THAN (1285891200),
    PARTITION METRICDATA_10_2010 VALUES LESS THAN (1288569600),
    PARTITION METRICDATA_11_2010 VALUES LESS THAN (1291161600),
    PARTITION METRICDATA_12_2010 VALUES LESS THAN (1293840000),
    PARTITION METRICDATA_01_2011 VALUES LESS THAN (1296518400),
    PARTITION METRICDATA_02_2011 VALUES LESS THAN (1298937600),
    PARTITION METRICDATA_03_2011 VALUES LESS THAN (1301616000),
    PARTITION METRICDATA_04_2011 VALUES LESS THAN (1304208000),
    PARTITION METRICDATA_05_2011 VALUES LESS THAN (1306886400),
    PARTITION METRICDATA_06_2011 VALUES LESS THAN (1309478400),
    PARTITION METRICDATA_07_2011 VALUES LESS THAN (1312156800),
    PARTITION METRICDATA_08_2011 VALUES LESS THAN (1314835200),
    PARTITION METRICDATA_09_2011 VALUES LESS THAN (1317427200),
    PARTITION METRICDATA_10_2011 VALUES LESS THAN (1320105600),
    PARTITION METRICDATA_11_2011 VALUES LESS THAN (1322697600),
    PARTITION METRICDATA_12_2011 VALUES LESS THAN (1325376000),
    PARTITION METRICDATA_01_2012 VALUES LESS THAN (1328054400),
    PARTITION METRICDATA_02_2012 VALUES LESS THAN (1330560000),
    PARTITION METRICDATA_03_2012 VALUES LESS THAN (1333238400),
    PARTITION METRICDATA_04_2012 VALUES LESS THAN (1335830400),
    PARTITION METRICDATA_05_2012 VALUES LESS THAN (1338508800),
    PARTITION METRICDATA_06_2012 VALUES LESS THAN (1341100800),
    PARTITION METRICDATA_07_2012 VALUES LESS THAN (1343779200),
    PARTITION METRICDATA_08_2012 VALUES LESS THAN (1346457600),
    PARTITION METRICDATA_09_2012 VALUES LESS THAN (1349049600),
    PARTITION METRICDATA_10_2012 VALUES LESS THAN (1351728000),
    PARTITION METRICDATA_11_2012 VALUES LESS THAN (1354320000),
    PARTITION METRICDATA_12_2012 VALUES LESS THAN (1356998400),
    PARTITION METRICDATA_01_2013 VALUES LESS THAN (1359676800),
    PARTITION METRICDATA_02_2013 VALUES LESS THAN (1362096000),
    PARTITION METRICDATA_03_2013 VALUES LESS THAN (1364774400),
    PARTITION METRICDATA_04_2013 VALUES LESS THAN (1367366400),
    PARTITION METRICDATA_05_2013 VALUES LESS THAN (1370044800),
    PARTITION METRICDATA_06_2013 VALUES LESS THAN (1372636800),
    PARTITION METRICDATA_07_2013 VALUES LESS THAN (1375315200),
    PARTITION METRICDATA_08_2013 VALUES LESS THAN (1377993600),
    PARTITION METRICDATA_09_2013 VALUES LESS THAN (1380585600),
    PARTITION METRICDATA_10_2013 VALUES LESS THAN (1383264000),
    PARTITION METRICDATA_11_2013 VALUES LESS THAN (1385856000),
    PARTITION METRICDATA_12_2013 VALUES LESS THAN (1388534400)
 );


CREATE TABLE statuschange_service_profile (
  id INT NOT NULL,
  service_id INT NULL,
  profile_id INT NULL,
  poem_sync_profile_id INT NULL,
  fqan_id INT,
  metricstatus_id INT NOT NULL,
  detail VARCHAR(256) NULL,
  timestamp INT NOT NULL,
  insert_time INT NOT NULL,
  is_considered_ace char(1) default 'N' NOT NULL,
  PRIMARY KEY (id),
  CONSTRAINT uk_statuschange_service_prof
    UNIQUE (service_id, profile_id, timestamp),
  CONSTRAINT fk_stchg_serv_p_metricst
    FOREIGN KEY (metricstatus_id )
    REFERENCES metricstatus (id ),
  CONSTRAINT fk_stchg_service_p_services
    FOREIGN KEY (service_id )
    REFERENCES service (id ),
  CONSTRAINT fk_stchg_service_p_profiles
    FOREIGN KEY (profile_id )
    REFERENCES profile (id ),
  CONSTRAINT fk_stchg_service_p_poem_prof
    FOREIGN KEY (poem_sync_profile_id )
    REFERENCES poem_sync_profile (id ),
  CONSTRAINT fk_stch_serv_profile_fqan_id
    FOREIGN KEY (fqan_id)
    REFERENCES fqan (id),
  CONSTRAINT statuschange_is_considered_chk
    check (is_considered_ace in ('N', 'Y', 'C')),
  CONSTRAINT uk_statuschange_service_p UNIQUE (service_id, profile_id, metricstatus_id, timestamp))
  PARTITION BY RANGE (timestamp) (
    PARTITION STATUSCHANGE_S_P_08_2010 VALUES LESS THAN (1283299200),
    PARTITION STATUSCHANGE_S_P_09_2010 VALUES LESS THAN (1285891200),
    PARTITION STATUSCHANGE_S_P_10_2010 VALUES LESS THAN (1288569600),
    PARTITION STATUSCHANGE_S_P_11_2010 VALUES LESS THAN (1291161600),
    PARTITION STATUSCHANGE_S_P_12_2010 VALUES LESS THAN (1293840000),
    PARTITION STATUSCHANGE_S_P_01_2011 VALUES LESS THAN (1296518400),
    PARTITION STATUSCHANGE_S_P_02_2011 VALUES LESS THAN (1298937600),
    PARTITION STATUSCHANGE_S_P_03_2011 VALUES LESS THAN (1301616000),
    PARTITION STATUSCHANGE_S_P_04_2011 VALUES LESS THAN (1304208000),
    PARTITION STATUSCHANGE_S_P_05_2011 VALUES LESS THAN (1306886400),
    PARTITION STATUSCHANGE_S_P_06_2011 VALUES LESS THAN (1309478400),
    PARTITION STATUSCHANGE_S_P_07_2011 VALUES LESS THAN (1312156800),
    PARTITION STATUSCHANGE_S_P_08_2011 VALUES LESS THAN (1314835200),
    PARTITION STATUSCHANGE_S_P_09_2011 VALUES LESS THAN (1317427200),
    PARTITION STATUSCHANGE_S_P_10_2011 VALUES LESS THAN (1320105600),
    PARTITION STATUSCHANGE_S_P_11_2011 VALUES LESS THAN (1322697600),
    PARTITION STATUSCHANGE_S_P_12_2011 VALUES LESS THAN (1325376000),
    PARTITION STATUSCHANGE_S_P_01_2012 VALUES LESS THAN (1328054400),
    PARTITION STATUSCHANGE_S_P_02_2012 VALUES LESS THAN (1330560000),
    PARTITION STATUSCHANGE_S_P_03_2012 VALUES LESS THAN (1333238400),
    PARTITION STATUSCHANGE_S_P_04_2012 VALUES LESS THAN (1335830400),
    PARTITION STATUSCHANGE_S_P_05_2012 VALUES LESS THAN (1338508800),
    PARTITION STATUSCHANGE_S_P_06_2012 VALUES LESS THAN (1341100800),
    PARTITION STATUSCHANGE_S_P_07_2012 VALUES LESS THAN (1343779200),
    PARTITION STATUSCHANGE_S_P_08_2012 VALUES LESS THAN (1346457600),
    PARTITION STATUSCHANGE_S_P_09_2012 VALUES LESS THAN (1349049600),
    PARTITION STATUSCHANGE_S_P_10_2012 VALUES LESS THAN (1351728000),
    PARTITION STATUSCHANGE_S_P_11_2012 VALUES LESS THAN (1354320000),
    PARTITION STATUSCHANGE_S_P_12_2012 VALUES LESS THAN (1356998400),
    PARTITION STATUSCHANGE_S_P_01_2013 VALUES LESS THAN (1359676800),
    PARTITION STATUSCHANGE_S_P_02_2013 VALUES LESS THAN (1362096000),
    PARTITION STATUSCHANGE_S_P_03_2013 VALUES LESS THAN (1364774400),
    PARTITION STATUSCHANGE_S_P_04_2013 VALUES LESS THAN (1367366400),
    PARTITION STATUSCHANGE_S_P_05_2013 VALUES LESS THAN (1370044800),
    PARTITION STATUSCHANGE_S_P_06_2013 VALUES LESS THAN (1372636800),
    PARTITION STATUSCHANGE_S_P_07_2013 VALUES LESS THAN (1375315200),
    PARTITION STATUSCHANGE_S_P_08_2013 VALUES LESS THAN (1377993600),
    PARTITION STATUSCHANGE_S_P_09_2013 VALUES LESS THAN (1380585600),
    PARTITION STATUSCHANGE_S_P_10_2013 VALUES LESS THAN (1383264000),
    PARTITION STATUSCHANGE_S_P_11_2013 VALUES LESS THAN (1385856000),
    PARTITION STATUSCHANGE_S_P_12_2013 VALUES LESS THAN (1388534400)
  );

create bitmap index statuschange_service_prof_b
  on statuschange_service_profile(is_considered_ace) local;


CREATE TABLE  metricdata_latest (
  id INT NOT NULL  ,
  metricstatus_id INT NOT NULL ,
  metricdetail_id INT NULL ,
  metric_id INT NULL ,
  poem_sync_metric_id INT,
  service_id INT NULL ,
  vo_id INT NULL ,
  fqan_id INT,
  summarydata VARCHAR(256) NULL ,
  gatheredat_id INT,
  check_time INT NOT NULL ,
  insert_time INT NOT NULL ,
  PRIMARY KEY (id) ,
  CONSTRAINT fk_metricdata_latest_metrics
    FOREIGN KEY (metric_id )
    REFERENCES metric (id ),
  CONSTRAINT fk_metricdata_l_poem_metrics
    FOREIGN KEY (poem_sync_metric_id)
      REFERENCES poem_sync_metric(id),
  CONSTRAINT fk_metricdata_latest_nodes
    FOREIGN KEY (service_id )
    REFERENCES service (id ),
  CONSTRAINT fk_metricdata_latest_vos
    FOREIGN KEY (vo_id )
    REFERENCES vo (id ),
  CONSTRAINT fk_metricdata_latest_fqan_id
    FOREIGN KEY (fqan_id)
    REFERENCES fqan (id),
  CONSTRAINT fk_metricdata_l_metricstatus
    FOREIGN KEY (metricstatus_id )
    REFERENCES metricstatus (id ),
  CONSTRAINT fk_metricdata_l_metricdetails
    FOREIGN KEY (metricdetail_id )
    REFERENCES metricdetails (id ),
  CONSTRAINT fk_metricdata_l_gatheredat_id
    FOREIGN KEY (gatheredat_id)
    REFERENCES gatheredat (id),
  CONSTRAINT uk_metricdata_l UNIQUE (metricstatus_id, metric_id, service_id, vo_id, check_time)
);


CREATE TABLE metricdata_rejected (
  id INT NOT NULL,
  service VARCHAR2(256),
  metricstatus VARCHAR(25),
  metric VARCHAR(256),
  serviceURI VARCHAR(256),
  hostname VARCHAR(256),
  service_flavour VARCHAR(256),
  vo VARCHAR(256),
  fqan VARCHAR2(256),
  summarydata CLOB NULL,
  gatheredat VARCHAR2(256),
  check_time INT NOT NULL ,
  insert_time INT NOT NULL ,
  reason VARCHAR(256),
  PRIMARY KEY (id))
  PARTITION BY RANGE (check_time) (
    PARTITION METRICDATA_R_08_2010 VALUES LESS THAN (1283299200),
    PARTITION METRICDATA_R_09_2010 VALUES LESS THAN (1285891200),
    PARTITION METRICDATA_R_10_2010 VALUES LESS THAN (1288569600),
    PARTITION METRICDATA_R_11_2010 VALUES LESS THAN (1291161600),
    PARTITION METRICDATA_R_12_2010 VALUES LESS THAN (1293840000),
    PARTITION METRICDATA_R_01_2011 VALUES LESS THAN (1296518400),
    PARTITION METRICDATA_R_02_2011 VALUES LESS THAN (1298937600),
    PARTITION METRICDATA_R_03_2011 VALUES LESS THAN (1301616000),
    PARTITION METRICDATA_R_04_2011 VALUES LESS THAN (1304208000),
    PARTITION METRICDATA_R_05_2011 VALUES LESS THAN (1306886400),
    PARTITION METRICDATA_R_06_2011 VALUES LESS THAN (1309478400),
    PARTITION METRICDATA_R_07_2011 VALUES LESS THAN (1312156800),
    PARTITION METRICDATA_R_08_2011 VALUES LESS THAN (1314835200),
    PARTITION METRICDATA_R_09_2011 VALUES LESS THAN (1317427200),
    PARTITION METRICDATA_R_10_2011 VALUES LESS THAN (1320105600),
    PARTITION METRICDATA_R_11_2011 VALUES LESS THAN (1322697600),
    PARTITION METRICDATA_R_12_2011 VALUES LESS THAN (1325376000),
    PARTITION METRICDATA_R_01_2012 VALUES LESS THAN (1328054400),
    PARTITION METRICDATA_R_02_2012 VALUES LESS THAN (1330560000),
    PARTITION METRICDATA_R_03_2012 VALUES LESS THAN (1333238400),
    PARTITION METRICDATA_R_04_2012 VALUES LESS THAN (1335830400),
    PARTITION METRICDATA_R_05_2012 VALUES LESS THAN (1338508800),
    PARTITION METRICDATA_R_06_2012 VALUES LESS THAN (1341100800),
    PARTITION METRICDATA_R_07_2012 VALUES LESS THAN (1343779200),
    PARTITION METRICDATA_R_08_2012 VALUES LESS THAN (1346457600),
    PARTITION METRICDATA_R_09_2012 VALUES LESS THAN (1349049600),
    PARTITION METRICDATA_R_10_2012 VALUES LESS THAN (1351728000),
    PARTITION METRICDATA_R_11_2012 VALUES LESS THAN (1354320000),
    PARTITION METRICDATA_R_12_2012 VALUES LESS THAN (1356998400),
    PARTITION METRICDATA_R_01_2013 VALUES LESS THAN (1359676800),
    PARTITION METRICDATA_R_02_2013 VALUES LESS THAN (1362096000),
    PARTITION METRICDATA_R_03_2013 VALUES LESS THAN (1364774400),
    PARTITION METRICDATA_R_04_2013 VALUES LESS THAN (1367366400),
    PARTITION METRICDATA_R_05_2013 VALUES LESS THAN (1370044800),
    PARTITION METRICDATA_R_06_2013 VALUES LESS THAN (1372636800),
    PARTITION METRICDATA_R_07_2013 VALUES LESS THAN (1375315200),
    PARTITION METRICDATA_R_08_2013 VALUES LESS THAN (1377993600),
    PARTITION METRICDATA_R_09_2013 VALUES LESS THAN (1380585600),
    PARTITION METRICDATA_R_10_2013 VALUES LESS THAN (1383264000),
    PARTITION METRICDATA_R_11_2013 VALUES LESS THAN (1385856000),
    PARTITION METRICDATA_R_12_2013 VALUES LESS THAN (1388534400)
);

CREATE INDEX MDATA_REJ_CHECKTIME_IDX ON METRICDATA_REJECTED (CHECK_TIME ASC);


INSERT INTO metricstatus(id, weight, description, description_nagios, comments) VALUES (1,1,'OK','OK',NULL);
INSERT INTO metricstatus(id, weight, description, description_nagios, comments) VALUES(2,2,'WARNING','WARNING',NULL);
INSERT INTO metricstatus(id, weight, description, description_nagios, comments) VALUES(3,3,'UNKNOWN','UNKNOWN',NULL);
INSERT INTO metricstatus(id, weight, description, description_nagios, comments) VALUES(4,4,'MISSING','MISSING',NULL);
INSERT INTO metricstatus(id, weight, description, description_nagios, comments) VALUES(5,5,'CRITICAL','CRITICAL',NULL);
INSERT INTO metricstatus(id, weight, description, description_nagios, comments) VALUES (6,6,'REMOVED', '', 'Service removed');


CREATE TABLE tested_services (
  id INT NOT NULL,
  service_id INT NOT NULL,
  profile_id INT NOT NULL,
  last_insert_time INT NOT NULL,
  PRIMARY KEY (id),
  CONSTRAINT uk_tested_services
    UNIQUE (service_id, profile_id),
  CONSTRAINT fk_tested_services_service
    FOREIGN KEY (service_id)
    REFERENCES service (id),
  CONSTRAINT fk_tested_services_profile
    FOREIGN KEY (profile_id)
    REFERENCES profile (id)
);


CREATE SEQUENCE MetricDetailsSeq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;


CREATE SEQUENCE MetricDataSeq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;


CREATE SEQUENCE StatusChange_ServiceProfileSeq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;


CREATE SEQUENCE MetricData_LatestSeq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;


CREATE SEQUENCE MetricData_RejectedSeq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;


CREATE SEQUENCE SchemaDetailsSeq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;


CREATE SEQUENCE TestedServicesSeq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;


  CREATE INDEX metricdata_metric_id_idx ON metricdata(metric_id);

  CREATE INDEX metricdata_p_s_metric_id_idx ON metricdata(poem_sync_metric_id);

  CREATE INDEX metricdata_service_id_idx ON metricdata(service_id);


  CREATE INDEX metricdata_vo_id_idx ON metricdata(vo_id);


  CREATE INDEX metricdata_metricstatus_id_idx ON metricdata(metricstatus_id);


  CREATE INDEX metricdata_metricdetail_id_idx ON metricdata(metricdetail_id);


  CREATE INDEX metricdata_checktime_local_idx ON metricdata (check_time) LOCAL;


  CREATE INDEX metricdata_l_metric_id_idx ON metricdata_latest(metric_id);

  CREATE INDEX metricdata_l_p_s_metric_id_idx ON metricdata_latest(poem_sync_metric_id);

  CREATE INDEX metricdata_l_service_id_idx ON metricdata_latest(service_id);


  CREATE INDEX metricdata_l_vo_id_idx ON metricdata_latest(vo_id);


  CREATE BITMAP INDEX metricdata_l_metricst_id_idx ON metricdata_latest(metricstatus_id);


  CREATE INDEX metricdata_l_metricdet_id_idx ON metricdata_latest(metricdetail_id);


  CREATE INDEX metricdata_l_check_time_idx ON metricdata_latest(check_time);


  CREATE INDEX statuschg_s_p_metricst_id_idx ON statuschange_service_profile(metricstatus_id);


  CREATE INDEX statuschg_s_p_service_id_idx ON statuschange_service_profile(service_id);

  CREATE INDEX statuschg_s_p_profile_id_idx ON statuschange_service_profile(profile_id);

  CREATE INDEX statuschg_s_p_poem_s_prof_idx ON statuschange_service_profile(poem_sync_profile_id);

  CREATE INDEX tested_services_service_id_idx ON tested_services(service_id);


  CREATE INDEX tested_services_profile_id_idx ON tested_services(profile_id);
  



-- BEGIN: Temporary hack to make msg-consume2oracle working

CREATE TABLE T_METRICOUTPUT (
  SERVICEFLAVOUR VARCHAR2(256),
  METRICNAME NVARCHAR2(256),
  METRICSTATUS VARCHAR2(45),
  SUMMARYDATA VARCHAR2(256),
  DETAILSDATA CLOB,
  VONAME VARCHAR2(256),
  VOFQAN VARCHAR2(256),
  HOSTNAME VARCHAR2(512),
  GATHEREDAT VARCHAR2(256),
  SERVICEURI VARCHAR2(256),
  TIMESTAMP VARCHAR2(256));


create or replace view v_metricoutput as select * from t_metricoutput;


-- END: Temporary hack to make msg-consume2oracle working


-- Additional functions

create or replace type split_tbl as table of varchar2(32767);
/


create or replace function split
(
    p_list varchar2,
    p_del varchar2 := ','
) return split_tbl pipelined
is
    l_idx    pls_integer;
    l_list    varchar2(32767) := p_list;
    l_value    varchar2(32767);
begin
    loop
        l_idx := instr(l_list,p_del);
        if l_idx > 0 then
            pipe row(substr(l_list,1,l_idx-1));
            l_list := substr(l_list,l_idx+length(p_del));

        else
            pipe row(l_list);
            exit;
        end if;
    end loop;
    return;
end split;
/


CREATE OR REPLACE FUNCTION  w3ctime_to_uts (str char) RETURN PLS_INTEGER IS

  ora_date DATE := to_date(str,'yyyy-mm-dd"T"hh24:mi:ss"Z"');
  unix_epoch DATE := TO_DATE('19700101000000','YYYYMMDDHH24MISS');
  max_date DATE := TO_DATE('20380101000000','YYYYMMDDHH24MISS');
  min_date DATE := TO_DATE('19030101000000','YYYYMMDDHH24MISS');
  unix_ts PLS_INTEGER;

BEGIN

  IF ora_date > max_date THEN
    RAISE_APPLICATION_ERROR( -20902,
      'Date too large for 32bit UNIX timestamp' );
  ELSIF ora_date < min_date THEN
    RAISE_APPLICATION_ERROR( -20902,
      'Date too small for 32bit UNIX timestamp' );
  ELSE
    unix_ts := (ora_date - unix_epoch)
                                * 86400;
END IF;

RETURN (unix_ts);

END;
/


CREATE OR REPLACE FUNCTION to_unixts(oracle_ts IN TIMESTAMP) RETURN PLS_INTEGER IS

--
-- Converts an Oracle timestamp to a UNIX timestamp
--

  unix_epoch DATE := TO_DATE('19700101000000','YYYYMMDDHH24MISS');
  max_date DATE := TO_DATE('20380101000000','YYYYMMDDHH24MISS');
  min_date DATE := TO_DATE('19030101000000','YYYYMMDDHH24MISS');
  unix_ts PLS_INTEGER;

BEGIN

  IF cast(oracle_ts as date) > max_date THEN
    RAISE_APPLICATION_ERROR( -20902,
      'Date too large for 32bit UNIX timestamp' );
  ELSIF cast(oracle_ts as date) < min_date THEN
    RAISE_APPLICATION_ERROR( -20902,
     'Date too small for 32bit UNIX timestamp' );
  ELSE
    unix_ts := (cast(sys_extract_utc(oracle_ts) as date) - unix_epoch) * 86400;
  END IF;

  RETURN (unix_ts);
END;
/


CREATE OR REPLACE FUNCTION unixts_to_date(unixts IN PLS_INTEGER) RETURN DATE IS

-- Converts a UNIX timestamp into an Oracle DATE

unix_epoch DATE := TO_DATE('19700101000000','YYYYMMDDHH24MISS');
max_ts PLS_INTEGER := 2145916799; -- 2938-12-31 23:59:59
min_ts PLS_INTEGER := -2114380800; -- 1903-01-01 00:00:00
oracle_date DATE;

BEGIN
  IF unixts > max_ts THEN
      RAISE_APPLICATION_ERROR( -20901,'UNIX timestamp too large for 32 bit limit');
  ELSIF unixts < min_ts THEN
      RAISE_APPLICATION_ERROR(-20901, 'UNIX timestamp too small for 32 bit limit');
  ELSE
      oracle_date := unix_epoch + NUMTODSINTERVAL(unixts, 'SECOND');
  END IF;

  RETURN (oracle_date);

END;
/


CREATE OR REPLACE FUNCTION uts_to_w3ctime (uts INTEGER) RETURN VARCHAR2 AS
BEGIN
  RETURN to_char(unixts_to_date(uts),'yyyy-mm-dd"T"hh24:mi:ss"Z"');
END;
/


CREATE OR REPLACE FUNCTION getMetricFreshness (in_service_id INTEGER, in_profile_id INTEGER, maxAgeInHours INTEGER)
RETURN INTEGER AS
  metricFreshness INTEGER;
BEGIN

  --"metricFreshness = urrent_timestamp - (1/24)*maxAgeInHours" if any metric with status "MISSING" found
  select min(to_unixts(current_timestamp - (1/24)*maxAgeInHours)) into metricFreshness from METRICDATA_LATEST
  where metric_id in
    (select distinct metric_id from profile_metric_map where profile_id = in_profile_id
       and service_type_flavour_id in
         (select flavour_id from service where id = in_service_id)
    )
    and metricstatus_id = 5
    and service_id = in_service_id;

  if metricFreshness is null then
	  select min(check_time) into metricFreshness from METRICDATA_LATEST
	  where metric_id in
	    (select distinct metric_id from profile_metric_map where profile_id = in_profile_id
	       and service_type_flavour_id in
	         (select flavour_id from service where id = in_service_id)
	    )
	    and metricstatus_id != 5
	    and service_id = in_service_id;

  end if;

  return(metricFreshness);
END;
/


  CREATE OR REPLACE PROCEDURE test_sam_ms_jobs

  AS
    sqlStatement VARCHAR2(2000);

    cursor jobs_cursor is select 'begin dbms_scheduler.run_job(''' ||job_name || ''', TRUE); end;' from all_scheduler_jobs
      where job_name like 'SAM_MS%'
      order by job_name;
  BEGIN
    OPEN jobs_cursor;
      LOOP
        FETCH jobs_cursor INTO sqlStatement;
        EXIT WHEN jobs_cursor%NOTFOUND;

        dbms_output.put_line('Executing sql command: ' || sqlStatement);
        execute immediate sqlStatement;


      END LOOP;
    CLOSE jobs_cursor;
  END;
/


CREATE TABLE DataLoader_LastCheckTime
(
  check_time INT NOT NULL,
  CONSTRAINT uk_DataLoader_LastCheckTime UNIQUE (check_time)
);


CREATE TABLE METRICDATAFORRECALCULATION (
  id INT NOT NULL,
  metricdata_spool_id INT NOT NULL,
  gatheredat_id INT,
  metricstatus_id INT NOT NULL,
  detailsdata CLOB,
  metric_id INT NOT NULL,
  poem_sync_metric_id INT,
  service_id INT NOT NULL,
  fqan_id INT,
  vo_id INT,
  summarydata VARCHAR2(256) NULL,
  check_time INT NOT NULL,
  insert_time INT NOT NULL,
  PRIMARY KEY (id),
  CONSTRAINT fk_metricdata_r_gatheredat_id
    FOREIGN KEY (gatheredat_id)
    REFERENCES gatheredat(id),
  CONSTRAINT fk_metricdata_r_metrics
    FOREIGN KEY (metric_id)
    REFERENCES metric(id),
  CONSTRAINT fk_metricdata_f_r_poem_metrics
    FOREIGN KEY (poem_sync_metric_id)
    REFERENCES poem_sync_metric(id),
  CONSTRAINT fk_metricdata_r_nodes
    FOREIGN KEY (service_id)
    REFERENCES service(id),
  CONSTRAINT fk_metricdata_r_vos
    FOREIGN KEY (vo_id)
    REFERENCES vo(id),
  CONSTRAINT fk_metricdata_r_fqan
    FOREIGN KEY (fqan_id)
    REFERENCES fqan(id),
  CONSTRAINT fk_metricdata_r_metricstatus
    FOREIGN KEY (metricstatus_id)
    REFERENCES metricstatus (id)
);

CREATE INDEX metricdatafr_p_s_metric_id_idx ON metricdataforrecalculation(poem_sync_metric_id);

create table METRICDATAFORRECALC_REJECTED as
select * from METRICDATAFORRECALCULATION where rownum < 0;


CREATE SEQUENCE MetricDataForRecalculationSeq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;


CREATE OR REPLACE TRIGGER MetricData_ForRec_trig BEFORE INSERT ON MetricDataForRecalculation
FOR EACH ROW
BEGIN
SELECT MetricDataForRecalculationSeq.NEXTVAL into :new.id FROM dual;
END;
/


CREATE TABLE MetricData_Spool
(
  ID INT NOT NULL,
  service_id INT NOT NULL,
  metric_id INT NOT NULL,
  poem_sync_metric_id INT,
  metricstatus_id INT NOT NULL,
  fqan_id INT,
  vo_id INT,
  gatheredat_id INT,
  SUMMARYDATA VARCHAR2(256),
  DETAILSDATA CLOB,
  check_time INT,
  insert_time INT,
  PRIMARY KEY(id),
  CONSTRAINT fk_metricdata_sp_nodes
    FOREIGN KEY (service_id)
    REFERENCES service(id),
  CONSTRAINT fk_metricdata_sp_metrics
    FOREIGN KEY (metric_id)
    REFERENCES metric(id),
  CONSTRAINT fk_metricdata_s_poem_metrics
    FOREIGN KEY (poem_sync_metric_id)
      REFERENCES poem_sync_metric(id),  
  CONSTRAINT fk_metricdata_sp_metricstatus
    FOREIGN KEY (metricstatus_id)
    REFERENCES metricstatus (id),
  CONSTRAINT fk_metricdata_spool_fqan_id
    FOREIGN KEY (fqan_id)
    REFERENCES fqan (id),
  CONSTRAINT fk_metricdata_sp_vos
    FOREIGN KEY (vo_id)
    REFERENCES vo(id),
  CONSTRAINT fk_metricdata_sp_gatheredat_id
    FOREIGN KEY (gatheredat_id)
    REFERENCES gatheredat(id)
);

CREATE INDEX metricdata_s_p_s_metric_id_idx ON metricdata_spool(poem_sync_metric_id);


CREATE SEQUENCE MetricData_SpoolSeq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  noCYCLE;


CREATE INDEX metricdata_s_check_time_idx ON metricdata_spool(check_time);


create table metricdata_spool_rejected as
select * from metricdata_spool where rownum < 0;


CREATE TABLE metrics_in_supported_services (
  id INT NOT NULL,
  service_id INT NOT NULL,
  metric_id INT NOT NULL,
  vo_id INT NULL,
  fqan_id INT NULL,
  profile_id INT NOT NULL,
  frequency INT NOT NULL,
  timestamp INT NULL,
  updated INT NULL,
  PRIMARY KEY (id),
  CONSTRAINT uk_supported_services UNIQUE(service_id, metric_id, vo_id, fqan_id, profile_id),
  CONSTRAINT fk_metrics_in_supp_service
    FOREIGN KEY (service_id)
    REFERENCES service (id),
  CONSTRAINT fk_metrics_in_supp_metric
    FOREIGN KEY (metric_id)
    REFERENCES metric (id),
  CONSTRAINT fk_metrics_in_supp_vo
    FOREIGN KEY (vo_id)
    REFERENCES vo (id),
  CONSTRAINT fk_metrics_in_supp_fqan
    FOREIGN KEY (fqan_id)
    REFERENCES fqan (id),
  CONSTRAINT fk_metrics_in_supp_profile
    FOREIGN KEY (profile_id)
    REFERENCES profile (id)
);


CREATE SEQUENCE metrics_in_supp_services_seq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;


CREATE TABLE metrics_in_supp_serv_history (
  id INT NOT NULL,
  service_id INT NOT NULL,
  metric_id INT NOT NULL,
  vo_id INT NULL,
  fqan_id INT NULL,
  profile_id INT NOT NULL,
  operation VARCHAR2(10) NOT NULL,
  timestamp INT NULL,
  PRIMARY KEY (id),
  CONSTRAINT uk_supported_services_hists UNIQUE(service_id, metric_id, vo_id, fqan_id, profile_id, operation, timestamp ),
  CONSTRAINT operation_chk CHECK( operation IN ('insert', 'delete') ),
  CONSTRAINT fk_metrics_in_supp_h_service
    FOREIGN KEY (service_id)
    REFERENCES service (id),
  CONSTRAINT fk_metrics_in_supp_h_metric
    FOREIGN KEY (metric_id)
    REFERENCES metric (id),
  CONSTRAINT fk_metrics_in_supp_h_vo
    FOREIGN KEY (vo_id)
    REFERENCES vo (id),
  CONSTRAINT fk_metrics_in_supp_h_fqan
    FOREIGN KEY (fqan_id)
    REFERENCES fqan (id),
  CONSTRAINT fk_metrics_in_supp_h_profile
    FOREIGN KEY (profile_id)
    REFERENCES profile (id)
);


CREATE SEQUENCE metrics_in_supp_serv_his_seq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;


CREATE TABLE metrics_in_supp_serv_rejected (
  id INT NOT NULL,
  service_type_flavour VARCHAR2(256) NULL,
  hostname VARCHAR2(256) NULL,
  metric_name VARCHAR2(256) NULL,
  vo VARCHAR2(256) NULL,
  fqan VARCHAR2(256) NULL,
  profile VARCHAR2(256) NULL,
  frequency INT NULL,
  timestamp INT NULL,
  reason VARCHAR(256) NULL,
  PRIMARY KEY (id)
 );


CREATE SEQUENCE metrics_in_supp_serv_rej_seq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;


CREATE TABLE statuschange_metric_service (
  id INT NOT NULL,
  metric_id INT NOT NULL,
  service_id INT NOT NULL,
  vo_id INT NULL,
  metricstatus_id INT NOT NULL,
  timestamp INT NOT NULL,
  insert_time INT NOT NULL,
  poem_sync_metric_id INT NULL,
  PRIMARY KEY (id),
  CONSTRAINT uk_statuschange_metric_service UNIQUE (service_id, metric_id, vo_id, timestamp),
  CONSTRAINT fk_statuschg_metric_s_metrics
    FOREIGN KEY (metric_id )
    REFERENCES metric (id ),
  CONSTRAINT fk_statuschg_metric_s_metricst
    FOREIGN KEY (metricstatus_id )
    REFERENCES metricstatus (id ),
  CONSTRAINT fk_statuschange_metric_s_serv
    FOREIGN KEY (service_id )
    REFERENCES service (id ),
  CONSTRAINT fk_stchg_metric_s_poem_serv
    FOREIGN KEY (poem_sync_metric_id)
    REFERENCES poem_sync_metric (id),
  CONSTRAINT fk_statuschange_metric_s_vos
    FOREIGN KEY (vo_id)
    REFERENCES vo (id))
  PARTITION BY RANGE (timestamp) (
    PARTITION STATUSCHANGE_M_S_08_2010 VALUES LESS THAN (1283299200),
    PARTITION STATUSCHANGE_M_S_09_2010 VALUES LESS THAN (1285891200),
    PARTITION STATUSCHANGE_M_S_10_2010 VALUES LESS THAN (1288569600),
    PARTITION STATUSCHANGE_M_S_11_2010 VALUES LESS THAN (1291161600),
    PARTITION STATUSCHANGE_M_S_12_2010 VALUES LESS THAN (1293840000),
    PARTITION STATUSCHANGE_M_S_01_2011 VALUES LESS THAN (1296518400),
    PARTITION STATUSCHANGE_M_S_02_2011 VALUES LESS THAN (1298937600),
    PARTITION STATUSCHANGE_M_S_03_2011 VALUES LESS THAN (1301616000),
    PARTITION STATUSCHANGE_M_S_04_2011 VALUES LESS THAN (1304208000),
    PARTITION STATUSCHANGE_M_S_05_2011 VALUES LESS THAN (1306886400),
    PARTITION STATUSCHANGE_M_S_06_2011 VALUES LESS THAN (1309478400),
    PARTITION STATUSCHANGE_M_S_07_2011 VALUES LESS THAN (1312156800),
    PARTITION STATUSCHANGE_M_S_08_2011 VALUES LESS THAN (1314835200),
    PARTITION STATUSCHANGE_M_S_09_2011 VALUES LESS THAN (1317427200),
    PARTITION STATUSCHANGE_M_S_10_2011 VALUES LESS THAN (1320105600),
    PARTITION STATUSCHANGE_M_S_11_2011 VALUES LESS THAN (1322697600),
    PARTITION STATUSCHANGE_M_S_12_2011 VALUES LESS THAN (1325376000),
    PARTITION STATUSCHANGE_M_S_01_2012 VALUES LESS THAN (1328054400),
    PARTITION STATUSCHANGE_M_S_02_2012 VALUES LESS THAN (1330560000),
    PARTITION STATUSCHANGE_M_S_03_2012 VALUES LESS THAN (1333238400),
    PARTITION STATUSCHANGE_M_S_04_2012 VALUES LESS THAN (1335830400),
    PARTITION STATUSCHANGE_M_S_05_2012 VALUES LESS THAN (1338508800),
    PARTITION STATUSCHANGE_M_S_06_2012 VALUES LESS THAN (1341100800),
    PARTITION STATUSCHANGE_M_S_07_2012 VALUES LESS THAN (1343779200),
    PARTITION STATUSCHANGE_M_S_08_2012 VALUES LESS THAN (1346457600),
    PARTITION STATUSCHANGE_M_S_09_2012 VALUES LESS THAN (1349049600),
    PARTITION STATUSCHANGE_M_S_10_2012 VALUES LESS THAN (1351728000),
    PARTITION STATUSCHANGE_M_S_11_2012 VALUES LESS THAN (1354320000),
    PARTITION STATUSCHANGE_M_S_12_2012 VALUES LESS THAN (1356998400),
    PARTITION STATUSCHANGE_M_S_01_2013 VALUES LESS THAN (1359676800),
    PARTITION STATUSCHANGE_M_S_02_2013 VALUES LESS THAN (1362096000),
    PARTITION STATUSCHANGE_M_S_03_2013 VALUES LESS THAN (1364774400),
    PARTITION STATUSCHANGE_M_S_04_2013 VALUES LESS THAN (1367366400),
    PARTITION STATUSCHANGE_M_S_05_2013 VALUES LESS THAN (1370044800),
    PARTITION STATUSCHANGE_M_S_06_2013 VALUES LESS THAN (1372636800),
    PARTITION STATUSCHANGE_M_S_07_2013 VALUES LESS THAN (1375315200),
    PARTITION STATUSCHANGE_M_S_08_2013 VALUES LESS THAN (1377993600),
    PARTITION STATUSCHANGE_M_S_09_2013 VALUES LESS THAN (1380585600),
    PARTITION STATUSCHANGE_M_S_10_2013 VALUES LESS THAN (1383264000),
    PARTITION STATUSCHANGE_M_S_11_2013 VALUES LESS THAN (1385856000),
    PARTITION STATUSCHANGE_M_S_12_2013 VALUES LESS THAN (1388534400)
);

CREATE INDEX statuschg_m_s_poem_s_met_idx ON statuschange_metric_service(poem_sync_metric_id);

CREATE SEQUENCE statuschange_metric_s_seq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE TABLE fqans_in_supported_services (
  id INT NOT NULL,
  profile_id INT NOT NULL,
  service_id INT NOT NULL,
  fqan_id INT NOT NULL,
  timestamp INT NOT NULL,
  updated INT NULL ,
  PRIMARY KEY (id) ,
  CONSTRAINT uk_fqan_in_supp_serv UNIQUE (profile_id, service_id, fqan_id),
  CONSTRAINT fk_fqans_in_supp_serv_fqan
    FOREIGN KEY (fqan_id)
    REFERENCES fqan(id),
  CONSTRAINT fk_fqans_in_supp_serv_profile
    FOREIGN KEY (profile_id)
    REFERENCES profile(id),
  CONSTRAINT fk_fqans_in_supp_serv_service
    FOREIGN KEY (service_id)
    REFERENCES service(id)
);

create or replace view fqans_in_regions as
select distinct get_roc_name(service_id) as roc_name, fqan_id from fqans_in_supported_services;

CREATE SEQUENCE fqans_in_supported_s_seq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;


CREATE TABLE fqans_in_supp_serv_rejected (
  id INT NOT NULL ,
  service_type_flavour VARCHAR2(256) NULL ,
  hostname VARCHAR2(256) NULL ,
  fqan VARCHAR2(256) NULL ,
  profile VARCHAR2(256) NULL ,
  timestamp INT NULL,
  reason VARCHAR2(256) NULL,
  PRIMARY KEY (id)
);


CREATE SEQUENCE fqans_in_supp_serv_r_seq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE TABLE PROFILE_HIERARCHY (	 
  ID INT NOT NULL, 
  PROFILE_ID INT NOT NULL,
  PARENT_PROFILE_ID INT NOT NULL,
  TIMESTAMP INT NOT NULL,
  PRIMARY KEY (ID), 
  CONSTRAINT UK_PROFILE_HIERARCHY UNIQUE (PROFILE_ID, PARENT_PROFILE_ID), 
  CONSTRAINT FK_PROFILE_HIERARCHY_PROFILE FOREIGN KEY (PROFILE_ID)
    REFERENCES PROFILE (ID), 
  CONSTRAINT FK_PROFILE_HIERARCHY_PARENT FOREIGN KEY (PARENT_PROFILE_ID)
	REFERENCES PROFILE (ID)
);

CREATE SEQUENCE PROFILE_HIERARCHY_SEQ;   


CREATE TABLE supported_profiles (
  id INT NOT NULL,
  name VARCHAR2(256) NOT NULL,
  insert_time INT NOT NULL ,
  PRIMARY KEY (id),
  CONSTRAINT uk_supported_profiles
    UNIQUE (name)
);


CREATE SEQUENCE supported_profiles_seq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE OR REPLACE TYPE freq_rec AS OBJECT (
  roc VARCHAR2(256),
  flavour_id NUMBER,
  metric_id NUMBER,
  freq NUMBER
);
/


CREATE OR REPLACE TYPE freq_table AS TABLE OF freq_rec;
/


CREATE GLOBAL TEMPORARY TABLE tmpJoinProfile (
  name VARCHAR2(256),
  metric_id NUMBER,
  service_type_flavour_id NUMBER
) ON COMMIT DELETE ROWS;


CREATE GLOBAL TEMPORARY TABLE tmpFilteredMetrics (
  NGI VARCHAR2(256),
  flavour_name VARCHAR2(256),
  metric_name VARCHAR2(256),
  fqan_name VARCHAR2(256),
  counter NUMBER
) ON COMMIT PRESERVE ROWS;


CREATE GLOBAL TEMPORARY TABLE tmpMetricsCount (
  NGI VARCHAR2(256),
  flavour_name VARCHAR2(256),
  metric_name VARCHAR2(256),
  fqan_name VARCHAR2(256),
  counter NUMBER
) ON COMMIT PRESERVE ROWS;


CREATE GLOBAL TEMPORARY TABLE tmpFreshMetrics (
  NGI VARCHAR2(256),
  flavour_name VARCHAR2(256),
  metric_name VARCHAR2(256),
  fqan_name VARCHAR2(256),
  received NUMBER,
  total NUMBER,
  percentage NUMBER
) ON COMMIT PRESERVE ROWS;


create or replace view metric_history_in_profile as
  select profile_name, vo.voname as defined_by_vo, hostname, service_type, service_flavour, metric_exec_time,
    metric_name, fqan, tested_by_vo, metric_status, metric_output_summary, gathered_at, metric_result_insert_time
  from (
    select p.name as profile_name, p.defining_vo_id, s.hostname, st.serviceabbr as service_type, t.flavourname as service_flavour, 
          l.check_time as metric_exec_time, m.name as metric_name, f.name as fqan, v.voname as tested_by_vo, ms.description as metric_status, 
          l.summarydata as metric_output_summary, g.name as gathered_at, l.insert_time as metric_result_insert_time from metricdata l, vo v, fqan f, 
          service s, service_type st, service_type_flavour t, metric m, metricstatus ms, profile p, gatheredat g, profile_metric_map pm
    where 
      g.id = l.gatheredat_id
      and st.id = t.service_type_id
      and ms.id = l.metricstatus_id
      and m.id = l.metric_id
      and t.id = s.flavour_id
      and s.id = l.service_id
      and (f.id(+) = l.fqan_id)  
      and (v.id(+) = l.vo_id)
      and pm.profile_id = p.id
      and pm.service_type_flavour_id = s.flavour_id
      and pm.metric_id = l.metric_id
      and (pm.test_vo_id = l.vo_id or l.vo_id is null)
  ) a, vo
  where a.defining_vo_id = vo.id;
  
create or replace view metric_history_in_poem_s_prof as
  select profile_name, namespace,  vo.voname as defined_by_vo, hostname, service_type, service_flavour, metric_exec_time,
    metric_name, fqan, tested_by_vo, metric_status, metric_output_summary, gathered_at, metric_result_insert_time
  from (
    select pp.name as profile_name, pp.atp_vo_id, s.hostname, st.serviceabbr as service_type, t.flavourname as service_flavour, 
          l.check_time as metric_exec_time, m.name as metric_name, f.name as fqan, v.voname as tested_by_vo, ms.description as metric_status, 
          l.summarydata as metric_output_summary, g.name as gathered_at, l.insert_time as metric_result_insert_time, pn.name as namespace 
          from metricdata l, vo v, fqan f, 
          service s, service_type st, service_type_flavour t, poem_sync_metric m, metricstatus ms, gatheredat g,  
          poem_sync_profile pp, poem_sync_namespace pn, poem_sync_p_m_instances ppm, poem_sync_metricinstance pm
    where 
      g.id = l.gatheredat_id
      and st.id = t.service_type_id
      and ms.id = l.metricstatus_id
      and m.id = l.poem_sync_metric_id
      and t.id = s.flavour_id
      and s.id = l.service_id
      and (f.id(+) = l.fqan_id)  
      and (v.id(+) = l.vo_id)
      and ppm.profile_id = pp.id
      and pm.atp_service_type_flavour_id = s.flavour_id
      and pm.metric_id = l.poem_sync_metric_id
      and (pm.atp_vo_id = l.vo_id or l.vo_id is null)
      and pm.id = ppm.metricinstance_id
      and pp.namespace_id = pn.id
  ) a, vo
  where a.atp_vo_id = vo.id;

CREATE materialized VIEW statuschg_serv_prof_MAXts BUILD immediate REFRESH ON COMMIT AS
SELECT i.service_id, i.profile_id, i.poem_sync_profile_id, MAX(i.timestamp) as max_timestamp
   FROM statuschange_service_profile i
   GROUP BY i.service_id, i.profile_id, i.poem_sync_profile_id;
   
   
CREATE OR REPLACE VIEW statuschange_service_profile_l AS
SELECT s.id, s.service_id, s.profile_id, s.poem_sync_profile_id, s.metricstatus_id, s.detail, s.timestamp
FROM statuschange_service_profile s, statuschg_serv_prof_MAXts r
WHERE s.service_id = r.service_id AND s.profile_id = r.profile_id AND s.poem_sync_profile_id = r.poem_sync_profile_id AND s.timestamp = r.max_timestamp;

CREATE TABLE mon_frequency_statistics (
  roc VARCHAR2(256),
  flavour_id INT NOT NULL,
  metric_id INT NOT NULL,
  freq_mean INT NOT NULL,
  freq_std INT NOT NULL
);


CREATE INDEX uk_mon_frequency_statistics ON mon_frequency_statistics(roc ASC, flavour_id ASC, metric_id ASC);

-- for LCG_SAM_MS_PILOT_W you have to do the following:
-- GRANT EXECUTE ON getFreshMetrics TO LCG_SAM_MS_PILOT_W;
-- GRANT SELECT ON tmpFreshMetrics TO LCG_SAM_MS_PILOT_W;

-- the following has to be done as LCG_SAM_MS_PILOT_W in LCG_SAM_MS_PILOT_W:
-- SYNONYM getFreshMetrics FOR LCG_SAM_MS_PILOT.getFreshMetrics;
-- SYNONYM tmpFreshMetrics FOR LCG_SAM_MS_PILOT.tmpFreshMetrics;


CREATE TABLE METRICSTORE_CURR_LOAD_H
(
    ID NUMBER 
    	NOT NULL,
    REC_DATE VARCHAR2(20 BYTE)
    	DEFAULT to_char(sys_extract_utc(CURRENT_TIMESTAMP), 'DD-MON-YYYY')
    	NOT NULL,
    HOUR NUMBER(2,0) 
    	DEFAULT EXTRACT(HOUR FROM CURRENT_TIMESTAMP) 
    	NOT NULL,
    TIMESTAMP TIMESTAMP (6) 
    	DEFAULT SYS_EXTRACT_UTC(CURRENT_TIMESTAMP) 
    	NOT NULL,
    NUMBER_OF_RECORDS NUMBER 
    	NOT NULL,
    CONSTRAINT METRICSTORE_CURR_LOAD_H_CHK1
    	CHECK (HOUR >= 0 AND HOUR <= 23
  			AND NUMBER_OF_RECORDS >= 0),
    CONSTRAINT METRICSTORE_CURR_LOAD_H_PK 
    	PRIMARY KEY (ID),
    CONSTRAINT METRICSTORE_CURR_LOAD_H_UK1
    	UNIQUE (REC_DATE, HOUR)
);

CREATE SEQUENCE METRICSTORE_CURR_LOAD_H_SEQ
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;
  
CREATE TABLE METRICSTORE_CURR_LOAD_M
(
    ID NUMBER 
    	NOT NULL,
    TIMESTAMP TIMESTAMP (6) 
    	DEFAULT sys_extract_utc(CURRENT_TIMESTAMP) 
    	NOT NULL,
    HOUR NUMBER(2,0) 
    	DEFAULT EXTRACT(HOUR FROM CURRENT_TIMESTAMP) 
    	NOT NULL,
    MINUTE NUMBER(2,0) 
    	DEFAULT EXTRACT(MINUTE FROM CURRENT_TIMESTAMP) 
    	NOT NULL,
    NUMBER_OF_RECORDS NUMBER 
    	NOT NULL,
    CONSTRAINT METRICSTORE_CURR_LOAD_M_PK
    	PRIMARY KEY (ID),
    CONSTRAINT METRICSTORE_CURR_LOAD_M_UK1 
    UNIQUE (HOUR, MINUTE),
    CONSTRAINT METRICSTORE_CURR_LOAD_M_CHK1 
    	CHECK (HOUR >= 0 AND HOUR <= 23 
    		AND MINUTE >= 0 AND MINUTE <= 59 
    		AND NUMBER_OF_RECORDS >= 0)
);

CREATE SEQUENCE METRICSTORE_CURR_LOAD_M_SEQ
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE TABLE METRICSTORE_CURR_LOAD_H_DET
(
    ID NUMBER 
    	NOT NULL,
    REC_DATE VARCHAR2(20 BYTE)
    	DEFAULT to_char(sys_extract_utc(CURRENT_TIMESTAMP), 'DD-MON-YYYY')
    	NOT NULL,
    HOUR NUMBER(2,0) 
    	DEFAULT EXTRACT(HOUR FROM CURRENT_TIMESTAMP) 
    	NOT NULL,
    TIMESTAMP TIMESTAMP (6) 
    	DEFAULT SYS_EXTRACT_UTC(CURRENT_TIMESTAMP) 
    	NOT NULL,
    NGI_NAME VARCHAR2(20 BYTE),
    PROFILE_ID NUMBER,
    FLAVOUR_ID NUMBER 
    	NOT NULL,
    NUMBER_OF_RECORDS NUMBER,
    poem_sync_profile_id INT NULL,
    CONSTRAINT METRICSTORE_CURR_LOAD_H_D_CHK1 
    	CHECK (HOUR >= 0 AND HOUR <= 23
  			AND NUMBER_OF_RECORDS >= 0),
    CONSTRAINT METRICSTORE_CURR_LOAD_H_D_PK 
    	PRIMARY KEY (ID),
    CONSTRAINT METRICSTORE_CURR_LOAD_H_D_UK1 
    	UNIQUE (REC_DATE, HOUR, NGI_NAME, PROFILE_ID, FLAVOUR_ID),
    CONSTRAINT METRICSTORE_CURR_LOAD_H_D_FK1 
    	FOREIGN KEY (PROFILE_ID) 
    	REFERENCES PROFILE (ID),
    CONSTRAINT fk_metricstore_clhd_poem_prof
        FOREIGN KEY (poem_sync_profile_id)
        REFERENCES poem_sync_profile (id),
    CONSTRAINT METRICSTORE_CURR_LOAD_H_D_FK2 
    	FOREIGN KEY (FLAVOUR_ID) 
    	REFERENCES SERVICE_TYPE_FLAVOUR (ID)
);

CREATE SEQUENCE METRICSTORE_CURR_LOAD_H_D_SEQ
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;
  
CREATE INDEX MRS_CURR_LOAD_H_DET_NGI_idx ON METRICSTORE_CURR_LOAD_H_DET(NGI_NAME);
CREATE INDEX MRS_CURR_LOAD_H_DET_PROF_idx ON METRICSTORE_CURR_LOAD_H_DET(PROFILE_ID);
CREATE INDEX MRS_CURR_LOAD_H_DET_FLAV_idx ON METRICSTORE_CURR_LOAD_H_DET(FLAVOUR_ID);
CREATE INDEX MRS_CURR_LOAD_H_DET_REC_D_idx ON METRICSTORE_CURR_LOAD_H_DET(REC_DATE);
CREATE INDEX MRS_CURR_LOAD_H_DET_HOUR_idx ON METRICSTORE_CURR_LOAD_H_DET(HOUR);
CREATE INDEX MRS_CURR_LOAD_H_DET_TIMEST_idx ON METRICSTORE_CURR_LOAD_H_DET(TIMESTAMP);
CREATE INDEX metricstore_clhd_poem_prof_idx ON metricstore_curr_load_h_det(poem_sync_profile_id);

------------------------------------------------------------
-- Start: OSG only Oracle version
------------------------------------------------------------

CREATE TABLE T_METRICOUTPUT_OSG
(
  SERVICETYPE VARCHAR2(256),
  METRICNAME NVARCHAR2(256),
  METRICSTATUS VARCHAR2(45),
  SUMMARYDATA VARCHAR2(256),
  PERFORMANCEDATA VARCHAR2(256),
  DETAILSDATA CLOB,
  VONAME VARCHAR2(256),
  SERVICEURI VARCHAR2(256),
  GATHEREDAT VARCHAR2(256),
  "TIMESTAMP" VARCHAR2(256)
);


CREATE OR REPLACE VIEW V_METRICOUTPUT_OSG AS SELECT * FROM T_METRICOUTPUT_OSG;

CREATE TABLE METRICGROUP_OSG
(
  ID INT NOT NULL,
  FLAVOUR_ID INT NOT NULL,
  SERVICETYPE VARCHAR2(256) NOT NULL,
  PRIMARY KEY (id),
  CONSTRAINT METRICGROUP_UK UNIQUE (FLAVOUR_ID, SERVICETYPE),
  CONSTRAINT METRICGROUP_OSG_FLAVOUR_FK FOREIGN KEY (FLAVOUR_ID)
    REFERENCES SERVICE_TYPE_FLAVOUR (ID)
);

CREATE SEQUENCE METRICGROUP_OSGSeq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE TABLE METRICDESCRIPTION_OSG
(
  ID INT NOT NULL,
  SERVICETYPE VARCHAR2(256) NOT NULL,
  METRICNAME VARCHAR2(256) NOT NULL,
  METRIC_ID INT NOT NULL,
  PRIMARY KEY (id),
  CONSTRAINT METRIDESC_OSG_UK UNIQUE (METRIC_ID, SERVICETYPE),
  CONSTRAINT METRIDESC_OSG_FLAVOUR_FK FOREIGN KEY (METRIC_ID)
    REFERENCES METRIC (ID)
);

CREATE SEQUENCE METRICDESCRIPTION_OSGSeq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE OR REPLACE FORCE VIEW V_METRICDESCRIPTION_OSG (SERVICETYPE, METRICNAME, METRICTITLE, METRICHELP) AS
 select distinct m.servicetype, m.metricname, t.description metrictitle, to_char(t.docurl) metrichelp
   from metricdescription_osg m, metric t
   where m.metric_id=t.id;

CREATE TABLE metricdata_rejected_osg (
  id INT NOT NULL,
  service VARCHAR2(256),
  metricstatus VARCHAR(25),
  metric VARCHAR(256),
  serviceURI VARCHAR(256),
  hostname VARCHAR(256),
  service_flavour VARCHAR(256),
  vo VARCHAR(256),
  fqan VARCHAR2(256),
  summarydata CLOB NULL,
  gatheredat VARCHAR2(256),
  check_time INT NOT NULL ,
  insert_time INT NOT NULL ,
  reason VARCHAR(256),
  PRIMARY KEY (id))
  PARTITION BY RANGE (check_time) (
    PARTITION METRICDATA_R_OSG_08_2010 VALUES LESS THAN (1283299200),
    PARTITION METRICDATA_R_OSG_09_2010 VALUES LESS THAN (1285891200),
    PARTITION METRICDATA_R_OSG_10_2010 VALUES LESS THAN (1288569600),
    PARTITION METRICDATA_R_OSG_11_2010 VALUES LESS THAN (1291161600),
    PARTITION METRICDATA_R_OSG_12_2010 VALUES LESS THAN (1293840000),
    PARTITION METRICDATA_R_OSG_01_2011 VALUES LESS THAN (1296518400),
    PARTITION METRICDATA_R_OSG_02_2011 VALUES LESS THAN (1298937600),
    PARTITION METRICDATA_R_OSG_03_2011 VALUES LESS THAN (1301616000),
    PARTITION METRICDATA_R_OSG_04_2011 VALUES LESS THAN (1304208000),
    PARTITION METRICDATA_R_OSG_05_2011 VALUES LESS THAN (1306886400),
    PARTITION METRICDATA_R_OSG_06_2011 VALUES LESS THAN (1309478400),
    PARTITION METRICDATA_R_OSG_07_2011 VALUES LESS THAN (1312156800),
    PARTITION METRICDATA_R_OSG_08_2011 VALUES LESS THAN (1314835200),
    PARTITION METRICDATA_R_OSG_09_2011 VALUES LESS THAN (1317427200),
    PARTITION METRICDATA_R_OSG_10_2011 VALUES LESS THAN (1320105600),
    PARTITION METRICDATA_R_OSG_11_2011 VALUES LESS THAN (1322697600),
    PARTITION METRICDATA_R_OSG_12_2011 VALUES LESS THAN (1325376000),
    PARTITION METRICDATA_R_OSG_01_2012 VALUES LESS THAN (1328054400),
    PARTITION METRICDATA_R_OSG_02_2012 VALUES LESS THAN (1330560000),
    PARTITION METRICDATA_R_OSG_03_2012 VALUES LESS THAN (1333238400),
    PARTITION METRICDATA_R_OSG_04_2012 VALUES LESS THAN (1335830400),
    PARTITION METRICDATA_R_OSG_05_2012 VALUES LESS THAN (1338508800),
    PARTITION METRICDATA_R_OSG_06_2012 VALUES LESS THAN (1341100800),
    PARTITION METRICDATA_R_OSG_07_2012 VALUES LESS THAN (1343779200),
    PARTITION METRICDATA_R_OSG_08_2012 VALUES LESS THAN (1346457600),
    PARTITION METRICDATA_R_OSG_09_2012 VALUES LESS THAN (1349049600),
    PARTITION METRICDATA_R_OSG_10_2012 VALUES LESS THAN (1351728000),
    PARTITION METRICDATA_R_OSG_11_2012 VALUES LESS THAN (1354320000),
    PARTITION METRICDATA_R_OSG_12_2012 VALUES LESS THAN (1356998400),
    PARTITION METRICDATA_R_OSG_01_2013 VALUES LESS THAN (1359676800),
    PARTITION METRICDATA_R_OSG_02_2013 VALUES LESS THAN (1362096000),
    PARTITION METRICDATA_R_OSG_03_2013 VALUES LESS THAN (1364774400),
    PARTITION METRICDATA_R_OSG_04_2013 VALUES LESS THAN (1367366400),
    PARTITION METRICDATA_R_OSG_05_2013 VALUES LESS THAN (1370044800),
    PARTITION METRICDATA_R_OSG_06_2013 VALUES LESS THAN (1372636800),
    PARTITION METRICDATA_R_OSG_07_2013 VALUES LESS THAN (1375315200),
    PARTITION METRICDATA_R_OSG_08_2013 VALUES LESS THAN (1377993600),
    PARTITION METRICDATA_R_OSG_09_2013 VALUES LESS THAN (1380585600),
    PARTITION METRICDATA_R_OSG_10_2013 VALUES LESS THAN (1383264000),
    PARTITION METRICDATA_R_OSG_11_2013 VALUES LESS THAN (1385856000),
    PARTITION METRICDATA_R_OSG_12_2013 VALUES LESS THAN (1388534400)
);

CREATE INDEX MDATA_REJ_OSG_CHECKTIME_IDX ON METRICDATA_REJECTED_OSG (CHECK_TIME ASC);

CREATE SEQUENCE MetricData_RejectedOSGSeq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

------------------------------------------------------------
-- End: OSG only Oracle version
------------------------------------------------------------

------------------------------------------------------------
-- Begin: Recomputation - only Oracle version
------------------------------------------------------------

CREATE TABLE statuschange_service_prof_rec (
  id INT NOT NULL,
  service_id INT NULL,
  profile_id INT NULL,
  fqan_id INT,
  metricstatus_id INT NOT NULL,
  detail VARCHAR(256) NULL,
  timestamp INT NOT NULL,
  insert_time INT NOT NULL,
  is_considered_ace char(1) default 'N' NOT NULL,
  ggus_ticket_id INT NOT NULL,
  PRIMARY KEY (id),
  CONSTRAINT uk_statuschange_service_p_rec
    UNIQUE (id, ggus_ticket_id)
  );

CREATE INDEX statusch_service_prof_rec_idx ON statuschange_service_prof_rec(ggus_ticket_id);

CREATE TABLE statuschange_metric_serv_rec (
  id INT NOT NULL,
  metric_id INT NOT NULL,
  service_id INT NOT NULL,
  vo_id INT NULL,
  metricstatus_id INT NOT NULL,
  timestamp INT NOT NULL,
  insert_time INT NOT NULL
  ggus_ticket_id INT NOT NULL,
  PRIMARY KEY (id),
  CONSTRAINT uk_statuschange_met_serv_rec
    UNIQUE (id, ggus_ticket_id)
  );

CREATE INDEX statusch_metric_serv_rec_idx ON statuschange_metric_serv_rec(ggus_ticket_id);

CREATE TABLE metricdata_rec (
  id INT NOT NULL  ,
  metricstatus_id INT NOT NULL ,
  metricdetail_id INT NULL ,
  metric_id INT,
  poem_sync_metric_id INT,
  service_id INT,
  vo_id INT,
  fqan_id INT,
  gatheredat_id INT,
  summarydata VARCHAR(256) NULL ,
  check_time INT NOT NULL ,
  insert_time INT NOT NULL ,
  ggus_ticket_id INT NOT NULL,
  PRIMARY KEY (id),
  CONSTRAINT uk_metricdata_r UNIQUE (id, ggus_ticket_id)
 );

CREATE INDEX metricdata_rec_idx ON metricdata_rec(ggus_ticket_id);

------------------------------------------------------------
-- End: Recomputation - only Oracle version
------------------------------------------------------------
