DELIMITER //

USE `mrs`;

SET GLOBAL event_scheduler = 1;

DROP EVENT IF EXISTS `purgeMetricStore_event`;

CREATE EVENT `purgeMetricStore_event`
 ON SCHEDULE EVERY 30 MINUTE
    STARTS CURRENT_TIMESTAMP
 DO 
    BEGIN
     DECLARE CONTINUE HANDLER FOR SQLWARNING
       BEGIN
         insert into event_logger(severity, name, message)
           values('WARN', 'PURGEMETRICSTORE_EVENT', 'Warning reported during execution. See server error log for details.');
       END;

     DECLARE EXIT HANDLER FOR SQLEXCEPTION
       BEGIN
         insert into event_logger(severity, name, message)
           values('ERROR', 'PURGEMETRICSTORE_EVENT', 'Execution failed. See server error log.');
     END;

     insert into event_logger(severity, name, message)
       values('INFO', 'PURGEMETRICSTORE_EVENT', 'Begin');
       
     call purgeMetricStore(90, 7);

     insert into event_logger(severity, name, message)
       values('INFO', 'PURGEMETRICSTORE_EVENT', 'Success');
   
     commit;
     
   END //
 

DROP EVENT IF EXISTS `loadmetricdata_event`;

CREATE EVENT `loadmetricdata_event`
 ON SCHEDULE EVERY 3 MINUTE
    STARTS CURRENT_TIMESTAMP
 DO 
   BEGIN
     DECLARE CONTINUE HANDLER FOR SQLWARNING
       BEGIN
         insert into event_logger(severity, name, message)
           values('WARN', 'LOADMETRICDATA_EVENT', 'Warning reported during execution. See server error log for details.');
       END;

     DECLARE EXIT HANDLER FOR SQLEXCEPTION
       BEGIN
         insert into event_logger(severity, name, message)
           values('ERROR', 'LOADMETRICDATA_EVENT', 'Execution failed. See server error log.');
       END;

     insert into event_logger(severity, name, message)
       values('INFO', 'LOADMETRICDATA_EVENT', 'Begin');

     call loadmetricdata(24, 10, 15);

     insert into event_logger(severity, name, message)
       values('INFO', 'LOADMETRICDATA_EVENT', 'Success');
   
     commit;
     
   END //

DELIMITER ;