BEGIN

  DBMS_SCHEDULER.drop_job (job_name => 'SAM_MS_INSERTMISSINGMETRICS');

  DBMS_SCHEDULER.create_job (
    job_name        => 'SAM_MS_INSERTMISSINGMETRICS',
    job_type        => 'PLSQL_BLOCK',
    job_action      => 'BEGIN DATALOADER.INSERTMISSINGMETRICS(24); END;',
    start_date      => SYSTIMESTAMP,
    repeat_interval => 'freq=hourly; interval=1; bysecond=1',
    end_date        => NULL,
    enabled         => TRUE,
    comments        => 'Mark MISSING metrics');

  DBMS_SCHEDULER.drop_job (job_name => 'SAM_MS_LoadData');

  DBMS_SCHEDULER.create_job (
    job_name        => 'SAM_MS_LoadData',
    job_type        => 'PLSQL_BLOCK',
    job_action      => 'BEGIN dataloader.loadmetricdata(10); END;',
    start_date      => SYSTIMESTAMP,
    repeat_interval => 'freq=minutely; interval=3; bysecond=1',
    end_date        => NULL,
    enabled         => TRUE,
    comments        => 'SAM - Load Data');

END;
/
