CREATE OR REPLACE TRIGGER ins_metr_in_sup_services_fer

AFTER INSERT ON metrics_in_supported_services FOR EACH ROW

BEGIN

  insert into metrics_in_supp_serv_history (id, service_id, metric_id, vo_id, fqan_id, profile_id, timestamp, operation)
  values(metrics_in_supp_serv_his_seq.nextval, :NEW.service_id, :NEW.metric_id, :NEW.vo_id, :NEW.fqan_id, :NEW.profile_id, to_unixts(current_timestamp), 'insert');

END;
/

CREATE OR REPLACE TRIGGER del_metr_in_sup_services_fer

AFTER DELETE ON metrics_in_supported_services FOR EACH ROW

BEGIN

  insert into metrics_in_supp_serv_history (id, service_id, metric_id, vo_id, fqan_id, profile_id, timestamp, operation)
  values(metrics_in_supp_serv_his_seq.nextval, :OLD.service_id, :OLD.metric_id, :OLD.vo_id, :OLD.fqan_id, :OLD.profile_id, to_unixts(current_timestamp), 'delete');

END;
/

CREATE OR REPLACE TRIGGER V_MOUT_INSERT_TRG instead of insert on V_METRICOUTPUT

BEGIN

  DataLoader.loadmetricdatatospool(:NEW.serviceflavour, :NEW.metricname, :NEW.metricstatus,
       :NEW.summarydata, :NEW.detailsdata, :NEW.voname, :NEW.vofqan, :NEW.hostname, :NEW.timestamp, :NEW.gatheredat);

END;
/

create or replace trigger load_metricdata_fer
  after insert on metricdata for each row

DECLARE

  CURSOR metric_curs IS SELECT check_time FROM metricdata_latest
    WHERE nvl(fqan_id, -1) = nvl(:NEW.fqan_id, -1) AND nvl(vo_id, -1) = nvl(:NEW.vo_id, -1) AND metric_id = :NEW.metric_id
      AND service_id = :NEW.service_id;

  v_check_time INTEGER;

BEGIN

  OPEN metric_curs;
  FETCH metric_curs INTO v_check_time;
  CLOSE metric_curs;

  IF ((v_check_time IS NOT NULL) AND (v_check_time <= :NEW.check_time)) THEN

    DELETE FROM metricdata_latest WHERE nvl(fqan_id, -1) = nvl(:NEW.fqan_id, -1) AND nvl(vo_id, -1) = nvl(:NEW.vo_id, -1)
      AND metric_id = :NEW.metric_id AND service_id = :NEW.service_id;
    INSERT INTO metricdata_latest(id, metricstatus_id, metricdetail_id, metric_id, service_id, fqan_id, vo_id, summarydata, gatheredat_id, check_time, insert_time)
    VALUES (MetricData_LatestSeq.nextval, :NEW.metricstatus_id, :NEW.metricdetail_id, :NEW.metric_id, :NEW.service_id, :NEW.fqan_id, :NEW.vo_id, :NEW.summarydata, :NEW.gatheredat_id, :NEW.check_time, :NEW.insert_time);
  ELSIF (v_check_time IS NULL) THEN
    INSERT INTO metricdata_latest(id, metricstatus_id, metricdetail_id, metric_id, service_id, fqan_id, vo_id, summarydata, gatheredat_id, check_time, insert_time)
    VALUES (MetricData_LatestSeq.nextval, :NEW.metricstatus_id, :NEW.metricdetail_id, :NEW.metric_id, :NEW.service_id, :NEW.fqan_id, :NEW.vo_id, :NEW.summarydata, :NEW.gatheredat_id, :NEW.check_time, :NEW.insert_time);
  END IF;


END;
/

CREATE OR REPLACE TRIGGER T_MOUT_OSG_INSERT_TRG instead of insert on V_METRICOUTPUT_OSG

BEGIN

  DataLoader.loadmetricdatatospool_OSG(:NEW.servicetype, :NEW.metricname, :NEW.metricstatus,
       :NEW.summarydata, :NEW.detailsdata, :NEW.voname, :NEW.serviceuri, :NEW.timestamp);

END;
/

