CREATE OR REPLACE TRIGGER ins_metr_in_sup_services_fer

AFTER INSERT ON metrics_in_supported_services FOR EACH ROW

BEGIN

  insert into metrics_in_supp_serv_history (id, service_id, metric_id, vo_id, fqan_id, profile_id, timestamp, operation)
  values(metrics_in_supp_serv_his_seq.nextval, :NEW.service_id, :NEW.metric_id, :NEW.vo_id, :NEW.fqan_id, :NEW.profile_id, to_unixts(current_timestamp), 'insert');

END;
/

CREATE OR REPLACE TRIGGER del_metr_in_sup_services_fer

AFTER DELETE ON metrics_in_supported_services FOR EACH ROW

BEGIN

  insert into metrics_in_supp_serv_history (id, service_id, metric_id, vo_id, fqan_id, profile_id, timestamp, operation)
  values(metrics_in_supp_serv_his_seq.nextval, :OLD.service_id, :OLD.metric_id, :OLD.vo_id, :OLD.fqan_id, :OLD.profile_id, to_unixts(current_timestamp), 'delete');

END;
/

CREATE OR REPLACE TRIGGER V_MOUT_INSERT_TRG instead of insert on V_METRICOUTPUT

BEGIN

  DataLoader.loadmetricdatatospool(:NEW.serviceflavour, :NEW.metricname, :NEW.metricstatus,
       :NEW.summarydata, :NEW.detailsdata, :NEW.voname, :NEW.vofqan, :NEW.hostname, :NEW.timestamp, :NEW.gatheredat);

END;
/

create or replace trigger load_metricdata_fer
  after insert on metricdata for each row

DECLARE

  CURSOR metric_curs IS SELECT check_time FROM metricdata_latest
    WHERE nvl(fqan_id, -1) = nvl(:NEW.fqan_id, -1) AND nvl(vo_id, -1) = nvl(:NEW.vo_id, -1) AND metric_id = :NEW.metric_id
      AND service_id = :NEW.service_id;

  v_check_time INTEGER;

BEGIN

  OPEN metric_curs;
  FETCH metric_curs INTO v_check_time;
  CLOSE metric_curs;

  IF ((v_check_time IS NOT NULL) AND (v_check_time <= :NEW.check_time)) THEN

    DELETE FROM metricdata_latest WHERE nvl(fqan_id, -1) = nvl(:NEW.fqan_id, -1) AND nvl(vo_id, -1) = nvl(:NEW.vo_id, -1)
      AND metric_id = :NEW.metric_id AND service_id = :NEW.service_id;
    INSERT INTO metricdata_latest(id, metricstatus_id, metricdetail_id, metric_id, service_id, fqan_id, vo_id, summarydata, gatheredat_id, check_time, insert_time)
    VALUES (MetricData_LatestSeq.nextval, :NEW.metricstatus_id, :NEW.metricdetail_id, :NEW.metric_id, :NEW.service_id, :NEW.fqan_id, :NEW.vo_id, :NEW.summarydata, :NEW.gatheredat_id, :NEW.check_time, :NEW.insert_time);
  ELSIF (v_check_time IS NULL) THEN
    INSERT INTO metricdata_latest(id, metricstatus_id, metricdetail_id, metric_id, service_id, fqan_id, vo_id, summarydata, gatheredat_id, check_time, insert_time)
    VALUES (MetricData_LatestSeq.nextval, :NEW.metricstatus_id, :NEW.metricdetail_id, :NEW.metric_id, :NEW.service_id, :NEW.fqan_id, :NEW.vo_id, :NEW.summarydata, :NEW.gatheredat_id, :NEW.check_time, :NEW.insert_time);
  END IF;


END;
/

CREATE OR REPLACE TRIGGER V_MOUT_OSG_INSERT_TRG instead of insert on V_METRICOUTPUT_OSG

BEGIN
  DataLoader.loadmetricdatatospool_OSG(:NEW.serviceuri, :NEW.servicetype, :NEW.metricname, :NEW.metricstatus,
       :NEW.summarydata, :NEW.detailsdata, :NEW.voname, :NEW.timestamp, :NEW.gatheredat);
 
END;
/

CREATE OR REPLACE TRIGGER V_MDESC_INSERT_TRG 
 instead of insert on V_METRICDESCRIPTION_OSG
declare
  tid number;
  tname varchar(100);
  stype varchar(100);
begin
  stype:=lower(:new.servicetype);
  for svc in (select f.id, f.flavourname
               from metricgroup_osg m, service_type_flavour f
               where m.flavour_id = f.id and m.SERVICETYPE=stype)
  loop
    tname:=:new.metricname;
    begin
      select id into tid
      from metric
      where name=tname;
      update metric
      set description=:new.metrictitle,
        docurl=:new.metrichelp
      where id=tid;
      insert into metricdescription_osg (id, servicetype, metricname, metric_id)
      values (METRICDESCRIPTION_OSGSeq.nextval, stype, :new.metricname, tid);
    exception
      when no_data_found then
        --SAME_DB_MONITORING.send_mail_to_list('SAM_DB_Monit@no.reply', 'Wojciech.Lapka@cern.ch,David.Collados@cern.ch', 'SAM Prod: metric result rejected at DB insertion', 'ERROR: serviceType ' || lower(:new.servicetype) || '  not defined in metricgroup table?');
        select metric_SEQ.nextval into tid from dual;
        
        insert into metric (id, name, version, creator_id, description, docurl, isdeleted)
        values (tid, tname, '1.0.0', 2 /*Vaibhav - see MDDB_USER*/, :new.metrictitle, :new.metrichelp, 0);
        
        insert into metricdescription_osg (id, servicetype, metricname, metric_id)
        values (METRICDESCRIPTION_OSGSeq.nextval, stype, :new.metricname, tid);
        
      when dup_val_on_index then
        update metricdescription_osg
        set metricname=:new.metricname
        where servicetype=stype and metricname=:new.metricname and metric_id=tid;
    end;
  end loop;
end;
/
