USE mrs; 

CREATE  TABLE IF NOT EXISTS `tested_services` (
  `id` INT NOT NULL AUTO_INCREMENT ,
  `service_id` INT NOT NULL ,
  `profile_id` INT NOT NULL ,
  `last_insert_time` INT NOT NULL ,
  PRIMARY KEY (`id`) ,
  INDEX `fk_tested_services_service` (`service_id` ASC) ,
  INDEX `fk_tested_services_profile` (`profile_id` ASC) ,
  INDEX `tested_services_time` (`last_insert_time` ASC) ,

  CONSTRAINT `uk_tested_services`
    UNIQUE KEY (`service_id`, `profile_id`),
  CONSTRAINT `fk_tested_services_service`
    FOREIGN KEY (`service_id` )
    REFERENCES `service` (`id` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT `fk_tested_services_profile`
    FOREIGN KEY (`profile_id` )
    REFERENCES `profile` (`id` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)

ENGINE = InnoDB;

CREATE TABLE  IF NOT EXISTS schema_details (
     id INT AUTO_INCREMENT NOT NULL,
     ver VARCHAR(20) NOT NULL,
     creation_date DATETIME NOT NULL,
     remarks VARCHAR(1000) BINARY NULL,
     PRIMARY KEY (id)
)
ENGINE=INNODB;

DROP TABLE IF EXISTS statuschange_service;

CREATE TABLE IF NOT EXISTS supportedVos (
  id INT AUTO_INCREMENT NOT NULL,
  vo_id INT NOT NULL,
  insert_time INT NOT NULL ,
  PRIMARY KEY (id),
  INDEX `fkSupportedVos` (`vo_id` ASC) ,
  CONSTRAINT `uk_supportedVos`
    UNIQUE KEY (`vo_id`),
  CONSTRAINT `fkSupportedVos`
    FOREIGN KEY (`vo_id` )
       REFERENCES `vo` (`id` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION
)
ENGINE=INNODB;

