CREATE TABLE tested_services (
  id INT NOT NULL,
  service_id INT NOT NULL,
  profile_id INT NOT NULL,
  last_insert_time INT NOT NULL,
  PRIMARY KEY (id),
  CONSTRAINT uk_tested_services
    UNIQUE (service_id, profile_id),
  CONSTRAINT fk_tested_services_service
    FOREIGN KEY (service_id)
    REFERENCES service (id),
  CONSTRAINT fk_tested_services_profile
    FOREIGN KEY (profile_id)
    REFERENCES profile (id)
);

CREATE INDEX tested_services_service_id_idx ON tested_services(service_id);
CREATE INDEX tested_services_profile_id_idx ON tested_services(profile_id);


CREATE TABLE schema_details (
  id INT NOT NULL,
  ver VARCHAR(20) NOT NULL,
  creation_date TIMESTAMP NOT NULL,
  remarks VARCHAR(1000) NULL,
  PRIMARY KEY (id)
);

CREATE SEQUENCE TestedServicesSeq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE SEQUENCE SchemaDetailsSeq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

DROP TABLE statuschange_service;

DROP SEQUENCE StatusChange_ServiceSeq;
