set serveroutput on
DECLARE
 
 jobclass VARCHAR(255) := NULL;
 servicename VARCHAR(255) := NULL;
 postmp NUMBER := 0;

BEGIN

  --  gets service name
  SELECT SYS_CONTEXT ('USERENV', 'SERVICE_NAME') into servicename FROM DUAL;
  postmp := instr (servicename, '.', 1, 1)-1;  

  -- gets job class
  BEGIN
    SELECT job_class_name INTO jobclass FROM ALL_SCHEDULER_JOB_CLASSES WHERE job_class_name='SAM_MONITORING_JOBS';
  EXCEPTION
    WHEN NO_DATA_FOUND THEN
      jobclass := NULL;
  END;

  --  creates job class if not yet defined using the correct service 
  IF jobclass='SAM_MONITORING_JOBS' THEN
    dbms_output.put_line ('job class SAM_MONITORING_JOBS alredy exits');
  ELSE
    DBMS_SCHEDULER.CREATE_JOB_CLASS (
      job_class_name => 'SAM_MONITORING_JOBS',
      service => substr(servicename,1,postmp),
      comments => 'Job class for GT/TOM SAM monitoring');
    dbms_output.put_line ('job class SAM_MONITORING_JOBS created using service ' || substr(servicename,1,postmp));
  END IF;

  --  drop existing job SAM_MS_PURGE_METRICSTORE
  DBMS_SCHEDULER.drop_job (job_name => 'SAM_MS_PURGE_METRICSTORE');
    
  DBMS_SCHEDULER.create_job (
    job_name        => 'SAM_MS_PURGE_METRICSTORE',
    job_type        => 'PLSQL_BLOCK',
    job_action      => 'BEGIN dataloader.purgeMetricstore(6, 1, 12, 7); END;',
    start_date      => SYSTIMESTAMP,
    repeat_interval => 'freq=daily; interval=1; byhour=1',
    end_date        => NULL,
    job_class       => 'SAM_MONITORING_JOBS',
    enabled         => TRUE,
    comments        => 'SAM - Purging Job');    
    
END;
/
