CREATE INDEX MDATA_REJ_CHECKTIME_IDX ON METRICDATA_REJECTED (CHECK_TIME ASC);
CREATE INDEX MDATA_REJ_OSG_CHECKTIME_IDX ON METRICDATA_REJECTED_OSG (CHECK_TIME ASC);

------------------------------------------------------------
-- Begin: Recomputation - only Oracle version
------------------------------------------------------------

CREATE TABLE statuschange_service_prof_rec (
  id INT NOT NULL,
  service_id INT NULL,
  profile_id INT NULL,
  fqan_id INT,
  metricstatus_id INT NOT NULL,
  detail VARCHAR(256) NULL,
  timestamp INT NOT NULL,
  insert_time INT NOT NULL,
  is_considered_ace char(1) default 'N' NOT NULL,
  ggus_ticket_id INT NOT NULL,
  PRIMARY KEY (id),
  CONSTRAINT uk_statuschange_service_p_rec
    UNIQUE (id, ggus_ticket_id)
  );

CREATE INDEX statusch_service_prof_rec_idx ON statuschange_service_prof_rec(ggus_ticket_id);

CREATE TABLE metricdata_rec (
  id INT NOT NULL  ,
  metricstatus_id INT NOT NULL ,
  metricdetail_id INT NULL ,
  metric_id INT,
  service_id INT,
  vo_id INT,
  fqan_id INT,
  gatheredat_id INT,
  summarydata VARCHAR(256) NULL ,
  check_time INT NOT NULL ,
  insert_time INT NOT NULL ,
  ggus_ticket_id INT NOT NULL,
  PRIMARY KEY (id),
  CONSTRAINT uk_metricdata_r UNIQUE (id, ggus_ticket_id)
 );

CREATE INDEX metricdata_rec_idx ON metricdata_rec(ggus_ticket_id);

------------------------------------------------------------
-- End: Recomputation - only Oracle version
------------------------------------------------------------