begin
  DBMS_SCHEDULER.create_job (
    job_name        => 'SAM_MS_PERFORMANCE_TUNING',
    job_type        => 'PLSQL_BLOCK',
    job_action      => 'BEGIN metricstore_performance_tuning(); END;',
    start_date      => SYSTIMESTAMP,
    repeat_interval => 'freq=minutely; interval=10; byhour=1',
    end_date        => NULL,
    job_class       => 'SAM_MONITORING_JOBS',
    enabled         => TRUE,
    comments        => 'SAM - METRICSTORE performance tuning');

  --  drop existing job SAM_MS_PURGE_METRICSTORE
  DBMS_SCHEDULER.drop_job (job_name => 'SAM_MS_PURGE_METRICSTORE');
    
  DBMS_SCHEDULER.create_job (
    job_name        => 'SAM_MS_PURGE_METRICSTORE',
    job_type        => 'PLSQL_BLOCK',
    job_action      => 'BEGIN dataloader.purgeMetricstore(6, 1, 12, 7, 7); END;',
    start_date      => SYSTIMESTAMP,
    repeat_interval => 'freq=daily; interval=1; byhour=1',
    end_date        => NULL,
    job_class       => 'SAM_MONITORING_JOBS',
    enabled         => TRUE,
    comments        => 'SAM - Purging Job');    
    
 end;
 /
