create or replace
PROCEDURE metricstore_performance_tuning AS

  schema_name VARCHAR(50) := NULL;
 
BEGIN


  --  gets schema name
  SELECT SYS_CONTEXT ('USERENV', 'CURRENT_SCHEMA') into schema_name FROM DUAL;

  execute immediate('lock table metricdataforrecalculation in exclusive mode' );
  execute immediate('alter table metricdataforrecalculation enable row movement');
  execute immediate('lock table metricdata_spool in exclusive mode' );
  execute immediate('alter table metricdata_spool enable row movement');

  
  execute immediate('alter table metricdataforrecalculation shrink space');
  execute immediate('alter table metricdata_spool shrink space'); 

  
  DBMS_STATS.GATHER_TABLE_STATS (schema_name,'METRICDATA_SPOOL',cascade=>TRUE,no_invalidate=>FALSE);
  DBMS_STATS.GATHER_TABLE_STATS (schema_name,'METRICDATAFORRECALCULATION',cascade=>TRUE,no_invalidate=>FALSE); 

  execute immediate('lock table metricdataforrecalculation in exclusive mode' );
  execute immediate('alter table metricdataforrecalculation disable row movement');
  execute immediate('lock table metricdata_spool in exclusive mode' );
  execute immediate('alter table metricdata_spool disable row movement');
 
 
  execute immediate('alter index ' || schema_name || '.UK_STATUSCHANGE_M_SERV_FQAN rebuild online');
  execute immediate('alter index ' || schema_name || '.UK_STATUSCHANGE_METRIC_SERVICE rebuild online'); 

END;
/