drop table TESTED_SERVICES_FQAN;
drop table STATUSCHANGE_METRIC_SERV_FQAN;
drop table STATUSCHANGE_SERV_PROFILE_FQAN;

drop sequence tested_services_fqan_seq;
drop sequence statuschange_metric_serv_f_seq;
drop sequence statuschange_serv_pr_fqan_seq;
drop view statuschange_serv_profile_fq_l;

create or replace view metric_history_in_profile as
  select profile_name, vo.voname as defined_by_vo, hostname, service_type, service_flavour, metric_exec_time,
    metric_name, fqan, tested_by_vo, metric_status, metric_output_summary, gathered_at, metric_result_insert_time
  from (
    select p.name as profile_name, p.defining_vo_id, s.hostname, st.serviceabbr as service_type, t.flavourname as service_flavour, 
          l.check_time as metric_exec_time, m.name as metric_name, f.name as fqan, v.voname as tested_by_vo, ms.description as metric_status, 
          l.summarydata as metric_output_summary, g.name as gathered_at, l.insert_time as metric_result_insert_time from metricdata l, vo v, fqan f, 
          service s, service_type st, service_type_flavour t, metric m, metricstatus ms, profile p, gatheredat g, profile_metric_map pm
    where 
      g.id = l.gatheredat_id
      and st.id = t.service_type_id
      and ms.id = l.metricstatus_id
      and m.id = l.metric_id
      and t.id = s.flavour_id
      and s.id = l.service_id
      and (f.id(+) = l.fqan_id)  
      and (v.id(+) = l.vo_id)
      and pm.profile_id = p.id
      and pm.service_type_flavour_id = s.flavour_id
      and pm.metric_id = l.metric_id
      and (pm.test_vo_id = l.vo_id or l.vo_id is null)
  ) a, vo
  where a.defining_vo_id = vo.id;
  
CREATE or replace TABLE statuschange_metric_serv_rec (
  id INT NOT NULL,
  metric_id INT NOT NULL,
  service_id INT NOT NULL,
  vo_id INT NULL,
  metricstatus_id INT NOT NULL,
  timestamp INT NOT NULL,
  insert_time INT NOT NULL
  ggus_ticket_id INT NOT NULL,
  PRIMARY KEY (id),
  CONSTRAINT uk_statuschange_met_serv_rec
    UNIQUE (id, ggus_ticket_id)
  );

CREATE INDEX statusch_metric_serv_rec_idx ON statuschange_metric_serv_rec(ggus_ticket_id);