USE mrs; 

ALTER TABLE statuschange_service_profile 
  ADD poem_sync_profile_id INT NULL;
  
ALTER TABLE statuschange_service_profile 
  ADD CONSTRAINT fk_stchg_service_p_poem_prof
  FOREIGN KEY (poem_sync_profile_id)
  REFERENCES poem_sync_profile (id);

CREATE INDEX statuschg_s_p_poem_s_prof_idx ON statuschange_service_profile(poem_sync_profile_id);



ALTER TABLE statuschange_metric_service 
  ADD poem_sync_metric_id INT NULL;
  
ALTER TABLE statuschange_metric_service 
  ADD CONSTRAINT fk_stchg_metric_s_poem_serv
    FOREIGN KEY (poem_sync_metric_id)
      REFERENCES poem_sync_metric (id);
      
CREATE INDEX statuschg_m_s_poem_s_met_idx ON statuschange_metric_service(poem_sync_metric_id);



ALTER TABLE metricdata
  ADD poem_sync_metric_id INT;
      
ALTER TABLE metricdata
  ADD CONSTRAINT fk_metricdata_poem_metrics
  FOREIGN KEY (poem_sync_metric_id)
  REFERENCES poem_sync_metric(id);
      
CREATE INDEX metricdata_p_s_metric_id_idx ON metricdata(poem_sync_metric_id);



ALTER TABLE metricdata_latest
  ADD poem_sync_metric_id INT;
      
ALTER TABLE metricdata_latest
  ADD CONSTRAINT fk_metricdata_l_poem_metrics
  FOREIGN KEY (poem_sync_metric_id)
  REFERENCES poem_sync_metric(id);
      
CREATE INDEX metricdata_l_p_s_metric_id_idx ON metricdata_latest(poem_sync_metric_id);



ALTER TABLE metricdata_spool
  ADD poem_sync_metric_id INT;
      
ALTER TABLE metricdata_spool
  ADD CONSTRAINT fk_metricdata_s_poem_metrics
  FOREIGN KEY (poem_sync_metric_id)
  REFERENCES poem_sync_metric(id);
  

CREATE OR REPLACE VIEW statuschange_service_profile_l_maxtimestamp AS
  SELECT i.service_id, i.profile_id, i.poem_sync_profile_id, MAX(i.timestamp) as max_timestamp
  FROM statuschange_service_profile i
  GROUP BY i.service_id, i.profile_id, i.poem_sync_profile_id;
  
CREATE OR REPLACE VIEW statuschange_service_profile_l AS
  SELECT s.id, s.service_id, s.profile_id, s.poem_sync_profile_id, s.metricstatus_id, s.detail, s.timestamp
  FROM statuschange_service_profile s, statuschange_service_profile_l_maxtimestamp r
  WHERE s.service_id = r.service_id AND s.profile_id = r.profile_id 
  	AND s.timestamp = r.max_timestamp and s.poem_sync_profile_id = r.poem_sync_profile_id;
  	
ALTER TABLE metricstore_curr_load_h_det 
  ADD poem_sync_profile_id INT;
ALTER TABLE metricstore_curr_load_h_det 
  ADD CONSTRAINT metricstore_curr_load_h_d_fk3
  FOREIGN KEY (poem_sync_profile_id)
  REFERENCES poem_sync_profile (id);
CREATE INDEX metricstore_curr_load_h_d_fk3 ON metricstore_curr_load_h_det(poem_sync_profile_id ASC);
ALTER TABLE metricstore_curr_load_h_det DROP INDEX metricstore_curr_load_h_d_uk1;
create UNIQUE INDEX metricstore_curr_load_h_d_uk1 
	on metricstore_curr_load_h_det  (rec_date, hour, ngi_name, profile_id, flavour_id, poem_sync_profile_id);