CREATE INDEX MRS_CURR_LOAD_H_DET_NGI_idx ON METRICSTORE_CURR_LOAD_H_DET(NGI_NAME);
CREATE INDEX MRS_CURR_LOAD_H_DET_PROF_idx ON METRICSTORE_CURR_LOAD_H_DET(PROFILE_ID);
CREATE INDEX MRS_CURR_LOAD_H_DET_FLAV_idx ON METRICSTORE_CURR_LOAD_H_DET(FLAVOUR_ID);
CREATE INDEX MRS_CURR_LOAD_H_DET_REC_D_idx ON METRICSTORE_CURR_LOAD_H_DET(REC_DATE);
CREATE INDEX MRS_CURR_LOAD_H_DET_HOUR_idx ON METRICSTORE_CURR_LOAD_H_DET(HOUR);
CREATE INDEX MRS_CURR_LOAD_H_DET_TIMEST_idx ON METRICSTORE_CURR_LOAD_H_DET(TIMESTAMP);


ALTER TABLE statuschange_service_profile 
  ADD poem_sync_profile_id INT NULL;
  
ALTER TABLE statuschange_service_profile 
  ADD CONSTRAINT fk_stchg_service_p_poem_prof
    FOREIGN KEY (poem_sync_profile_id)
      REFERENCES poem_sync_profile (id);
      
CREATE INDEX statuschg_s_p_poem_s_prof_idx ON statuschange_service_profile(poem_sync_profile_id);

ALTER TABLE statuschange_metric_service 
  ADD poem_sync_metric_id INT NULL;
  
ALTER TABLE statuschange_metric_service 
  ADD CONSTRAINT fk_stchg_metric_s_poem_serv
    FOREIGN KEY (poem_sync_metric_id)
      REFERENCES poem_sync_metric (id);
      
CREATE INDEX statuschg_m_s_poem_s_met_idx ON statuschange_metric_service(poem_sync_metric_id);

CREATE materialized VIEW statuschg_serv_prof_MAXts BUILD immediate REFRESH ON COMMIT AS
SELECT i.service_id, i.profile_id, i.poem_sync_profile_id, MAX(i.timestamp) as max_timestamp
   FROM statuschange_service_profile i
   GROUP BY i.service_id, i.profile_id, i.poem_sync_profile_id;
   
   
CREATE OR REPLACE VIEW statuschange_service_profile_l AS
SELECT s.id, s.service_id, s.profile_id, s.poem_sync_profile_id, s.metricstatus_id, s.detail, s.timestamp
FROM statuschange_service_profile s, statuschg_serv_prof_MAXts r
WHERE s.service_id = r.service_id AND s.profile_id = r.profile_id AND s.poem_sync_profile_id = r.poem_sync_profile_id AND s.timestamp = r.max_timestamp;      
ALTER TABLE metricdata
  ADD poem_sync_metric_id INT;
      
ALTER TABLE metricdata
  ADD CONSTRAINT fk_metricdata_poem_metrics
    FOREIGN KEY (poem_sync_metric_id)
      REFERENCES poem_sync_metric(id);
      
CREATE INDEX metricdata_p_s_metric_id_idx ON metricdata(poem_sync_metric_id);

ALTER TABLE metricdata_latest
  ADD poem_sync_metric_id INT;
      
ALTER TABLE metricdata_latest
  ADD CONSTRAINT fk_metricdata_l_poem_metrics
    FOREIGN KEY (poem_sync_metric_id)
      REFERENCES poem_sync_metric(id);
      
CREATE INDEX metricdata_l_p_s_metric_id_idx ON metricdata_latest(poem_sync_metric_id);         

ALTER TABLE metricdata_spool
  ADD poem_sync_metric_id INT;
      
ALTER TABLE metricdata_spool
  ADD CONSTRAINT fk_metricdata_s_poem_metrics
    FOREIGN KEY (poem_sync_metric_id)
      REFERENCES poem_sync_metric(id);
      
CREATE INDEX metricdata_s_p_s_metric_id_idx ON metricdata_spool(poem_sync_metric_id);

ALTER TABLE metricdata_spool_rejected
  ADD poem_sync_metric_id INT;
  
ALTER TABLE metricdata_rec
  ADD poem_sync_metric_id INT;
  
ALTER TABLE metricdataforrecalculation
  ADD poem_sync_metric_id INT;
  
ALTER TABLE metricdataforrecalculation
  ADD CONSTRAINT fk_metricdata_f_r_poem_metrics
    FOREIGN KEY (poem_sync_metric_id)
      REFERENCES poem_sync_metric(id);
      
CREATE INDEX metricdatafr_p_s_metric_id_idx ON metricdataforrecalculation(poem_sync_metric_id);

ALTER TABLE metricdataforrecalc_rejected
  ADD poem_sync_metric_id INT;
  
ALTER TABLE metricstore_curr_load_h_det 
  ADD poem_sync_profile_id INT NULL;
  
ALTER TABLE metricstore_curr_load_h_det 
  ADD CONSTRAINT fk_metricstore_clhd_poem_prof
    FOREIGN KEY (poem_sync_profile_id)
      REFERENCES poem_sync_profile (id);
      
CREATE INDEX metricstore_clhd_poem_prof_idx ON metricstore_curr_load_h_det(poem_sync_profile_id);
  
create or replace view metric_history_in_poem_s_prof as
  select profile_name, namespace,  vo.voname as defined_by_vo, hostname, service_type, service_flavour, metric_exec_time,
    metric_name, fqan, tested_by_vo, metric_status, metric_output_summary, gathered_at, metric_result_insert_time
  from (
    select pp.name as profile_name, pp.atp_vo_id, s.hostname, st.serviceabbr as service_type, t.flavourname as service_flavour, 
          l.check_time as metric_exec_time, m.name as metric_name, f.name as fqan, v.voname as tested_by_vo, ms.description as metric_status, 
          l.summarydata as metric_output_summary, g.name as gathered_at, l.insert_time as metric_result_insert_time, pn.name as namespace 
          from metricdata l, vo v, fqan f, 
          service s, service_type st, service_type_flavour t, poem_sync_metric m, metricstatus ms, gatheredat g,  
          poem_sync_profile pp, poem_sync_namespace pn, poem_sync_p_m_instances ppm, poem_sync_metricinstance pm
    where 
      g.id = l.gatheredat_id
      and st.id = t.service_type_id
      and ms.id = l.metricstatus_id
      and m.id = l.poem_sync_metric_id
      and t.id = s.flavour_id
      and s.id = l.service_id
      and (f.id(+) = l.fqan_id)  
      and (v.id(+) = l.vo_id)
      and ppm.profile_id = pp.id
      and pm.atp_service_type_flavour_id = s.flavour_id
      and pm.metric_id = l.poem_sync_metric_id
      and (pm.atp_vo_id = l.vo_id or l.vo_id is null)
      and pm.id = ppm.metricinstance_id
      and pp.namespace_id = pn.id
  ) a, vo
  where a.atp_vo_id = vo.id;