USE mrs; 

CREATE INDEX fk_metricdata_sp_poem_metrics ON metricdata_spool(poem_sync_metric_id);

ALTER TABLE statuschange_metric_service DROP INDEX uk_statuschange_metric_service;
create UNIQUE INDEX uk_statuschange_metric_service 
	on statuschange_metric_service (service_id ASC, metric_id ASC, vo_id ASC, timestamp ASC, poem_sync_metric_id ASC);
create INDEX fk_statuschange_m_s_poem_metrics on statuschange_metric_service (poem_sync_metric_id ASC);

create or replace view metric_history_in_poem_s_prof as
	SELECT 
		pp.name profile_name, 
		v.voname defined_by_vo, 
		s.hostname, 
		st.serviceabbr service_type,
  		t.flavourname service_flavour, 
  		md.check_time metric_exec_time,
  		m.name metric_name, 
  		f.name fqan, 
  		v.voname tested_by_vo,
  		ms.description metric_status, 
  		md.summarydata metric_output_summary,
  		g.name gathered_at, 
  		md.insert_time metric_result_insert_time
  	from metricdata md, vo v, fqan f, 
        service s, service_type st, service_type_flavour t, poem_sync_metric m, metricstatus ms, gatheredat g,  
        poem_sync_profile pp, poem_sync_namespace pn, poem_sync_p_m_instances ppm, poem_sync_metricinstance pm
    where 
      	g.id = md.gatheredat_id
      	and st.id = t.service_type_id
      	and ms.id = md.metricstatus_id
      	and s.id = md.service_id
      	and f.id = md.fqan_id
      	and v.id = md.vo_id
      	and m.id = md.poem_sync_metric_id
      	and t.id = s.flavour_id
      	and ppm.profile_id = pp.id
      	and pm.atp_service_type_flavour_id = s.flavour_id
      	and pm.metric_id = md.poem_sync_metric_id
      	and (pm.atp_vo_id = md.vo_id or md.vo_id is null)
      	and pm.id = ppm.metricinstance_id
      	and pp.namespace_id = pn.id;
      	
      	
CREATE TABLE if not exists  mrs_bootstrapper
  (
    service_id INT NOT NULL,
    metric_id INT NOT NULL,
    fqan_id INT,
    vo_id INT,
    timestamp timestamp DEFAULT CURRENT_TIMESTAMP,
    CONSTRAINT bootstrapper_fk1 FOREIGN KEY (service_id) REFERENCES service (id),
    CONSTRAINT bootstrapper_fk2 FOREIGN KEY (metric_id) REFERENCES poem_sync_metric (id),
    CONSTRAINT bootstrapper_fk3 FOREIGN KEY (fqan_id) REFERENCES poem_sync_fqan (id),
    CONSTRAINT bootstrapper_fk4 FOREIGN KEY (vo_id) REFERENCES vo (id)
  )
  ENGINE = InnoDB;  
  
CREATE TABLE if not exists mrs_bootstrapper_history
  (
    service_id INT NOT NULL,
    metric_id INT NOT NULL,
    fqan_id INT,
    vo_id INT,
    timestamp timestamp DEFAULT CURRENT_TIMESTAMP,
    operation varchar(256),
    CONSTRAINT bootstrapper_h_fk1 FOREIGN KEY (service_id) REFERENCES service (id),
    CONSTRAINT bootstrapper_h_fk2 FOREIGN KEY (metric_id) REFERENCES poem_sync_metric (id),
    CONSTRAINT bootstrapper_h_fk3 FOREIGN KEY (fqan_id) REFERENCES poem_sync_fqan (id),
    CONSTRAINT bootstrapper_h_fk4 FOREIGN KEY (vo_id) REFERENCES vo (id)
  )
  ENGINE = InnoDB;


 drop table if exists mon_frequency_statistics;  
 
 ALTER TABLE metricdata MODIFY poem_sync_metric_id int NOT NULL ;  	
 ALTER TABLE metricdata_spool MODIFY poem_sync_metric_id int NOT NULL ;
 ALTER TABLE statuschange_service_profile MODIFY poem_sync_profile_id int NOT NULL ;
 ALTER TABLE metricdata_latest MODIFY poem_sync_metric_id int NOT NULL ;
 ALTER TABLE statuschange_metric_service MODIFY poem_sync_metric_id int NOT NULL ;
 
 drop table if exists metrics_in_supported_services;
 drop table if exists metrics_in_supp_serv_history;
 drop table if exists metrics_in_supp_serv_rejected;
 drop table if exists fqans_in_supported_services;
 drop view if exists fqans_in_regions;
 drop table if exists fqans_in_supp_serv_history;
 drop table if exists fqans_in_supp_serv_rejected;
 