DROP TABLE METRICGROUP_OSG;
DROP SEQUENCE METRICGROUP_OSGSeq;
DROP TABLE METRICDESCRIPTION_OSG;
DROP SEQUENCE METRICDESCRIPTION_OSGSeq;
DROP VIEW V_METRICDESCRIPTION_OSG;
alter table statuschange_service_profile drop column fqan_id;

alter table metricdata drop constraint uk_metricdata;
alter table metricdata 
	add CONSTRAINT uk_metricdata 
	UNIQUE (metricstatus_id, metric_id, service_id, vo_id, check_time, poem_sync_metric_id);
	
alter table statuschange_service_profile drop CONSTRAINT uk_statuschange_service_prof;
alter table statuschange_service_profile
	add CONSTRAINT uk_statuschange_service_prof
    UNIQUE (service_id, profile_id, timestamp, poem_sync_profile_id);
alter table statuschange_service_profile drop CONSTRAINT uk_statuschange_service_p;
alter table statuschange_service_profile
	add CONSTRAINT uk_statuschange_service_p 
	UNIQUE (service_id, profile_id, metricstatus_id, timestamp, poem_sync_profile_id);
	
alter table metricdata_latest drop CONSTRAINT uk_metricdata_l;
alter table metricdata_latest 
	add CONSTRAINT uk_metricdata_l 
	UNIQUE (metricstatus_id, metric_id, service_id, vo_id, check_time, poem_sync_metric_id);
	
alter table statuschange_metric_service drop CONSTRAINT uk_statuschange_metric_service;
alter table statuschange_metric_service 
	add CONSTRAINT uk_statuschange_metric_service
	UNIQUE (service_id, metric_id, vo_id, timestamp, poem_sync_metric_id);
	
alter table metricstore_curr_load_h_det drop CONSTRAINT METRICSTORE_CURR_LOAD_H_D_UK1;
alter table metricstore_curr_load_h_det 
	add CONSTRAINT METRICSTORE_CURR_LOAD_H_D_UK1 
    UNIQUE (REC_DATE, HOUR, NGI_NAME, PROFILE_ID, FLAVOUR_ID, poem_sync_profile_id);
    
alter SEQUENCE logger_seq
  CACHE 20;
  
alter SEQUENCE MetricDetailsSeq
  CACHE 50;
  
alter SEQUENCE MetricDataSeq
  CACHE 50;
  
alter SEQUENCE StatusChange_ServiceProfileSeq
  CACHE 20;
  
alter SEQUENCE MetricData_LatestSeq
  CACHE 20;
  
alter SEQUENCE MetricData_RejectedSeq
  CACHE 50;
  
alter SEQUENCE TestedServicesSeq
  CACHE 20;
  
alter SEQUENCE MetricData_SpoolSeq
  CACHE 50;
  
alter SEQUENCE metrics_in_supp_services_seq
  CACHE 20;
  
alter SEQUENCE metrics_in_supp_serv_his_seq
  CACHE 20;
  
alter SEQUENCE metrics_in_supp_serv_rej_seq
  CACHE 20;
  
alter SEQUENCE statuschange_metric_s_seq
  CACHE 20;
  
alter SEQUENCE METRICSTORE_CURR_LOAD_H_SEQ
  CACHE 20;
  
alter SEQUENCE METRICSTORE_CURR_LOAD_M_SEQ
  CACHE 20;
  
alter SEQUENCE METRICSTORE_CURR_LOAD_H_D_SEQ
  CACHE 20;
  
alter SEQUENCE MetricData_RejectedOSGSeq
  CACHE 20;
  
------------------------------------------------------------
-- Begin: Bootstrapping
------------------------------------------------------------

CREATE TABLE mrs_bootstrapper
  (
    service_id INT NOT NULL,
    metric_id INT NOT NULL,
    fqan_id INT,
    vo_id INT,
    timestamp timestamp DEFAULT CURRENT_TIMESTAMP,
    CONSTRAINT bootstrapper_fk1 FOREIGN KEY (service_id) REFERENCES service (id),
    CONSTRAINT bootstrapper_fk2 FOREIGN KEY (metric_id) REFERENCES poem_sync_metric (id),
    CONSTRAINT bootstrapper_fk3 FOREIGN KEY (fqan_id) REFERENCES poem_sync_fqan (id),
    CONSTRAINT bootstrapper_fk4 FOREIGN KEY (vo_id) REFERENCES vo (id)
  );
  
CREATE TABLE mrs_bootstrapper_history
  (
    service_id INT NOT NULL,
    metric_id INT NOT NULL,
    fqan_id INT,
    vo_id INT,
    timestamp timestamp DEFAULT CURRENT_TIMESTAMP,
    operation varchar(256),
    CONSTRAINT bootstrapper_h_fk1 FOREIGN KEY (service_id) REFERENCES service (id),
    CONSTRAINT bootstrapper_h_fk2 FOREIGN KEY (metric_id) REFERENCES poem_sync_metric (id),
    CONSTRAINT bootstrapper_h_fk3 FOREIGN KEY (fqan_id) REFERENCES poem_sync_fqan (id),
    CONSTRAINT bootstrapper_h_fk4 FOREIGN KEY (vo_id) REFERENCES vo (id)
  );
  
------------------------------------------------------------
-- End: Bootstrapping
------------------------------------------------------------


------------------------------------------------------------
-- Begin: Recomputation - only Oracle version
------------------------------------------------------------

CREATE TABLE statuschange_metric_serv_rec (
  id INT NOT NULL,
  metric_id INT NOT NULL,
  service_id INT NOT NULL,
  vo_id INT NULL,
  metricstatus_id INT NOT NULL,
  timestamp INT NOT NULL,
  insert_time INT NOT NULL,
  ggus_ticket_id INT NOT NULL,
  PRIMARY KEY (id),
  CONSTRAINT uk_statuschange_met_serv_rec
    UNIQUE (id, ggus_ticket_id)
  );

CREATE INDEX statusch_metric_serv_rec_idx ON statuschange_metric_serv_rec(ggus_ticket_id);

------------------------------------------------------------
-- End: Recomputation - only Oracle version
------------------------------------------------------------

-- for LCG_SAM_MS_PILOT_W you have to do the following:
-- revoke EXECUTE ON getFreshMetrics TO LCG_SAM_MS_PILOT_W;
-- revoke SELECT ON tmpFreshMetrics TO LCG_SAM_MS_PILOT_W;

-- the following has to be done as LCG_SAM_MS_PILOT_W in LCG_SAM_MS_PILOT_W:
-- drop SYNONYM getFreshMetrics FOR LCG_SAM_MS_PILOT.getFreshMetrics;
-- drop SYNONYM tmpFreshMetrics FOR LCG_SAM_MS_PILOT.tmpFreshMetrics;

drop table tmpJoinProfile;
drop table tmpFilteredMetrics;
drop table tmpMetricsCount;
drop table tmpFreshMetrics;

drop type freq_table;
drop type freq_rec;

drop table mon_frequency_statistics;

drop table metrics_in_supported_services;
drop sequence metrics_in_supp_services_seq;
drop table metrics_in_supp_serv_history;
drop sequence metrics_in_supp_serv_his_seq;
drop table metrics_in_supp_serv_rejected;
drop sequence metrics_in_supp_serv_rej_seq;
drop table fqans_in_supported_services;
drop view fqans_in_regions;
drop sequence fqans_in_supported_s_seq;
drop table fqans_in_supp_serv_rejected;
drop sequence fqans_in_supp_serv_r_seq;
