USE mrs; 

alter table metricdata drop foreign key fk_metricdata_sam_metrics;
drop index fk_metricdata_sam_metrics on metricdata;
alter table metricdata drop column metric_id;

alter table metricdata_spool drop foreign key fk_metricdata_sp_metrics;
drop index fk_metricdata_sp_metrics on metricdata_spool;
alter table metricdata_spool drop column metric_id;

alter table statuschange_service_profile drop foreign key fk_statuschange_service_p_profiles;
drop index uk_statuschange_service_profile on statuschange_service_profile;
create unique index uk_statuschange_service_profile
    on statuschange_service_profile (service_id, poem_sync_profile_id, timestamp);
alter table statuschange_service_profile drop column profile_id;

alter table metricdata_latest drop foreign key fk_metricdata_latest_metrics;
drop index fk_metricdata_latest_metrics on metricdata_latest;
alter table metricdata_latest drop column metric_id;

alter table statuschange_metric_service drop foreign key fk_statuschange_metric_s_metrics;
drop index fk_statuschange_metric_s_metrics on statuschange_metric_service;
drop index uk_statuschange_metric_service on statuschange_metric_service;
create unique index uk_statuschange_metric_service
	on statuschange_metric_service  (service_id ASC, vo_id ASC, timestamp ASC, poem_sync_metric_id ASC);
alter table statuschange_metric_service drop column metric_id;

alter table metricstore_curr_load_h_det drop foreign key metricstore_curr_load_h_d_fk1;
drop index  metricstore_curr_load_h_d_uk1 on metricstore_curr_load_h_det;
create unique index metricstore_curr_load_h_d_uk1 
	on metricstore_curr_load_h_det (rec_date, hour, ngi_name, flavour_id, poem_sync_profile_id);
alter table metricstore_curr_load_h_det drop column profile_id;


drop  view metric_history_in_profile;

CREATE OR REPLACE VIEW statuschange_service_profile_l_maxtimestamp AS
  SELECT i.service_id,  i.poem_sync_profile_id, MAX(i.timestamp) as max_timestamp
  FROM statuschange_service_profile i
  GROUP BY i.service_id, i.poem_sync_profile_id;
  

CREATE OR REPLACE VIEW statuschange_service_profile_l AS
  SELECT s.id, s.service_id,  s.poem_sync_profile_id, s.metricstatus_id, s.detail, s.timestamp
  FROM statuschange_service_profile s, statuschange_service_profile_l_maxtimestamp r
  WHERE s.service_id = r.service_id 
  	AND s.timestamp = r.max_timestamp 
  	and s.poem_sync_profile_id = r.poem_sync_profile_id;
  	
drop table tested_services;

CREATE TABLE IF NOT EXISTS metricdata_spool_rejected (
  id INT NOT NULL AUTO_INCREMENT,
  fqan_id INT,
  gatheredat_id INT,
  metricstatus_id INT NOT NULL,
  detailsdata text,
  service_id INT NOT NULL,
  vo_id INT,
  summarydata VARCHAR(256) NULL,
  check_time INT NOT NULL,
  insert_time INT NOT NULL,
  poem_sync_metric_id INT NOT NULL,
  PRIMARY KEY (id),
  CONSTRAINT fk_metricdata_spool_r_fqan_id
    FOREIGN KEY (fqan_id)
    REFERENCES fqan (id)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_metricdata_spr_gatheredat_id 
    FOREIGN KEY (gatheredat_id)
    REFERENCES gatheredat (id)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_metricdata_spr_nodes
    FOREIGN KEY (service_id)
    REFERENCES service (id)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_metricdata_spr_vos
    FOREIGN KEY (vo_id)
    REFERENCES vo (id)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_metricdata_spr_metricstatus
    FOREIGN KEY (metricstatus_id)
    REFERENCES metricstatus (id )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_metricdata_sr_poem_metrics
    FOREIGN KEY (poem_sync_metric_id)
    REFERENCES poem_sync_metric(id)
) ENGINE = InnoDB ;






