DELIMITER //

USE `mrs`;

DROP TRIGGER IF EXISTS load_metricdata_fer;

CREATE TRIGGER load_metricdata_fer

AFTER INSERT ON metricdata FOR EACH ROW

BEGIN
  DECLARE v_check_time INT;
  DECLARE done INT DEFAULT 0;
  DECLARE metric_curs CURSOR FOR SELECT check_time FROM metricdata_latest 
    WHERE ((fqan_id <=> NEW.fqan_id ) or (fqan_id is NULL)) AND vo_id <=> NEW.vo_id 
      AND poem_sync_metric_id <=> NEW.poem_sync_metric_id AND service_id <=> NEW.service_id;
  DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = 1;

  OPEN metric_curs;
  FETCH metric_curs INTO v_check_time;
  CLOSE metric_curs;

  IF ((v_check_time IS NOT NULL) AND (v_check_time <= NEW.check_time)) THEN

    DELETE FROM metricdata_latest WHERE ((fqan_id <=> NEW.fqan_id) or (fqan_id is NULL)) 
     AND vo_id <=> NEW.vo_id AND poem_sync_metric_id <=> NEW.poem_sync_metric_id AND service_id <=> NEW.service_id;
    INSERT INTO metricdata_latest(metricstatus_id, metricdetail_id, poem_sync_metric_id, service_id, fqan_id, vo_id, summarydata, gatheredat_id, check_time, insert_time)
    VALUES (NEW.metricstatus_id, NEW.metricdetail_id, NEW.poem_sync_metric_id, NEW.service_id, NEW.fqan_id, NEW.vo_id, NEW.summarydata, NEW.gatheredat_id, NEW.check_time, NEW.insert_time);
  ELSEIF (v_check_time IS NULL) THEN 
    INSERT INTO metricdata_latest(metricstatus_id, metricdetail_id, poem_sync_metric_id, service_id, fqan_id, vo_id, summarydata, gatheredat_id, check_time, insert_time)
    VALUES (NEW.metricstatus_id, NEW.metricdetail_id, NEW.poem_sync_metric_id, NEW.service_id, NEW.fqan_id, NEW.vo_id, NEW.summarydata, NEW.gatheredat_id, NEW.check_time, NEW.insert_time);
  END IF;

END //

DELIMITER ;
