create or replace
trigger load_metricdata_fer
  after insert on metricdata for each row

DECLARE

  CURSOR metric_curs IS SELECT check_time FROM metricdata_latest
    WHERE ((nvl(fqan_id, -1) = nvl(:NEW.fqan_id, -1)) or (fqan_id is NULL))
      AND poem_sync_metric_id = :NEW.poem_sync_metric_id AND service_id = :NEW.service_id;

  v_check_time INTEGER;

BEGIN

  OPEN metric_curs;
  FETCH metric_curs INTO v_check_time;
  CLOSE metric_curs;

  IF ((v_check_time IS NOT NULL) AND (v_check_time <= :NEW.check_time)) THEN

    DELETE FROM metricdata_latest WHERE ((nvl(fqan_id, -1) = nvl(:NEW.fqan_id, -1)) or (fqan_id is NULL)) 
      AND nvl(vo_id, -1) = nvl(:NEW.vo_id, -1)
      AND poem_sync_metric_id = :NEW.poem_sync_metric_id AND service_id = :NEW.service_id;
    INSERT INTO metricdata_latest(id, metricstatus_id, metricdetail_id, service_id, fqan_id, vo_id, summarydata, gatheredat_id, check_time, insert_time, poem_sync_metric_id)
    VALUES (MetricData_LatestSeq.nextval, :NEW.metricstatus_id, :NEW.metricdetail_id, :NEW.service_id, :NEW.fqan_id, :NEW.vo_id, :NEW.summarydata, :NEW.gatheredat_id, :NEW.check_time, :NEW.insert_time, :NEW.poem_sync_metric_id);
  ELSIF (v_check_time IS NULL) THEN
    INSERT INTO metricdata_latest(id, metricstatus_id, metricdetail_id, service_id, fqan_id, vo_id, summarydata, gatheredat_id, check_time, insert_time, poem_sync_metric_id)
    VALUES (MetricData_LatestSeq.nextval, :NEW.metricstatus_id, :NEW.metricdetail_id, :NEW.service_id, :NEW.fqan_id, :NEW.vo_id, :NEW.summarydata, :NEW.gatheredat_id, :NEW.check_time, :NEW.insert_time, :NEW.poem_sync_metric_id);
  END IF;


END;
/