USE mrs;

create or replace view metric_history_in_poem_s_prof as
   SELECT                                                                                                             
       pp.name profile_name,                                                    
       pn.name namespace,                                                       
       getVoName(pp.atp_vo_id) defined_by_vo,                                   
       s.hostname,                                                              
       t.flavourname service_flavour,                                           
       md.check_time metric_exec_time,                                          
       m.name metric_name,                                                      
       f.name fqan,                                                             
       v.voname tested_by_vo,                                                   
       ms.description metric_status,                                            
       md.summarydata metric_output_summary,                                    
       g.name gathered_at,                                                      
       md.insert_time metric_result_insert_time                                 
   from                                                                         
       service s, service_type_flavour t,                                       
       poem_sync_metric m, metricstatus ms,                                     
       poem_sync_profile pp, poem_sync_namespace pn,                            
       poem_sync_p_m_instances ppm, poem_sync_metricinstance pm,                
       vo v right outer join metricdata md on v.id = md.vo_id                   
       left outer join fqan f on md.fqan_id = f.id                              
       left outer join gatheredat g on g.id = md.gatheredat_id                  
   where                                                                        
       ms.id = md.metricstatus_id                                               
       and s.id = md.service_id                                                 
       and m.id = md.poem_sync_metric_id                                        
       and t.id = s.flavour_id                                                  
       and ppm.profile_id = pp.id                                               
       and pm.atp_service_type_flavour_id = s.flavour_id                        
       and pm.metric_id = md.poem_sync_metric_id                                
       and (pm.atp_vo_id = md.vo_id or md.vo_id is null)                        
       and pm.id = ppm.metricinstance_id                                        
       and pp.namespace_id = pn.id;
