use mrs; 

alter table statuschange_service_profile 
  add CONSTRAINT uk_statuschange_service_profile
    UNIQUE KEY (service_id, profile_id, timestamp);

alter table metricstatus
  add comments varchar(45);

update metricstatus set comments = comment;

alter table statuschange_service_profile
  modify detail varchar(256) null;

create table if not exists dataloader_lastchecktime
(
  check_time int not null,
  constraint uk_dataloader_lastchecktime unique (check_time)
) ENGINE = InnoDB;

create table if not exists gatheredat
(
  id int auto_increment not null,
  name varchar(256),
  primary key(id)  
) ENGINE = InnoDB;

CREATE TABLE IF NOT EXISTS metricdata_spool (
  id INT NOT NULL AUTO_INCREMENT,
  gatheredat_id INT,
  metricstatus_id INT NOT NULL,
  detailsdata text,
  metric_id INT NOT NULL,
  service_id INT NOT NULL,
  vo_id INT,
  summarydata VARCHAR(256) NULL,
  check_time INT NOT NULL,
  insert_time INT NOT NULL,
  PRIMARY KEY (id),
  INDEX fk_metricdata_sp_gatheredat_id (gatheredat_id ASC),
  INDEX fk_metricdata_sp_metrics (metric_id ASC),
  INDEX fk_metricdata_sp_nodes (service_id ASC),
  INDEX fk_metricdata_sp_vos (vo_id ASC),
  INDEX fk_metricidata_sp_metricstatus (metricstatus_id ASC),
  INDEX fk_metricdata_sp_check_time (check_time ASC),
  
  CONSTRAINT fk_metricdata_sp_gatheredat_id 
    FOREIGN KEY (gatheredat_id)
    REFERENCES gatheredat (id)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_metricdata_sp_metrics
    FOREIGN KEY (metric_id )
    REFERENCES metric (id)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_metricdata_sp_nodes
    FOREIGN KEY (service_id)
    REFERENCES service (id)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_metricdata_sp_vos
    FOREIGN KEY (vo_id)
    REFERENCES vo (id)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_metricdata_sp_metricstatus
    FOREIGN KEY (metricstatus_id)
    REFERENCES metricstatus (id )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION
) ENGINE = InnoDB;

ALTER TABLE metricdata_latest
  ADD gatheredat_id INT;
  
ALTER TABLE metricdata_latest  
  ADD INDEX fk_metricdata_latest_gatheredat_id (gatheredat_id ASC);


ALTER TABLE metricdata_latest  
  ADD CONSTRAINT fk_metricdata_latest_gatheredat_id 
    FOREIGN KEY  (gatheredat_id)
    REFERENCES gatheredat (id )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION;


ALTER TABLE metricdata
  ADD gatheredat_id INT;
  
ALTER TABLE metricdata  
  ADD INDEX fk_metricdata_gatheredat_id (gatheredat_id ASC);
  
  
ALTER TABLE metricdata  
  ADD CONSTRAINT `fk_metricdata_gatheredat_id`
    FOREIGN KEY (`gatheredat_id`)
    REFERENCES `gatheredat` (`id` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION;    

    
ALTER TABLE metricdata_rejected
  ADD gatheredat VARCHAR(255);

/*Added 28.01.2010*/

CREATE TABLE IF NOT EXISTS supported_sites (
  id INT AUTO_INCREMENT NOT NULL,
  site_id INT NOT NULL,
  insert_time INT NOT NULL ,
  PRIMARY KEY (id),
  INDEX `fkSupported_sites` (`site_id` ASC) ,
  CONSTRAINT `uk_supported_sites`
    UNIQUE KEY (`site_id`),
  CONSTRAINT `fkSupported_sites`
    FOREIGN KEY (`site_id` )
       REFERENCES `site` (`id` )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION
)
ENGINE=INNODB;

CREATE TABLE IF NOT EXISTS supported_rocs (
  id INT AUTO_INCREMENT NOT NULL,
  name VARCHAR(256) NOT NULL,
  insert_time INT NOT NULL ,
  PRIMARY KEY (id),
  CONSTRAINT `uk_supported_rocs`
    UNIQUE KEY (`name`)
)
ENGINE=INNODB;

CREATE TABLE IF NOT EXISTS supported_vos (
  id INT AUTO_INCREMENT NOT NULL,
  name VARCHAR(256) NOT NULL,
  insert_time INT NOT NULL ,
  PRIMARY KEY (id),
  CONSTRAINT `uk_supported_vos`
    UNIQUE KEY (`name`)
)
ENGINE=INNODB;

DROP TABLE IF EXISTS supportedVos;

CREATE TABLE IF NOT EXISTS supported_profiles (
  id INT AUTO_INCREMENT NOT NULL,
  name VARCHAR(256) NOT NULL,
  insert_time INT NOT NULL ,
  PRIMARY KEY (id),
  CONSTRAINT `uk_supported_profiles`
    UNIQUE KEY (`name`)
)
ENGINE=INNODB;

