DROP TABLE METRICDATA_LATEST_TMP;

alter table statuschange_service_profile
  add CONSTRAINT uk_statuschange_service_prof
    UNIQUE (service_id, profile_id, timestamp);

CREATE TABLE statuschangeRecalculated (
  id INT NOT NULL,
  statuschange_service_id INT NULL,
  insert_time INT,
  PRIMARY KEY (id),
  CONSTRAINT uk_statuschangeRecalculated UNIQUE (statuschange_service_id)
);

CREATE SEQUENCE statuschangeRecalculatedSeq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

alter table METRICSTATUS
  add comments VARCHAR2(45);

update metricstatus set comments = "comment";

alter table STATUSCHANGE_SERVICE_PROFILE
  modify detail VARCHAR2(256) NULL;

CREATE TABLE DataLoader_LastCheckTime
(
  check_time INT NOT NULL,
  CONSTRAINT uk_DataLoader_LastCheckTime UNIQUE (check_time)
);

CREATE TABLE MetricDataForRecalculation
(
  ID INT NOT NULL,
  MetricData_Spool_id INT NOT NULL,
  SERVICEFLAVOUR VARCHAR2(256),
  METRICNAME NVARCHAR2(256),
  METRICSTATUS VARCHAR2(45),
  SUMMARYDATA VARCHAR2(256),
  DETAILSDATA CLOB,
  VONAME VARCHAR2(256),
  HOSTNAME VARCHAR2(512),
  SERVICEURI VARCHAR2(256),
  check_time INT,
  insert_time INT,
  CONSTRAINT uk_MetricDataForRecalculation UNIQUE (MetricData_Spool_id)
);

CREATE SEQUENCE MetricDataForRecalculationSeq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE OR REPLACE TRIGGER MetricData_ForRec_trig BEFORE INSERT ON MetricDataForRecalculation
FOR EACH ROW
BEGIN
SELECT MetricDataForRecalculationSeq.NEXTVAL into :new.id FROM dual;
END;
/

CREATE TABLE MetricData_Spool
(
  ID INT NOT NULL,
  SERVICEFLAVOUR VARCHAR2(256),
  METRICNAME NVARCHAR2(256),
  METRICSTATUS VARCHAR2(45),
  SUMMARYDATA VARCHAR2(256),
  DETAILSDATA CLOB,
  VONAME VARCHAR2(256),
  HOSTNAME VARCHAR2(512),
  SERVICEURI VARCHAR2(256),
  check_time INT,
  insert_time INT
);


CREATE SEQUENCE MetricData_SpoolSeq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  noCYCLE;
