use mrs; 

alter table metricstatus drop column comment;

/*Added 11.03.2010*/
DROP TABLE IF EXISTS supported_rocs;

DROP TABLE IF EXISTS supported_sites;

DROP TABLE IF EXISTS fqan;

CREATE TABLE IF NOT EXISTS fqan (
  id INT(11) NOT NULL AUTO_INCREMENT ,
  name VARCHAR(256) NOT NULL ,
  PRIMARY KEY (id) )
ENGINE = InnoDB;

DROP TABLE IF EXISTS metrics_in_supported_services;

CREATE  TABLE IF NOT EXISTS metrics_in_supported_services (
  id INT(11) NOT NULL AUTO_INCREMENT ,
  service_id INT NOT NULL ,
  metric_id INT NOT NULL ,
  vo_id INT NULL ,
  fqan_id INT NULL ,
  profile_id INT NOT NULL ,
  timestamp INT NULL,
  updated tinyint(1) NULL,
  PRIMARY KEY (id),
  UNIQUE INDEX uk_supported_services (service_id ASC, metric_id ASC, vo_id ASC, fqan_id ASC, profile_id ASC),
  INDEX fk_metrics_in_supp_service (service_id ASC),
  INDEX fk_metrics_in_supp_metric (metric_id ASC),
  INDEX fk_metrics_in_supp_vo (vo_id ASC),
  INDEX fk_metrics_in_supp_fqan (fqan_id ASC),
  INDEX fk_metrics_in_supp_profile (profile_id ASC),
  CONSTRAINT fk_metrics_in_supp_service
    FOREIGN KEY (service_id )
    REFERENCES service (id )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_metrics_in_supp_metric
    FOREIGN KEY (metric_id )
    REFERENCES metric (id )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_metrics_in_supp_vo
    FOREIGN KEY (vo_id )
    REFERENCES vo (id )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_metrics_in_supp_fqan
    FOREIGN KEY (fqan_id )
    REFERENCES fqan (id )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_metrics_in_supp_profile
    FOREIGN KEY (profile_id )
    REFERENCES profile (id )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION
 )
ENGINE = InnoDB;

DROP TABLE IF EXISTS metrics_in_supp_serv_history;

CREATE TABLE IF NOT EXISTS metrics_in_supp_serv_history (
  id INT(11) NOT NULL AUTO_INCREMENT,
  service_id INT NOT NULL,
  metric_id INT NOT NULL,
  vo_id INT NULL,
  fqan_id INT NULL,
  profile_id INT NOT NULL,
  operation ENUM ('insert', 'delete') NOT NULL,
  timestamp INT NULL,
  PRIMARY KEY (id),
  UNIQUE INDEX uk_supported_services_hist (service_id ASC, metric_id ASC, vo_id ASC, fqan_id ASC, profile_id ASC, operation ASC, timestamp ASC),
  INDEX fk_metrics_in_supp_h_service (service_id ASC),
  INDEX fk_metrics_in_supp_h_metric (metric_id ASC),
  INDEX fk_metrics_in_supp_h_vo (vo_id ASC),
  INDEX fk_metrics_in_supp_h_fqan (fqan_id ASC),
  INDEX fk_metrics_in_supp_h_profile (profile_id ASC),
  CONSTRAINT fk_metrics_in_supp_h_service
    FOREIGN KEY (service_id )
    REFERENCES service (id )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_metrics_in_supp_h_metric
    FOREIGN KEY (metric_id )
    REFERENCES metric (id )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_metrics_in_supp_h_vo
    FOREIGN KEY (vo_id )
    REFERENCES vo (id )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_metrics_in_supp_h_fqan
    FOREIGN KEY (fqan_id )
    REFERENCES fqan (id )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_metrics_in_supp_h_profile
    FOREIGN KEY (profile_id )
    REFERENCES profile (id )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION
 )
ENGINE = InnoDB;

DROP TABLE IF EXISTS metrics_in_supp_serv_rejected;

CREATE  TABLE IF NOT EXISTS metrics_in_supp_serv_rejected (
  id INT(11) NOT NULL AUTO_INCREMENT ,
  service_type_flavour VARCHAR(256) NULL ,
  hostname VARCHAR(256) NULL ,
  metric_name VARCHAR(256) NULL ,
  vo VARCHAR(256) NULL ,
  fqan VARCHAR(256) NULL ,
  profile VARCHAR(256) NULL ,
  timestamp INT NULL,
  reason VARCHAR(256) NULL,
  PRIMARY KEY (id)
 )
ENGINE = InnoDB;

alter table metricdata
  add fqan_id INT;

alter table metricdata 
  ADD INDEX fk_metricdata_fqan_id (fqan_id ASC);

alter table metricdata 
  ADD CONSTRAINT fk_metricdata_fqan_id
    FOREIGN KEY (fqan_id)
    REFERENCES fqan (id)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION;

alter table metricdata_latest
  add fqan_id INT;

alter table metricdata_latest 
  ADD INDEX fk_metricdata_latest_fqan_id (fqan_id ASC);

alter table metricdata_latest
  ADD CONSTRAINT fk_metricdata_latest_fqan_id
    FOREIGN KEY (fqan_id)
    REFERENCES fqan (id)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION;

alter table metricdata_spool
  add fqan_id INT;

alter table metricdata_spool 
  ADD INDEX fk_metricdata_spool_fqan_id (fqan_id ASC);

alter table metricdata_spool
  ADD CONSTRAINT fk_metricdata_spool_fqan_id
    FOREIGN KEY (fqan_id)
    REFERENCES fqan (id)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION;

alter table metricdata_rejected
  add fqan VARCHAR(256);

alter table statuschange_service_profile
  add fqan_id INT;

alter table statuschange_service_profile 
  ADD INDEX fk_stch_serv_profile_fqan_id (fqan_id ASC);

alter table statuschange_service_profile
  ADD CONSTRAINT fk_stch_serv_profile_fqan_id 
    FOREIGN KEY (fqan_id)
    REFERENCES fqan (id)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION;


CREATE TABLE IF NOT EXISTS statuschange_metric_service (
  id INT(11) NOT NULL AUTO_INCREMENT ,
  metric_id INT(11) NOT NULL ,
  service_id INT(11) NOT NULL ,
  vo_id INT(11) NULL ,
  metricstatus_id INT(11) NOT NULL ,
  timestamp INT(11) NOT NULL ,
  PRIMARY KEY (id) ,
  UNIQUE INDEX uk_statuschange_metric_service (service_id ASC, metric_id ASC, vo_id ASC, timestamp ASC) ,
  INDEX fk_statuschange_metric_s_metrics (metric_id ASC),
  INDEX fk_statuschange_metric_s_metricstatus (metricstatus_id ASC),
  INDEX fk_statuschange_metric_s_services (service_id ASC),
  INDEX fk_statuschange_metric_s_vos (vo_id ASC),
  CONSTRAINT fk_statuschange_metric_s_metrics
    FOREIGN KEY (metric_id )
    REFERENCES metric (id )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_statuschange_metric_s_metricstatus
    FOREIGN KEY (metricstatus_id )
    REFERENCES metricstatus (id )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_statuschange_metric_s_services
    FOREIGN KEY (service_id )
    REFERENCES service (id )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_statuschange_metric_s_vos
    FOREIGN KEY (vo_id)
    REFERENCES vo (id)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;

CREATE TABLE IF NOT EXISTS statuschange_metric_serv_fqan (
  id INT(11) NOT NULL AUTO_INCREMENT,
  fqan_id INT(11) NULL,
  metric_id INT(11) NOT NULL,
  service_id INT(11) NOT NULL,
  vo_id INT(11) NULL,
  metricstatus_id INT(11) NOT NULL,
  timestamp INT(11) NOT NULL,
  PRIMARY KEY (id),
  UNIQUE INDEX uk_statuschange_metric_serv_fqan (service_id ASC, metric_id ASC, fqan_id ASC, timestamp ASC),
  INDEX fk_statuschange_m_s_fqan_fqan (fqan_id ASC),
  INDEX fk_statuschange_m_s_fqan_metrics (metric_id ASC),
  INDEX fk_statuschange_m_s_fqan_metricstatus (metricstatus_id ASC),
  INDEX fk_statuschange_m_s_fqan_services (service_id ASC),
  INDEX fk_statuschange_m_s_fqan_vos (vo_id ASC),
  CONSTRAINT fk_statuschange_m_s_fqan_fqan
    FOREIGN KEY (fqan_id)
    REFERENCES fqan (id)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_statuschange_m_s_fqan_metrics
    FOREIGN KEY (metric_id )
    REFERENCES metric (id )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_statuschange_m_s_fqan_metricstatus
    FOREIGN KEY (metricstatus_id )
    REFERENCES metricstatus (id )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_statuschange_m_s_fqan_services
    FOREIGN KEY (service_id )
    REFERENCES service (id )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_statuschange_m_s_fqan_vos
    FOREIGN KEY (vo_id)
    REFERENCES vo (id)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;

CREATE TABLE IF NOT EXISTS statuschange_serv_profile_fqan (
  id INT NOT NULL AUTO_INCREMENT,
  fqan_id INT NOT NULL,
  service_id INT NOT NULL,
  profile_id INT NOT NULL,
  metricstatus_id INT NOT NULL DEFAULT 0,
  timestamp INT NOT NULL,
  PRIMARY KEY (id),
  INDEX fk_statusch_service_p_f_fqan (fqan_id ASC),
  INDEX fk_statusch_service_p_f_services (service_id ASC),
  INDEX fk_statusch_service_p_f_profiles (profile_id ASC),
  INDEX fk_statusch_service_p_f_metricstatus (metricstatus_id ASC),
  CONSTRAINT uk_statusch_service_p_frofile
    UNIQUE KEY (fqan_id, service_id, profile_id, timestamp),
  CONSTRAINT fk_statusch_service_p_f_fqan 
    FOREIGN KEY (fqan_id)
    REFERENCES fqan(id)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_statusch_service_p_f_metricstatus
    FOREIGN KEY (metricstatus_id )
    REFERENCES metricstatus (id )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_statusch_service_p_f_services
    FOREIGN KEY (service_id )
    REFERENCES service (id )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_statusch_service_p_f_profiles
    FOREIGN KEY (profile_id )
    REFERENCES profile (id )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)
ENGINE = InnoDB;

CREATE  TABLE IF NOT EXISTS tested_services_fqan (
  id INT NOT NULL AUTO_INCREMENT,
  service_id INT NOT NULL,
  profile_id INT NOT NULL,
  fqan_id INT NULL,
  last_insert_time INT NOT NULL,
  PRIMARY KEY (id),
  INDEX fk_tested_services_fqan_service (service_id ASC),
  INDEX fk_tested_services_fqan_profile (profile_id ASC),
  INDEX fk_tested_services_fqan_fqan (fqan_id ASC),
  INDEX tested_services_time (last_insert_time ASC),

  CONSTRAINT uk_tested_services_fqan
    UNIQUE KEY (service_id, profile_id, fqan_id),
  CONSTRAINT fk_tested_services_fqan_service
    FOREIGN KEY (service_id )
    REFERENCES service (id )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_tested_services_fqan_profile
    FOREIGN KEY (profile_id )
    REFERENCES profile (id )
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_tested_services_fqan_fqan
    FOREIGN KEY (fqan_id)
    REFERENCES fqan (id)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)

ENGINE = InnoDB;

DROP TABLE IF EXISTS fqans_in_supported_services;
CREATE TABLE IF NOT EXISTS fqans_in_supported_services (
  id INT(11) NOT NULL AUTO_INCREMENT,
  profile_id INT NOT NULL,
  service_id INT NOT NULL,
  fqan_id INT(11) NOT NULL,
  timestamp INT NOT NULL,
  updated TINYINT(1) NULL ,
  PRIMARY KEY (id) ,
  UNIQUE INDEX uk_fqan_in_supp_serv(profile_id ASC, service_id ASC, fqan_id ASC),
  CONSTRAINT fk_fqans_in_supp_serv_fqan
    FOREIGN KEY (fqan_id)
    REFERENCES fqan(id)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_fqans_in_supp_serv_profile
    FOREIGN KEY (profile_id)
    REFERENCES profile(id)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_fqans_in_supp_serv_service
    FOREIGN KEY (service_id)
    REFERENCES service(id)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)

ENGINE = InnoDB;

DROP TABLE IF EXISTS fqans_in_supp_serv_rejected;

CREATE  TABLE IF NOT EXISTS fqans_in_supp_serv_rejected (
  id INT(11) NOT NULL AUTO_INCREMENT ,
  service_type_flavour VARCHAR(256) NULL ,
  hostname VARCHAR(256) NULL ,
  fqan VARCHAR(256) NULL ,
  profile VARCHAR(256) NULL ,
  timestamp INT NULL,
  reason VARCHAR(256) NULL,
  PRIMARY KEY (id)
 )
ENGINE = InnoDB;

INSERT INTO metricstatus(id, description,
description_nagios, comments) VALUES (6, 'REMOVED', '', 'Service removed');

delete from metricdata_latest;

delete from metricdata_spool;

commit;
