USE `mrs`;

CREATE OR REPLACE VIEW statuschange_service_profile_l_maxtimestamp AS
SELECT i.service_id, i.profile_id, MAX(i.timestamp) as max_timestamp
FROM statuschange_service_profile i
GROUP BY i.service_id, i.profile_id;

CREATE OR REPLACE VIEW statuschange_service_profile_l AS
SELECT s.id, s.service_id, s.profile_id, s.metricstatus_id, s.detail, s.timestamp
FROM statuschange_service_profile s, statuschange_service_profile_l_maxtimestamp r
WHERE s.service_id = r.service_id AND s.profile_id = r.profile_id AND s.timestamp = r.max_timestamp;

CREATE OR REPLACE VIEW statuschange_serv_profile_fq_l_maxtimestamp AS
SELECT i.service_id, i.profile_id, i.fqan_id, MAX(i.timestamp) as max_timestamp
FROM statuschange_serv_profile_fqan i
GROUP BY i.service_id, i.profile_id, i.fqan_id;

CREATE OR REPLACE VIEW statuschange_serv_profile_fq_l AS
SELECT s.id, s.service_id, s.profile_id, s.fqan_id, s.metricstatus_id, s.timestamp
FROM statuschange_serv_profile_fqan s, statuschange_serv_profile_fq_l_maxtimestamp r
WHERE s.service_id = r.service_id AND s.profile_id = r.profile_id AND s.timestamp = r.max_timestamp
      and s.fqan_id = r.fqan_id;

alter table metrics_in_supported_services 
  add frequency INT;

alter table metrics_in_supp_serv_rejected
  add frequency INT;

DROP TABLE IF EXISTS fqans_in_supp_serv_history;
CREATE TABLE IF NOT EXISTS  fqans_in_supp_serv_history(
  id INT(11) NOT NULL AUTO_INCREMENT,
  profile_id INT NOT NULL,
  service_id INT NOT NULL,
  fqan_id INT(11) NOT NULL,
  operation ENUM ('insert', 'delete') NOT NULL,
  timestamp INT NOT NULL,
  PRIMARY KEY (id) ,
  UNIQUE INDEX uk_fqan_in_supp_serv_h(profile_id ASC, service_id ASC, fqan_id ASC, operation ASC, timestamp ASC),
  CONSTRAINT fk_fqans_in_supp_serv_h_fqan
    FOREIGN KEY (fqan_id)
    REFERENCES fqan(id)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_fqans_in_supp_serv_h_profile
    FOREIGN KEY (profile_id)
    REFERENCES profile(id)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION,
  CONSTRAINT fk_fqans_in_supp_serv_h_service
    FOREIGN KEY (service_id)
    REFERENCES service(id)
    ON DELETE NO ACTION
    ON UPDATE NO ACTION)

ENGINE = InnoDB;

alter table metricdetails
  add timestamp INT;

alter table metricdetails
  add INDEX metricdetails_timestamp (timestamp ASC);

CREATE TABLE mon_frequency_statistics (
  roc VARCHAR(200),
  flavour_id INT NOT NULL,
  metric_id INT NOT NULL,
  freq_mean INT NOT NULL,
  freq_std INT NOT NULL,
  UNIQUE INDEX uk_mon_frequency_statistics(roc ASC, flavour_id ASC, metric_id ASC)
) ENGINE = InnoDB;
