DELIMITER //

USE `mrs`;

DROP TRIGGER IF EXISTS ins_fqans_in_sup_services_fer;

CREATE TRIGGER ins_fqans_in_sup_services_fer

AFTER INSERT ON fqans_in_supported_services FOR EACH ROW

BEGIN
  insert into fqans_in_supp_serv_history (profile_id, service_id, fqan_id, timestamp, operation)
  values(NEW.profile_id, NEW.service_id, NEW.fqan_id, unix_timestamp(), 'insert');
END //


DROP TRIGGER IF EXISTS del_fqans_in_sup_services_fer;

CREATE TRIGGER del_fqans_in_sup_services_fer

AFTER DELETE ON fqans_in_supported_services FOR EACH ROW

BEGIN

  insert into fqans_in_supp_serv_history (profile_id, service_id, fqan_id, timestamp, operation)
  values(OLD.profile_id, OLD.service_id, OLD.fqan_id, unix_timestamp(), 'delete');

END //

DROP TRIGGER IF EXISTS del_metrics_in_sup_services_fer;

CREATE TRIGGER del_metrics_in_sup_services_fer

AFTER DELETE ON metrics_in_supported_services FOR EACH ROW

BEGIN

  insert into metrics_in_supp_serv_history (service_id, metric_id, vo_id, fqan_id, profile_id, timestamp, operation)
  values(OLD.service_id, OLD.metric_id, OLD.vo_id, OLD.fqan_id, OLD.profile_id, unix_timestamp(), 'delete');

END //

DROP TRIGGER IF EXISTS ins_metricdetails_fer;

CREATE TRIGGER ins_metricdetails_fer 

BEFORE INSERT ON metricdetails FOR EACH ROW

BEGIN

  SET NEW.timestamp = unix_timestamp();

END //

DELIMITER ;
