BEGIN

  DBMS_SCHEDULER.drop_job (job_name => 'SAM_MS_INSERTMISSINGMETRICS');

  DBMS_SCHEDULER.drop_job (job_name => 'SAM_MS_LoadData');

  DBMS_SCHEDULER.create_job (
    job_name        => 'SAM_MS_LoadData',
    job_type        => 'PLSQL_BLOCK',
    job_action      => 'BEGIN dataloader.loadmetricdata(24, 10); END;',
    start_date      => SYSTIMESTAMP,
    repeat_interval => 'freq=minutely; interval=3; bysecond=1',
    end_date        => NULL,
    enabled         => TRUE,
    comments        => 'SAM - Load Data');

  DBMS_SCHEDULER.drop_job (job_name => 'SAM_MS_CALCULATESTATISTICS');

  DBMS_SCHEDULER.create_job (
    job_name        => 'SAM_MS_CALCULATESTATISTICS',
    job_type        => 'STORED_PROCEDURE',
    job_action      => 'CALCMETRICFREQ',
    start_date      => SYSTIMESTAMP,
    repeat_interval => 'freq=weekly; interval=1; bysecond=1',
    end_date        => NULL,
    enabled         => TRUE,
    comments        => 'Calculate metric frequency statistics for past two weeks');


END;
/
