/* BEGIN: Temporary hack to make msg-consume2oracle working */

ALTER TABLE T_METRICOUTPUT
  ADD GATHEREDAT VARCHAR2(256);

ALTER TABLE T_METRICOUTPUT
  ADD VOFQAN VARCHAR2(256);
  
create or replace view v_metricoutput as select * from t_metricoutput;

/* END: Temporary hack to make msg-consume2oracle working */


CREATE TABLE gatheredat
(
  id INT NOT NULL,
  name VARCHAR2(256),
  PRIMARY KEY (id)
);

CREATE SEQUENCE gatheredat_seq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

/*Stop consumers to Central MRS, wait 10 minutes till all data is consumed from metricdata_spool
and than run the upgrade script */
ALTER TABLE metricdata
  add gatheredat_id INT;

ALTER TABLE metricdata 
  ADD CONSTRAINT fk_metricdata_gatheredat_id
    FOREIGN KEY (gatheredat_id)
    REFERENCES gatheredat (id);

ALTER TABLE metricdata_latest
  add gatheredat_id INT;

ALTER TABLE metricdata_latest 
  ADD CONSTRAINT fk_metricdata_l_gatheredat_id
    FOREIGN KEY (gatheredat_id)
    REFERENCES gatheredat (id);


ALTER TABLE metricdata_spool
 add gatheredat_id INT;
ALTER TABLE metricdata_spool
 add metricstatus_id INT NOT NULL;
ALTER TABLE metricdata_spool
 add metric_id INT NOT NULL;
ALTER TABLE metricdata_spool
 add service_id INT NOT NULL;
ALTER TABLE metricdata_spool
 add vo_id INT;
ALTER TABLE metricdata_spool
  add fqan_id INT;
  
ALTER TABLE metricdata_spool
  ADD CONSTRAINT fk_metricdata_spool_fqan_id
    FOREIGN KEY (fqan_id)
    REFERENCES fqan (id);
             
ALTER TABLE metricdata_spool
  ADD CONSTRAINT fk_metricdata_sp_gatheredat_id
    FOREIGN KEY (gatheredat_id)
    REFERENCES gatheredat(id);
ALTER TABLE metricdata_spool
  ADD CONSTRAINT fk_metricdata_sp_metrics
    FOREIGN KEY (metric_id)
    REFERENCES metric(id);
ALTER TABLE metricdata_spool
  ADD CONSTRAINT fk_metricdata_sp_nodes
    FOREIGN KEY (service_id)
    REFERENCES service(id);
ALTER TABLE metricdata_spool
  ADD CONSTRAINT fk_metricdata_sp_vos
    FOREIGN KEY (vo_id)
    REFERENCES vo(id);
ALTER TABLE metricdata_spool
  ADD CONSTRAINT fk_metricdata_sp_metricstatus
    FOREIGN KEY (metricstatus_id)
    REFERENCES metricstatus (id);

ALTER TABLE metricdata_spool
  DROP COLUMN serviceflavour;

ALTER TABLE metricdata_spool
  DROP COLUMN metricname;

ALTER TABLE metricdata_spool
  DROP COLUMN metricstatus;

ALTER TABLE metricdata_spool
  DROP COLUMN voname;

ALTER TABLE metricdata_spool
  DROP COLUMN hostname;
  
ALTER TABLE metricdata_spool
  DROP COLUMN serviceuri;  

ALTER TABLE METRICSTATUS drop column "comment";

ALTER TABLE statuschangerecalculated ADD CONSTRAINT
  fk_statchangerec_stat_ch_prof
    FOREIGN KEY (statuschange_service_id)
    REFERENCES statuschange_service_profile (id);

CREATE TABLE fqan (
  id INT NOT NULL,
  name VARCHAR(256) NOT NULL,
  PRIMARY KEY (id),
  CONSTRAINT uk_fqan UNIQUE (name)
);

CREATE SEQUENCE fqan_seq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE TABLE metrics_in_supported_services (
  id INT NOT NULL,
  service_id INT NOT NULL,
  metric_id INT NOT NULL,
  vo_id INT NULL,
  fqan_id INT NULL,
  profile_id INT NOT NULL,
  frequency INT NOT NULL,
  timestamp INT NULL,
  updated INT NULL,
  PRIMARY KEY (id),
  CONSTRAINT uk_supported_services UNIQUE(service_id, metric_id, vo_id, fqan_id, profile_id), 
  CONSTRAINT fk_metrics_in_supp_service
    FOREIGN KEY (service_id)
    REFERENCES service (id),
  CONSTRAINT fk_metrics_in_supp_metric
    FOREIGN KEY (metric_id)
    REFERENCES metric (id),
  CONSTRAINT fk_metrics_in_supp_vo
    FOREIGN KEY (vo_id)
    REFERENCES vo (id),
  CONSTRAINT fk_metrics_in_supp_fqan
    FOREIGN KEY (fqan_id)
    REFERENCES fqan (id),
  CONSTRAINT fk_metrics_in_supp_profile
    FOREIGN KEY (profile_id)
    REFERENCES profile (id)
);

CREATE SEQUENCE metrics_in_supp_services_seq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE TABLE metrics_in_supp_serv_history (
  id INT NOT NULL,
  service_id INT NOT NULL,
  metric_id INT NOT NULL,
  vo_id INT NULL,
  fqan_id INT NULL,
  profile_id INT NOT NULL,
  operation VARCHAR2(10) NOT NULL,
  timestamp INT NULL,
  PRIMARY KEY (id),
  CONSTRAINT uk_supported_services_hists UNIQUE(service_id, metric_id, vo_id, fqan_id, profile_id, operation, timestamp ),
  CONSTRAINT operation_chk CHECK( operation IN ('insert', 'delete') ),
  CONSTRAINT fk_metrics_in_supp_h_service
    FOREIGN KEY (service_id)
    REFERENCES service (id),
  CONSTRAINT fk_metrics_in_supp_h_metric
    FOREIGN KEY (metric_id)
    REFERENCES metric (id),
  CONSTRAINT fk_metrics_in_supp_h_vo
    FOREIGN KEY (vo_id)
    REFERENCES vo (id),
  CONSTRAINT fk_metrics_in_supp_h_fqan
    FOREIGN KEY (fqan_id)
    REFERENCES fqan (id),
  CONSTRAINT fk_metrics_in_supp_h_profile
    FOREIGN KEY (profile_id)
    REFERENCES profile (id)
);

CREATE SEQUENCE metrics_in_supp_serv_his_seq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE TABLE metrics_in_supp_serv_rejected (
  id INT NOT NULL,
  service_type_flavour VARCHAR2(256) NULL,
  hostname VARCHAR2(256) NULL,
  metric_name VARCHAR2(256) NULL,
  vo VARCHAR2(256) NULL,
  fqan VARCHAR2(256) NULL,
  profile VARCHAR2(256) NULL,
  frequency INT NULL,
  timestamp INT NULL,
  reason VARCHAR(256) NULL,
  PRIMARY KEY (id)
 );
 
CREATE SEQUENCE metrics_in_supp_serv_rej_seq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE; 
 
ALTER TABLE metricdata
  add fqan_id INT;

ALTER TABLE metricdata 
  ADD CONSTRAINT fk_metricdata_fqan_id
    FOREIGN KEY (fqan_id)
    REFERENCES fqan (id);

ALTER TABLE metricdata_latest
  add fqan_id INT;

ALTER TABLE metricdata_latest
  ADD CONSTRAINT fk_metricdata_latest_fqan_id
    FOREIGN KEY (fqan_id)
    REFERENCES fqan (id);

ALTER TABLE metricdata_spool_rejected
  add fqan_id INT;

ALTER TABLE metricdata_spool_rejected
  ADD CONSTRAINT fk_metricdata_spool_r_fqan_id
    FOREIGN KEY (fqan_id)
    REFERENCES fqan (id);

ALTER TABLE metricdata_rejected
  add fqan VARCHAR2(256);
  
ALTER TABLE metricdata_rejected
  add gatheredat VARCHAR2(256);  

ALTER TABLE metricdata_rejected
  add service VARCHAR2(256);
  
ALTER TABLE statuschange_service_profile
  add fqan_id INT;

ALTER TABLE statuschange_service_profile
  ADD CONSTRAINT fk_stch_serv_profile_fqan_id 
    FOREIGN KEY (fqan_id)
    REFERENCES fqan (id);

CREATE TABLE statuschange_metric_service (
  id INT NOT NULL,
  metric_id INT NOT NULL,
  service_id INT NOT NULL,
  vo_id INT NULL,
  metricstatus_id INT NOT NULL,
  timestamp INT NOT NULL,
  PRIMARY KEY (id),
  CONSTRAINT uk_statuschange_metric_service UNIQUE (service_id, metric_id, vo_id, timestamp),
  CONSTRAINT fk_statuschg_metric_s_metrics
    FOREIGN KEY (metric_id )
    REFERENCES metric (id ),
  CONSTRAINT fk_statuschg_metric_s_metricst
    FOREIGN KEY (metricstatus_id )
    REFERENCES metricstatus (id ),
  CONSTRAINT fk_statuschange_metric_s_serv
    FOREIGN KEY (service_id )
    REFERENCES service (id ),
  CONSTRAINT fk_statuschange_metric_s_vos
    FOREIGN KEY (vo_id)
    REFERENCES vo (id)
);

CREATE SEQUENCE statuschange_metric_s_seq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE TABLE statuschange_metric_serv_fqan (
  id INT NOT NULL,
  fqan_id INT NULL,
  metric_id INT NOT NULL,
  service_id INT NOT NULL,
  vo_id INT NULL,
  metricstatus_id INT NOT NULL,
  timestamp INT NOT NULL,
  PRIMARY KEY (id),
  CONSTRAINT uk_statuschange_m_serv_fqan UNIQUE (service_id, metric_id, fqan_id, timestamp),
  CONSTRAINT fk_statuschange_m_s_fqan_fqan
    FOREIGN KEY (fqan_id)
    REFERENCES fqan (id),
  CONSTRAINT fk_statusch_m_s_fqan_metrics
    FOREIGN KEY (metric_id)
    REFERENCES metric (id),
  CONSTRAINT fk_statusch_m_s_fqan_metricst
    FOREIGN KEY (metricstatus_id)
    REFERENCES metricstatus (id),
  CONSTRAINT fk_statusch_m_s_fqan_services
    FOREIGN KEY (service_id)
    REFERENCES service (id),
  CONSTRAINT fk_statuschange_m_s_fqan_vos
    FOREIGN KEY (vo_id)
    REFERENCES vo (id)
);

CREATE SEQUENCE statuschange_metric_serv_f_seq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE TABLE statuschange_serv_profile_fqan (
  id INT NOT NULL,
  fqan_id INT NOT NULL,
  service_id INT NOT NULL,
  profile_id INT NOT NULL,
  metricstatus_id INT NOT NULL,
  timestamp INT NOT NULL,
  PRIMARY KEY (id),
  CONSTRAINT uk_statusch_service_p_frofile
    UNIQUE (fqan_id, service_id, profile_id, timestamp),
  CONSTRAINT fk_statusch_service_p_f_fqan
    FOREIGN KEY (fqan_id)
    REFERENCES fqan(id),
  CONSTRAINT fk_statusch_s_p_f_metricst
    FOREIGN KEY (metricstatus_id)
    REFERENCES metricstatus (id),
  CONSTRAINT fk_statusch_service_p_f_s
    FOREIGN KEY (service_id)
    REFERENCES service (id),
  CONSTRAINT fk_statusch_service_p_f_p
    FOREIGN KEY (profile_id)
    REFERENCES profile (id)
);

CREATE SEQUENCE statuschange_serv_pr_fqan_seq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE TABLE tested_services_fqan (
  id INT NOT NULL,
  service_id INT NOT NULL,
  profile_id INT NOT NULL,
  fqan_id INT NULL,
  last_insert_time INT NOT NULL,
  PRIMARY KEY (id),
  CONSTRAINT uk_tested_services_fqan
    UNIQUE (service_id, profile_id, fqan_id),
  CONSTRAINT fk_tested_services_fqan_s
    FOREIGN KEY (service_id)
    REFERENCES service (id),
  CONSTRAINT fk_tested_services_fqan_p
    FOREIGN KEY (profile_id)
    REFERENCES profile (id),
  CONSTRAINT fk_tested_services_fqan_f
    FOREIGN KEY (fqan_id)
    REFERENCES fqan (id)
);

CREATE SEQUENCE tested_services_fqan_seq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE TABLE fqans_in_supported_services (
  id INT NOT NULL,
  profile_id INT NOT NULL,
  service_id INT NOT NULL,
  fqan_id INT NOT NULL,
  timestamp INT NOT NULL,
  updated INT NULL ,
  PRIMARY KEY (id) ,
  CONSTRAINT uk_fqan_in_supp_serv UNIQUE (profile_id, service_id, fqan_id),
  CONSTRAINT fk_fqans_in_supp_serv_fqan
    FOREIGN KEY (fqan_id)
    REFERENCES fqan(id),
  CONSTRAINT fk_fqans_in_supp_serv_profile
    FOREIGN KEY (profile_id)
    REFERENCES profile(id),
  CONSTRAINT fk_fqans_in_supp_serv_service
    FOREIGN KEY (service_id)
    REFERENCES service(id)
);

CREATE SEQUENCE fqans_in_supported_s_seq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE TABLE fqans_in_supp_serv_rejected (
  id INT NOT NULL ,
  service_type_flavour VARCHAR2(256) NULL ,
  hostname VARCHAR2(256) NULL ,
  fqan VARCHAR2(256) NULL ,
  profile VARCHAR2(256) NULL ,
  timestamp INT NULL,
  reason VARCHAR2(256) NULL,
  PRIMARY KEY (id)
);

CREATE SEQUENCE fqans_in_supp_serv_r_seq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE TABLE supported_profiles (
  id INT NOT NULL,
  name VARCHAR2(256) NOT NULL,
  insert_time INT NOT NULL ,
  PRIMARY KEY (id),
  CONSTRAINT uk_supported_profiles
    UNIQUE (name)
);

CREATE SEQUENCE supported_profiles_seq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;
  
drop table METRICDATA_SPOOL_REJECTED;
create table metricdata_spool_rejected as
select * from metricdata_spool where rownum < 0;

DROP TABLE METRICDATAFORRECALCULATION;

CREATE TABLE METRICDATAFORRECALCULATION (
  id INT NOT NULL,
  metricdata_spool_id INT NOT NULL,
  gatheredat_id INT,
  metricstatus_id INT NOT NULL,
  detailsdata CLOB,
  metric_id INT NOT NULL,
  service_id INT NOT NULL,
  fqan_id INT,
  vo_id INT,
  summarydata VARCHAR2(256) NULL,
  check_time INT NOT NULL,
  insert_time INT NOT NULL,
  PRIMARY KEY (id),
  CONSTRAINT fk_metricdata_r_gatheredat_id
    FOREIGN KEY (gatheredat_id)
    REFERENCES gatheredat(id),
  CONSTRAINT fk_metricdata_r_metrics
    FOREIGN KEY (metric_id)
    REFERENCES metric(id),
  CONSTRAINT fk_metricdata_r_nodes
    FOREIGN KEY (service_id)
    REFERENCES service(id),
  CONSTRAINT fk_metricdata_r_vos
    FOREIGN KEY (vo_id)
    REFERENCES vo(id),
  CONSTRAINT fk_metricdata_r_fqan
    FOREIGN KEY (fqan_id)
    REFERENCES fqan(id),
  CONSTRAINT fk_metricdata_r_metricstatus
    FOREIGN KEY (metricstatus_id)
    REFERENCES metricstatus (id)
);

drop table METRICDATAFORRECALC_REJECTED;
create table METRICDATAFORRECALC_REJECTED as
select * from METRICDATAFORRECALCULATION where rownum < 0;

insert into supported_profiles(id, name, insert_time)
values(supported_profiles_seq.nextval, 'ROC', to_unixts(current_timestamp));

insert into supported_profiles(id, name, insert_time)
values(supported_profiles_seq.nextval, 'ROC_CRITICAL', to_unixts(current_timestamp));

insert into supported_profiles(id, name, insert_time)
values(supported_profiles_seq.nextval, 'ROC_OPERATORS', to_unixts(current_timestamp));
                  
INSERT INTO metricstatus(id, description, description_nagios, comments)
VALUES (6, 'REMOVED', '', 'Service removed');

COMMIT;

CREATE TABLE T_METRICOUTPUT_OSG
(
  SERVICETYPE VARCHAR2(256),
  METRICNAME NVARCHAR2(256),
  METRICSTATUS VARCHAR2(45),
  SUMMARYDATA VARCHAR2(256),
  PERFORMANCEDATA VARCHAR2(256),
  DETAILSDATA CLOB,
  VONAME VARCHAR2(256),
  SERVICEURI VARCHAR2(256),
  "TIMESTAMP" VARCHAR2(256)
);

CREATE VIEW V_METRICOUTPUT_OSG AS SELECT * FROM T_METRICOUTPUT_OSG;

CREATE OR REPLACE VIEW statuschange_service_profile_l AS
SELECT s.id, s.service_id, s.profile_id, s.metricstatus_id, s.detail, s.timestamp
FROM statuschange_service_profile s, (
    SELECT i.service_id, i.profile_id, MAX(i.timestamp) as max_timestamp
    FROM statuschange_service_profile i
    GROUP BY i.service_id, i.profile_id
    ) r
WHERE s.service_id = r.service_id AND s.profile_id = r.profile_id AND s.timestamp = r.max_timestamp;

CREATE OR REPLACE VIEW statuschange_serv_profile_fq_l AS
SELECT s.id, s.service_id, s.profile_id, s.fqan_id, s.metricstatus_id, s.timestamp
FROM statuschange_serv_profile_fqan s, (
    SELECT i.service_id, i.profile_id, i.fqan_id, MAX(i.timestamp) as max_timestamp
    FROM statuschange_serv_profile_fqan i
    GROUP BY i.service_id, i.profile_id, i.fqan_id
    ) r
WHERE s.service_id = r.service_id AND s.profile_id = r.profile_id AND s.timestamp = r.max_timestamp
      AND s.fqan_id = r.fqan_id;

alter table metrics_in_supported_services 
  add frequency INT;

alter table metrics_in_supp_serv_rejected
  add frequency INT;

CREATE TABLE mon_frequency_statistics (
  roc VARCHAR2(256),
  flavour_id INT NOT NULL,
  metric_id INT NOT NULL,
  freq_mean INT NOT NULL,
  freq_std INT NOT NULL
);
/

CREATE INDEX uk_mon_frequency_statistics ON mon_frequency_statistics(roc ASC, flavour_id ASC, metric_id ASC);
/

CREATE OR REPLACE TYPE freq_rec AS OBJECT (
  roc VARCHAR2(256),
  flavour_id NUMBER,
  metric_id NUMBER,
  freq NUMBER
);
/

CREATE OR REPLACE TYPE freq_table AS TABLE OF freq_rec;

CREATE GLOBAL TEMPORARY TABLE tmpJoinProfile (
  name VARCHAR2(256), 
  metric_id NUMBER, 
  service_type_flavour_id NUMBER
) ON COMMIT DELETE ROWS;

CREATE GLOBAL TEMPORARY TABLE tmpFilteredMetrics (
  NGI VARCHAR2(256),
  flavour_name VARCHAR2(256),
  metric_name VARCHAR2(256),
  fqan_name VARCHAR2(256),
  counter NUMBER
) ON COMMIT PRESERVE ROWS;

CREATE GLOBAL TEMPORARY TABLE tmpMetricsCount (
  NGI VARCHAR2(256),
  flavour_name VARCHAR2(256),
  metric_name VARCHAR2(256),
  fqan_name VARCHAR2(256),
  counter NUMBER
) ON COMMIT PRESERVE ROWS;

CREATE GLOBAL TEMPORARY TABLE tmpFreshMetrics (
  NGI VARCHAR2(256),
  flavour_name VARCHAR2(256),
  metric_name VARCHAR2(256),
  fqan_name VARCHAR2(256),
  received NUMBER,
  total NUMBER,
  percentage NUMBER
) ON COMMIT PRESERVE ROWS;


-- for LCG_SAM_MS_PILOT_W you have to do the following:
GRANT EXECUTE ON getFreshMetrics TO LCG_SAM_MS_PILOT_W;
GRANT SELECT ON tmpFreshMetrics TO LCG_SAM_MS_PILOT_W;

-- the following has to be done as LCG_SAM_MS_PILOT_W in LCG_SAM_MS_PILOT_W:
SYNONYM getFreshMetrics FOR LCG_SAM_MS_PILOT.getFreshMetrics;
SYNONYM tmpFreshMetrics FOR LCG_SAM_MS_PILOT.tmpFreshMetrics;
