/*https://tomtools.cern.ch/jira/browse/SAM-994*/

DROP INDEX METRICDATA_CHECK_TIME_IDX;
CREATE INDEX metricdata_checktime_local_idx ON metricdata (check_time) LOCAL;

ALTER TABLE statuschange_service_profile
  ADD insert_time INT;
  
ALTER TABLE STATUSCHANGE_SERV_PROFILE_FQAN
  ADD insert_time INT;  

ALTER TABLE STATUSCHANGE_METRIC_SERVICE
  ADD insert_time INT;
  
ALTER TABLE STATUSCHANGE_METRIC_SERV_FQAN
  ADD insert_time INT;  
  
--OSG - won't go to MySQL

CREATE TABLE metricdata_rejected_osg (
  id INT NOT NULL,
  service VARCHAR2(256),
  metricstatus VARCHAR(25),
  metric VARCHAR(256),
  serviceURI VARCHAR(256),
  hostname VARCHAR(256),
  service_flavour VARCHAR(256),
  vo VARCHAR(256),
  fqan VARCHAR2(256),
  summarydata CLOB NULL,
  gatheredat VARCHAR2(256),
  check_time INT NOT NULL ,
  insert_time INT NOT NULL ,
  reason VARCHAR(256),
  PRIMARY KEY (id))
  PARTITION BY RANGE (check_time) (
    PARTITION METRICDATA_R_OSG_08_2010 VALUES LESS THAN (1283299200),
    PARTITION METRICDATA_R_OSG_09_2010 VALUES LESS THAN (1285891200),
    PARTITION METRICDATA_R_OSG_10_2010 VALUES LESS THAN (1288569600),
    PARTITION METRICDATA_R_OSG_11_2010 VALUES LESS THAN (1291161600),
    PARTITION METRICDATA_R_OSG_12_2010 VALUES LESS THAN (1293840000),
    PARTITION METRICDATA_R_OSG_01_2011 VALUES LESS THAN (1296518400),
    PARTITION METRICDATA_R_OSG_02_2011 VALUES LESS THAN (1298937600),
    PARTITION METRICDATA_R_OSG_03_2011 VALUES LESS THAN (1301616000),
    PARTITION METRICDATA_R_OSG_04_2011 VALUES LESS THAN (1304208000),
    PARTITION METRICDATA_R_OSG_05_2011 VALUES LESS THAN (1306886400),
    PARTITION METRICDATA_R_OSG_06_2011 VALUES LESS THAN (1309478400),
    PARTITION METRICDATA_R_OSG_07_2011 VALUES LESS THAN (1312156800),
    PARTITION METRICDATA_R_OSG_08_2011 VALUES LESS THAN (1314835200),
    PARTITION METRICDATA_R_OSG_09_2011 VALUES LESS THAN (1317427200),
    PARTITION METRICDATA_R_OSG_10_2011 VALUES LESS THAN (1320105600),
    PARTITION METRICDATA_R_OSG_11_2011 VALUES LESS THAN (1322697600),
    PARTITION METRICDATA_R_OSG_12_2011 VALUES LESS THAN (1325376000),
    PARTITION METRICDATA_R_OSG_01_2012 VALUES LESS THAN (1328054400),
    PARTITION METRICDATA_R_OSG_02_2012 VALUES LESS THAN (1330560000),
    PARTITION METRICDATA_R_OSG_03_2012 VALUES LESS THAN (1333238400),
    PARTITION METRICDATA_R_OSG_04_2012 VALUES LESS THAN (1335830400),
    PARTITION METRICDATA_R_OSG_05_2012 VALUES LESS THAN (1338508800),
    PARTITION METRICDATA_R_OSG_06_2012 VALUES LESS THAN (1341100800),
    PARTITION METRICDATA_R_OSG_07_2012 VALUES LESS THAN (1343779200),
    PARTITION METRICDATA_R_OSG_08_2012 VALUES LESS THAN (1346457600),
    PARTITION METRICDATA_R_OSG_09_2012 VALUES LESS THAN (1349049600),
    PARTITION METRICDATA_R_OSG_10_2012 VALUES LESS THAN (1351728000),
    PARTITION METRICDATA_R_OSG_11_2012 VALUES LESS THAN (1354320000),
    PARTITION METRICDATA_R_OSG_12_2012 VALUES LESS THAN (1356998400),
    PARTITION METRICDATA_R_OSG_01_2013 VALUES LESS THAN (1359676800),
    PARTITION METRICDATA_R_OSG_02_2013 VALUES LESS THAN (1362096000),
    PARTITION METRICDATA_R_OSG_03_2013 VALUES LESS THAN (1364774400),
    PARTITION METRICDATA_R_OSG_04_2013 VALUES LESS THAN (1367366400),
    PARTITION METRICDATA_R_OSG_05_2013 VALUES LESS THAN (1370044800),
    PARTITION METRICDATA_R_OSG_06_2013 VALUES LESS THAN (1372636800),
    PARTITION METRICDATA_R_OSG_07_2013 VALUES LESS THAN (1375315200),
    PARTITION METRICDATA_R_OSG_08_2013 VALUES LESS THAN (1377993600),
    PARTITION METRICDATA_R_OSG_09_2013 VALUES LESS THAN (1380585600),
    PARTITION METRICDATA_R_OSG_10_2013 VALUES LESS THAN (1383264000),
    PARTITION METRICDATA_R_OSG_11_2013 VALUES LESS THAN (1385856000),
    PARTITION METRICDATA_R_OSG_12_2013 VALUES LESS THAN (1388534400)
);

CREATE SEQUENCE MetricData_RejectedOSGSeq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE TABLE METRICGROUP_OSG
(
  ID INT NOT NULL,
  FLAVOUR_ID INT NOT NULL,
  SERVICETYPE VARCHAR2(256) NOT NULL,
  PRIMARY KEY (id),
  CONSTRAINT METRICGROUP_UK UNIQUE (FLAVOUR_ID, SERVICETYPE),
  CONSTRAINT METRICGROUP_OSG_FLAVOUR_FK FOREIGN KEY (FLAVOUR_ID)
    REFERENCES SERVICE_TYPE_FLAVOUR (ID)
);

CREATE SEQUENCE METRICGROUP_OSGSeq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE TABLE METRICDESCRIPTION_OSG
(
  ID INT NOT NULL,
  SERVICETYPE VARCHAR2(256) NOT NULL,
  METRICNAME VARCHAR2(256) NOT NULL,
  METRIC_ID INT NOT NULL,
  PRIMARY KEY (id),
  CONSTRAINT METRIDESC_OSG_UK UNIQUE (METRIC_ID, SERVICETYPE),
  CONSTRAINT METRIDESC_OSG_FLAVOUR_FK FOREIGN KEY (METRIC_ID)
    REFERENCES METRIC (ID)
);

CREATE SEQUENCE METRICDESCRIPTION_OSGSeq
  START WITH 1
  INCREMENT BY 1
  NOCACHE
  NOCYCLE;

CREATE OR REPLACE FORCE VIEW V_METRICDESCRIPTION_OSG (SERVICETYPE, METRICNAME, METRICTITLE, METRICHELP) AS
 select distinct m.servicetype, m.metricname, t.description metrictitle, to_char(t.docurl) metrichelp
   from metricdescription_osg m, metric t
   where m.metric_id=t.id;

ALTER TABLE T_METRICOUTPUT_OSG
  ADD GATHEREDAT VARCHAR2(256);

create or replace view v_metricoutput_osg as select * from t_metricoutput_osg;

