CREATE OR REPLACE TRIGGER V_MOUT_OSG_INSERT_TRG instead of insert on V_METRICOUTPUT_OSG

BEGIN
  DataLoader.loadmetricdatatospool_OSG(:NEW.serviceuri, :NEW.servicetype, :NEW.metricname, :NEW.metricstatus,
       :NEW.summarydata, :NEW.detailsdata, :NEW.voname, :NEW.timestamp, :NEW.gatheredat);
 
END;
/

CREATE OR REPLACE TRIGGER V_MDESC_INSERT_TRG 
 instead of insert on V_METRICDESCRIPTION_OSG
declare
  tid number;
  tname varchar(100);
  stype varchar(100);
begin
  stype:=lower(:new.servicetype);
  for svc in (select f.id, f.flavourname
               from metricgroup_osg m, service_type_flavour f
               where m.flavour_id = f.id and m.SERVICETYPE=stype)
  loop
    tname:=:new.metricname;
    begin
      select id into tid
      from metric
      where name=tname;
      update metric
      set description=:new.metrictitle,
        docurl=:new.metrichelp
      where id=tid;
      insert into metricdescription_osg (id, servicetype, metricname, metric_id)
      values (METRICDESCRIPTION_OSGSeq.nextval, stype, :new.metricname, tid);
    exception
      when no_data_found then
        --SAME_DB_MONITORING.send_mail_to_list('SAM_DB_Monit@no.reply', 'Wojciech.Lapka@cern.ch,David.Collados@cern.ch', 'SAM Prod: metric result rejected at DB insertion', 'ERROR: serviceType ' || lower(:new.servicetype) || '  not defined in metricgroup table?');
        select metric_SEQ.nextval into tid from dual;
        
        insert into metric (id, name, version, creator_id, description, docurl, isdeleted)
        values (tid, tname, '1.0.0', 2 /*Vaibhav - see MDDB_USER*/, :new.metrictitle, :new.metrichelp, 0);
        
        insert into metricdescription_osg (id, servicetype, metricname, metric_id)
        values (METRICDESCRIPTION_OSGSeq.nextval, stype, :new.metricname, tid);
        
      when dup_val_on_index then
        update metricdescription_osg
        set metricname=:new.metricname
        where servicetype=stype and metricname=:new.metricname and metric_id=tid;
    end;
  end loop;
end;
/
