USE `mrs`;

CREATE TABLE metricstore_curr_load_h
(
	id INT
		NOT NULL 
		AUTO_INCREMENT,
	rec_date VARCHAR(20)
		NOT NULL,
    hour NUMERIC(2,0)
    	NOT NULL,
    timestamp TIMESTAMP
    	NOT NULL,
    number_of_records INT
    	NOT NULL,
	CONSTRAINT metricstore_curr_load_h_pk
    	PRIMARY KEY (id),
    CONSTRAINT metricstore_curr_load_h_chk1
    	CHECK (hour >= 0 AND hour <= 23
  			AND number_of_records >= 0),
    CONSTRAINT metricstore_curr_load_h_uk1
    	UNIQUE (rec_date, hour)
) ENGINE=InnoDB;


CREATE TABLE metricstore_curr_load_m
(
	id INT
		NOT NULL
		AUTO_INCREMENT,
    timestamp TIMESTAMP
    	NOT NULL,
    hour NUMERIC(2,0) 
    	NOT NULL,
    minute NUMERIC(2,0)  
    	NOT NULL,
    number_of_records INT 
    	NOT NULL,
    CONSTRAINT metricstore_curr_load_m_pk
    	PRIMARY KEY (id),
    CONSTRAINT metricstore_curr_load_m_uk1
    UNIQUE (hour, minute),
    CONSTRAINT metricstore_curr_load_m_chk1
    	CHECK (hour >= 0 AND hour <= 23 
    		AND minute >= 0 AND minute <= 59 
    		AND minute >= 0)
) ENGINE=InnoDB;


CREATE TABLE metricstore_curr_load_h_det
  (
    id INT
    	NOT NULL
		AUTO_INCREMENT,
    rec_date VARCHAR(20)
    	NOT NULL,
    hour NUMERIC(2,0) 
    	NOT NULL,
    timestamp TIMESTAMP
    	NOT NULL,
    ngi_name VARCHAR(20),
    profile_id INT,
    flavour_id INT 
    	NOT NULL,
    number_of_records INT,
    CONSTRAINT metricstore_curr_load_h_d_chk1 
    	CHECK (hour >= 0 AND hour <= 23
  			AND number_of_records >= 0),
    CONSTRAINT metricstore_curr_load_h_d_pk 
    	PRIMARY KEY (id),
    CONSTRAINT metricstore_curr_load_h_d_uk1 
    	UNIQUE (rec_date, hour, ngi_name, profile_id, flavour_id),
    INDEX metricstore_curr_load_h_d_fk1 (profile_id ASC),
    CONSTRAINT metricstore_curr_load_h_d_fk1
    	FOREIGN KEY (profile_id) 
    	REFERENCES profile (id)
    	ON DELETE NO ACTION
    	ON UPDATE NO ACTION,
    INDEX metricstore_curr_load_h_d_fk2 (flavour_id ASC),
    CONSTRAINT metricstore_curr_load_h_d_fk2
    	FOREIGN KEY (flavour_id) 
    	REFERENCES service_type_flavour (id)
    	ON DELETE NO ACTION
    	ON UPDATE NO ACTION
) ENGINE=InnoDB;
